<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: Configuration directives for common aMember installation
*    FileName $RCSfile: config.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.40 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*/

$notebook_page = 'Global';
config_set_notebook_comment($notebook_page, 'main configuration directives');
config_set_notebook_comment('Plugins', 'configure list of enabled plugins');
if (!function_exists('is_trial') || !is_trial())
    config_set_notebook_comment('License', 'aMember License Code');
config_set_notebook_comment('E-Mail', 'E-Mail configuration');
config_set_notebook_comment('Colors', 'colors and fonts configuration');
config_set_notebook_comment('Advanced', 'advanced configuration');
config_set_notebook_comment('Ban', 'ban customers by email, IP and username');
if ($config['use_tax'])
    config_set_notebook_comment('Tax Settings', 'tax settings');

add_config_field('root_url', 'Root URL',
    'text', 'root script URL, usually <i>http://example.com/amember</i>',
    $notebook_page, 
    'validate_root_url', '', '',
    array('size' => 40));
add_config_field('root_surl', 'Secure Root URL',
    'text', 'secure script URL, usually <i>https://example.com/amember</i>',
    $notebook_page, 
    'validate_root_url', '','',
    array('size' => 40));

add_config_field('admin_email', 'Admin Email',
    'text', "will be used to send email notifications to admin<br>as well as From: address emails to user",
    'E-Mail', 
    'validate_email');
add_config_field('admin_login', 'Admin Username',
    'text', "",
    $notebook_page);
add_config_field('admin_pass', 'Admin Password',
    'password', "",
    $notebook_page, 
    'validate_password', '', '');
if (!extension_loaded("curl")){
    add_config_field('curl', 'cURL executable file location',
        'text', "you need it only if you are using payment processors<br>
        like Authorize.Net or PayFlow Pro<br>
        usually valid path is /usr/bin/curl or /usr/local/bin/curl",
        $notebook_page, 'validate_curl');
    function validate_curl($field, $vars){
        $fname = $field['name']; $val = $vars[$fname];
        if (!$val) return;
        exec("$val http://www.yahoo.com/ 2>&1", $out, $return);
        if ($return){
            return "Couldn't execute '$val http://www.yahoo.com/'. Exit code: $return";
        }
    }
}

    /*
add_config_field('tpl_cache_level', 'Template Cache Level',
    'select', '',
    $notebook_page,
    '','','',
    array(
        'options' => array(
            0 => '0 - Safe, no cache, no write',
            1 => '1 - Write compiled templates to single directory',
            2 => '2 - Effective, but cannot work on some hostings'
        )
    ));
    */
add_config_field('send_signup_mail',  'Send Signup E-Mail',
    'select', "send email to user when he completes<br>
    first subscription",
    'E-Mail',
    '','','',
    array(
        'options' => array(
            1 => 'Yes',
            0 => 'No'
        )
    ));
add_config_field('mail_expire',  'Enable Expire Notification',
    'select', "send email to user when his subscription expires<br>
    email will not be sent for products with recurring billing",
    'E-Mail',
    '','','',
    array(
        'options' => array(
            1 => 'Yes',
            0 => 'No'
        )
    ));
add_config_field('mail_expire_days', 'Expire Notification',
    'integer', "number of days when notification must be send. <br>
    <i>-1</i> means 1 day after expiration<br>
    <i>2</i> means 2 days before expiration",
    'E-Mail', 
    'validate_integer');

add_config_field('mail_not_completed',  'Enable "Not-Completed Payment" Notification',
    'select', "send email to user when his subscription is pending<br>
    and no completed subscriptions created for this customer yet",
    'E-Mail',
    '','','',
    array(
        'options' => array(
            '' => 'No',
            1 => 'Yes'
        )
    ));
add_config_field('mail_not_completed_days', '"Not-Completed Payment" Notification',
    'integer', "number of days when notification must be send. <br>
    <i>1</i> means 1 day after payment<br>
    <i>2</i> means 2 days after payment",
    'E-Mail', 
    'validate_integer');

add_config_field('send_payment_admin',  'Send Payment Notifications',
    'select', "send email to admin when subscription 
    completed",
    'E-Mail',
    '','','',
    array(
        'options' => array(
            0 => 'No',
            1 => 'Yes'
        )
    ));

add_config_field('send_cancel_admin',  'Send Cancel Notifications',
    'select', "send email to admin when recurring subscription<br> 
    cancelled by member. It works only for payment processors<br>
    which works like Authorize.Net or PayFlow Pro",
    'E-Mail',
    '','','',
    array(
        'options' => array(
            0 => 'No',
            1 => 'Yes'
        )
    ));
if (!is_lite()){
add_config_field('autoresponder', 'Send Automatic Emails',
    'textarea', "user can receive automatic emails after<br>
    signup. You can setup series of emails to be sent.<br>
    Format is :<br>
    <i>NUMBER_OF_DAYS - TEMPLATE_FILE_NAME</i>, like:<br>
    <i>1 - email1.txt<br>
       2 - email2.txt<br>
    </i>
    Email templates should be uploaded to amember/templates/ folder.
    ", 'E-Mail',
    '', '', '');
add_config_field('autoresponder_renew', 'Send Automatic Emails after Renewal',
    'select', "When user renews subscription, aMember can<br>
    resend days counter and start emails again from first one<br>
    or aMember can continue old mailing cycle.
    ", 'E-Mail',
    '', '', '',
    array('options' => array(
        ''  => 'Continue old mailing cycle',
        '1' => 'Reset days counter to zero, start new cycle'
    )));
}
$ignore_smtp = array('' => '*** use default ***');
if (ini_get('SMTP')) 
    $ignore_smtp[0] = 'SMTP';
if (ini_get('sendmail_path')) 
    $ignore_smtp[1] = 'SendMail';
$ignore_smtp_default = '';
if ($ignore_smtp[0] && preg_match('/^(Linux|FreeBSD|Solaris|Sparc|Unix)/i', php_uname())) 
    $ignore_smtp_default = 1;


add_config_field('ignore_smtp',  'Use SMTP/Sendmail',
    'select', "use SMTP or SendMail for sending e-mails",
    'E-Mail',
    '','','',
    array(
        'default' => $ignore_smtp_default,
        'options' => $ignore_smtp
    ));

if (!is_lite()){
$pp = array('ALL' => 'Use for all payments (not recommended)');
foreach (get_paysystems_list() as $p)
    $pp[$p['paysys_id']] = $p['title'];
add_config_field('send_pending_mail',  'Send Pending E-Mail',
    'multi_select', "send email to user when he does payment<br>
    in aMember (and it is not completed yet). It is suitable<br>
    for offline payment methods to keep reminder for customer<br>
    how to make payment.
     ",
    'E-Mail',
    '','','',
    array(
        'store_type' => 1,
        'options' => $pp
    ));

add_config_field('send_pending_mail_admin',  'Send Pending E-Mail to Admin',
    'multi_select', "send email to admin when visitor does payment<br>
    in aMember (and it is not completed yet). 
     ",
    'E-Mail',
    '','','',
    array(
        'store_type' => 1,
        'options' => $pp
    ));

}





####################################################################


if (!is_lite())
add_config_field('generate_login', 'Generate Login',
    'select', "should aMember generate username for customer?",
    $notebook_page, 
    '','','',
    array(
        'options' => array(
            0 => 'No',
            1 => 'Yes'
        )
    ));

add_config_field('login_min_length', 'Login minimum length',
    'integer', "",
    $notebook_page, 
    '','','',
    array(
        'default' => 5
    ));
add_config_field('login_max_length', 'Login maxmimum length',
    'integer', "",
    $notebook_page, 
    '','','',
    array(
        'default' => 8
    ));

if (!is_lite())
add_config_field('generate_pass', 'Generate Password',
    'select', "should aMember generate password for customer?",
    $notebook_page, 
    '','','',
    array(
        'options' => array(
            0 => 'No',
            1 => 'Yes'
        )
    ));
add_config_field('pass_min_length', 'Password minimum length',
    'integer', "",
    $notebook_page, 
    '','','',
    array(
        'default' => 6
    ));
add_config_field('pass_max_length', 'Password maxmimum length',
    'integer', "",
    $notebook_page, 
    '','','',
    array(
        'default' => 8
    ));

add_config_field('use_cron', 'Use External Cron',
    'select', "use external cron - recommended.<br>
    Add the following record to your crontab:<br>
    <code>1 * * * * /usr/bin/lynx -source 
    http://yoursite.com/amember/cron.php?pass=your_cron_pass</code><br>
    then set this option to Yes

    ",
    "Advanced", 
    '', '', '',    
    array(
        'options' => array(
            0 => 'No',
            1 => 'Yes'
        )
    ));
add_config_field('cron_pass', 'Cron Password',
    'password', "enter cron password to prevent visitors<br>
    to run your cron
    ",
    "Advanced", 
    '', '', '',    
    array(
    ));
add_config_field('clear_access_log', 'Clear Access Log',
    'select', "should aMember clear access log to save database space and speed?",
    "Advanced", 
    '','','',
    array(
        'options' => array(
            1 => 'Yes',
            0 => 'No'
        )
    ));


add_config_field('verify_email', 'Verfiy E-Mail Address On Signup',
    'select', "verify email address entered by customer,<br>
    aMember will send email (templates/email_verify.txt) to<br>
    specified email and user will be able to continue signup<br>
    only after clicking a link in the email message",
    $notebook_page, 
    '','','',
    array(
        'options' => array(
            '' => 'No',
            1 => 'Yes'
        )
    ));

add_config_field('unique_email', 'Require Unique Email',
    'select', "require unique email address for each member",
    $notebook_page, 
    '','','',
    array(
        'options' => array(
            0 => 'No',
            1 => 'Yes'
        )
    ));
add_config_field('use_address_info', 'Use Address Info',
    'select', "display address fields in the member forms",
    $notebook_page, 
    '','','',
    array(
        'options' => array(
            0 => 'No',
            1 => 'Yes'
        )
    ));

add_config_field('currency', 'Display Currency',
    'text', "currency to be displayed on membership and signup pages<br>
    NOTE - it is display change only - real price/currency change must be<br>
    made in product settings and not all payment processors allow you to<br>
    change currency. Make sure that EACH enabled payment processor will work<br>
    in selected currency.",
    $notebook_page, 
    '', '', '',
    array('default' => '$', size=>6)
    );

add_config_field('clear_access_log_days', 'Clear Access Log before .. days',
    'integer', "number of days",
    "Advanced", 
    'validate_integer');

if (!is_lite())
add_config_field('display_member_pw_urls', 'Display username/password in URL?',
    'select', "display usernmae/password in the URL?<br>
    According to latest IE6 fix, this option becomes unusable, so it <br>
    disabled.
    ",
    "Advanced", 
    '','','',
    array(
        'options' => array(
            0 => 'No'
        )
    ));

add_config_field('max_ip_count', 'Maximum count of different IP',
    'integer', "if member will reach this limit, his account will be locked",
    "Advanced", 
    'validate_integer');
add_config_field('max_ip_period', 'Count IP for ... hours',
    'integer', "the above limit is for previous ... hours",
    "Advanced", 
    'validate_integer');

if (!is_lite())
add_config_field('select_multiple_products', 'Select Multiple Products',
    'select', "allow select for multiple products for order<br>
    it might cause problems with recurring plugins or plugins,<br>
    which don't support this behaviour",
    "Advanced", 
    '', '', '',    
    array(
        'options' => array(
            0 => 'No',
            1 => 'Yes'
        )
    ));
if (!is_lite())
add_config_field('member_select_multiple_products', 'Select Multiple Products on Member Page',
    'select', "allow select for multiple products for order<br>
    on member.php page (for existing members)
    ",
    "Advanced", 
    '', '', '',    
    array(
        'options' => array(
            0 => 'No',
            1 => 'Yes'
        )
    ));
if (!is_lite())
add_config_field('multi_title', 'Multiple Order Title',
    'text', "when user ordering multiple products, what should be<br>
    displayed on the payment system receipt page?",
    "Advanced", 
    '', '', '',    
    array(
        'default' => 'Membership'
    ));

if (!is_lite())
add_config_field('use_coupons', 'Allow usage of coupons',
    'select', "",
    "Advanced", 
    '', '', '',    
    array(
        'options' => array(
            0 => 'No',
            1 => 'Yes'
        )
    ));

/*
add_config_field('use_affiliates', 'Enable affiliate program',
    'select', "",
    "Advanced", 
    '', '', '',    
    array(
        'options' => array(
            0 => 'No',
            1 => 'Yes'
        )
    ));
*/

if (!is_lite())
add_config_field('manually_approve', 'Manually Approve New Members',
    'select', "manually approve all new members (first payment)<br>
    don't enable it if you have huge members base already - all old<br>
    members become not-approved
    ",
    "Advanced", 
    '', '', '',    
    array(
        'options' => array(0 => 'No', 1 => 'Yes')
    ));

if (!is_lite())
add_config_field('use_tax', 'Enable Tax',
    'select', "calculate sales tax or VAT
    ",
    "Advanced", 
    '', '', '',    
    array(
        'options' => array(0 => 'No', 1 => 'Yes')
    ));
add_config_field('product_paysystem', 'Assign paysystem to product',
    'select', "
    if you enable this option, you will get select in product<br>
    options. You will be allowed to choose a payment system to<br>
    be used with this product. Don't enable this option along<br>
    with \"Select Multiple Product\" or be very careful!<br>
    Usually this option is not very useful.
    ",
    "Advanced", 
    '', '', '',    
    array(
        'options' => array(
            '' =>'No',
            1 => 'Yes'
        )
    ));

/*if (!is_lite())
add_config_field('use_shop', 'Use Shopping-cart alike interface',
    'select', "use shopping cart interface (/amember/shop/) instead<br>
               of default one-step signup interface.
    ",
    "Advanced", 
    '', '', '',    
    array(
        'options' => array(0 => 'No', 1 => 'Yes')
    ));
*/
add_config_field('date_format', 'Date Format',
    'text', "php <a target=_top 
    href='http://www.php.net/manual/en/function.date.php'>date()</a> format used,<br>
    use <i>%m/%d/%y<i> for US format, <i>%d/%m/%Y</i> for European
    ",
    "Advanced", 
    '', '', '',    
    array(
        'default' => '%m/%d/%y'
    ));
add_config_field('time_format', 'Time Format',
    'text', "php <a target=_top 
    href='http://www.php.net/manual/en/function.date.php'>date()</a> format used,<br>
    use <i>%m/%d/%y %H:%M:%S<i> for US format, <i>%d/%m/%Y %H:%M:%S</i> for European
    ",
    "Advanced", 
    '', '', '',    
    array(
        'default' => '%m/%d/%y'
    ));
add_config_field('profile_fields', 'User can change the following fields',
    'multi_select', "user can change the following fields<br>
     when he clicks \"Edit Profile\" link",
    "Advanced", 
    '','','',
    array(
        'options' => array(
            'login' => 'Login (username)',
            'pass0'  => 'Password',
            'name_f' => 'First Name',
            'name_l' => 'Last Name',
            'email'  => 'E-Mail',
        ) + (($GLOBALS['config']['use_address_info']) ? 
        array(
            'street' => 'Street',
            'city'   => 'City',
            'state'  => 'State',
            'zip'    => 'ZIP',
            'country'=> 'Country'
        ) : array())
        ,'store_type' => 1
    ));

if (!function_exists('is_trial') || !is_trial())
add_config_field('license', 'License',
    'textarea', "please enter license text",
    "License", 
    'validate_license', '', '',    
    array(
        'cols' => 100,
        'rows' => 7,
        'store_type' => 2
    ));

function validate_license($field, $vars){
    global $config;        
    $v = $vars[$field['name']];
    if (!strlen($v)) $errors[] = "Please enter license code";
    if (!preg_match('/^===== .+?===== ENF OF LICENSE =====$/s', $v)) $errors[] = "Please enter full license code (it should start and end with ======)";
    if (!preg_match('/^===== .+?=====$/m', $v)) $errors[] = "Please enter valid license code (seems there is a not-necessary linebreak in the first line between ===== and =====)";
    if ( preg_match('/^===== .+? \((.+?), (.+?), valid thru (.+?)\) =====/m', $v, $regs)){
        $d = preg_quote($regs[1]);
        $sd = preg_quote($regs[2]);
        $exp = $regs[3];
        $u1 = parse_url($url=$config['root_url']);
        $u2 = parse_url($surl=$config['root_surl']);
        
        if (!preg_match($x = "/($d|$sd)\$/", $u1['host']))
            $errors[] = "Root URL '$url' doesn't match license domain";
        if (!preg_match("/($d|$sd)\$/", $u2['host']))
            $errors[] = "Secure Root URL '$surl' doesn't match license domain";
    }
    return $errors[0];
}    
    

/// helper function
    
function read_plugins_list($ds){
    $d = opendir($ds);
    if (!$d) fatal_error("Cannot open '$ds'");
    $res = array();
    while ($dd = readdir($d)){
        $fpath = "$ds/$dd";
        if (($dd[0] == '.') || !is_dir($fpath)) continue;
        if ($dd == 'CVS') continue;
        $res[$dd] = $dd;
    }
    return $res;
}

add_config_field('plugins.payment', 'Payment Plugins',
    'multi_select', "select plugins for payment. It is always recommended<br>
    to have 'free' plugin enabled. It will not be displayed in payment<br>
    methods list.<br>
    <b>HOLD Ctrl key to select multiple plugins</b>
    ",
    "Plugins", 
    '', '', '',    
    array(
        'store_type' => 1,
        'options' => read_plugins_list("$config[root_dir]/plugins/payment")
    ));
add_config_field('plugins.protect', 'Protect Plugins',
    'multi_select', "select plugins for protection. It is always recommended<br>
    to have 'php_include' plugin enabled.<br>
    <b>HOLD Ctrl key to select multiple plugins</b>
    ",
    "Plugins", 
    '', '', '',    
    array(
        'store_type' => 1,
        'options' => read_plugins_list("$config[root_dir]/plugins/protect")
    ));

//////////// look & feel 
add_config_field('page_bg', 'Page Background Color',
    'color', "",  "Colors", 
    '', '', '',    
    array('default' => 'white')
);
add_config_field('page_fg', 'Page Foreground (text) Color',
    'color', "",  "Colors", 
    '', '', '',    
    array('default' => 'black')
);
//////////// tax page
add_config_field('tax', 'Tax Settings',
    '', '',
    'Tax Settings',
    '', 'tax_page_get', 'tax_page_set'
);

//////////// ban
add_config_field('ban.email', 'Denied Email address list',
    'textarea', 'put one email per line<br>
    use * for substitution, like <i>*@aol.com</i>',
    'Ban', 
    '', '', '',
    array('cols' => 30, 'rows'=>10, 'store_type' => 2));
add_config_field('ban.email_action', 'Denied Email Action',
    'select', 'what to do if user enter denied email',
    'Ban', 
    '', '', '',
    array('options' => array(
    'error' => 'Display error message',
    'die'   => 'Die and show ugly internal error page'
    )));
add_config_field('ban.ip', 'Denied IP address list',
    'textarea', 'put one IP per line<br>
    use * for substitution, like <i>193.122.123.*</i>',
    'Ban', 
    '', '', '',
    array('cols' => 30, 'rows'=>10, 'store_type' => 2));
add_config_field('ban.ip_action', 'Denied IP Action',
    'select', 'what to do if user comes from denied IP<br>
    to signup or renewal page',
    'Ban', 
    '', '', '',
    array('options' => array(
    'error' => 'Display error message',
    'die'   => 'Die and show ugly internal error page'
    )));
add_config_field('ban.login', 'Denied usernames address list',
    'textarea', 'put one denined username per line<br>
    use * for substitution, like <i>admin*</i>',
    'Ban', 
    '', '', '',
    array('cols' => 30, 'rows'=>10, 'store_type' => 2));
add_config_field('ban.login_action', 'Denied Username Action',
    'select', 'what to do if user enter denied username',
    'Ban', 
    '', '', '',
    array('options' => array(
    'error' => 'Display error message',
    'die'   => 'Die and show ugly internal error page'
    )));

/////////// affiliate settings
if ($config['use_affiliates'])
    aff_config();

function shop_config(){
    $page = "Shopping cart";
    config_set_notebook_comment($page, 'configure shopping-cart interface');
    add_config_field('shop.price_groups', 'Price Groups',
    'textarea', 'Enter one per line, in the following format:<br>
    price_group_number price group description<br>
    will be displayed in products list',
    $page, 
    '', '', '',
    array('cols' => 30, 'rows'=>10, 'store_type' => 2));
}

if ($config['use_shop'])
    shop_config();














/////////////////////////////////////////////////
function get_select($options, $value=''){
    foreach ($options as $k=>$v){
        $sel = ($k == $value) ? 'selected' : '';
        $res .= "<option value=\"$k\">$v\n";
    }
    return $res;
}

function tax_page_get(&$field, &$vars){
    global $config;
    $s = "";
    if ($vars['tax_type'] == 2) 
        $tax2='checked'; 
    else 
        $tax1='checked';
    $country_select = get_select($config['country_options']);
    $state_select = get_select($config['state_options']);

    $s = <<<CUT
    </table>
    <h3 align=center><input type=radio name=tax_type value=1 $tax1>
    Method 1 - Global Tax Settings</h3>

    <table class=vedit align=center>
    <tr>
        <th>Global Tax Title<br><small>Sales Tax or VAT</small></th>
        <td><input type=text name=tax_title value="$vars[tax_title]" size=12> %</td>
    </tr>
    <tr>
        <th>Global Tax Value</th>
        <td><input type=text name=tax_value value="$vars[tax_value]" size=4> %</td>
    </tr>
    <table>


    <h3 align=center><input type=radio name=tax_type value=2 $tax2>
Method 2 - Regional Tax Settings</h3>
     <b>Create New Tax Rate</b><br>
     <table align=center class=vedit>
     <tr>
        <th>Region</th>
        <td><input type=radio name=what value=country> Country<br>
        <select name=country size=1>$country_select</select>
        <br><br>
        <input type=radio name=what value=state checked> State<br>
        <select name=state size=1>$state_select</select>
        or <input type=text name=state_text size=5>
        </td>
     </tr>
     <tr>
        <th>Tax</th>
        <td>
        <input type=text name=regional_tax_value size=5> %
        </td>
     </tr>
    </table>
    <br>
CUT;
    if (!isset($vars['regional_taxes'])) 
        $vars['regional_taxes'] = $config['regional_taxes'];
    if (count($vars['regional_taxes'])){
        $s .= "
                <table class=hedit>
        <tr>                
            <th>Region</th>
            <th>Tax</th>
            <th>&nbsp;</th>
        </tr>
        ";
        foreach ((array)$vars['regional_taxes'] as $id=>$t){
            if ($t['state']){
                $r = ($config['state_options'][$t['state']] ?
                $config['state_options'][$t['state']] : 
                $t['state'] )
                . " <small>(state)</small>";
            } else {
                $r = ( $config['country_options'][$t['country']] ? 
                $config['country_options'][$t['country']] :
                $t['country'] )
                . " <small>(country)</small>";
            }
            $s.="<tr>
            <td>$r</td>
            <td>$t[tax_value]%</td>
            <td><a href='setup.php?notebook=Tax+Settings&save=1&remove_regional=1&id=$id'>remove</a></td>
            </tr>";
            $id++;
        }
        $s.= "</table>";
    }

    $s .= "<table>";
    return $s;

}

function tax_page_set(&$field, &$vars, &$db_vars){
    if ($vars['remove_regional']){
        global $db, $config;
        $rt = $config['regional_taxes'];
        unset($rt[$vars['id']]);
        $db->config_set('regional_taxes', $rt, 1);
        $vars['regional_taxes'] = $rt;
        return;
    }

    $db_vars['tax_type']  = intval($vars['tax_type']);
    $db_vars['tax_value'] = doubleval($vars['tax_value']);
    $db_vars['tax_title'] = $vars['tax_title'];

    if ($vars['tax_type'] == 2 && $vars['regional_tax_value'] 
        && (($vars['what'] == 'country' && $vars['country']) 
        ||  ($vars['what'] == 'state'   && ($vars['state'] || 
        $vars['state_text'])))){
        global $db, $config;
        $rt = $config['regional_taxes'];
        $to_add = array('tax_value' => $vars['regional_tax_value']);
        if ($vars['what'] == 'state')
            $to_add['state'] = $vars['state_text'] ? $vars['state_text'] : $vars['state'];
        else
            $to_add['country'] = $vars['country'];
        $rt[] = $to_add;
        $db->config_set('regional_taxes', $rt, 1);
        $vars['regional_taxes'] = $rt;
    }

}

//////////// validation functions
function validate_root_url($field, $vars){
    $url = $vars[$field['name']];
    if (!preg_match('/^http(s|):\/\/.+$/', $url))
        return "$field[title] - must start from <i>http://</i> or <i>https://</i>";
    if (preg_match('/\/+$/', $url))
        return "$field[title] - must be without trailing slash";

    ////
    $up = parse_url($url);
    global $_amember_license;
    $d1 = preg_quote($_amember_license['domain']);
    $d2 = preg_quote($_amember_license['secure_domain']);
    if (!preg_match($s="/($d1|$d2)\$/", $up['host'])){
        $dms = $_amember_license['domain'];
        if ($dms != $_amember_license['secure_domain'])
            $dms .= ", " . $_amember_license['secure_domain'];
        return "URL '$url' doesn't match license domain(s): $dms";
    }
}
function validate_email($field, $vars){
    if (!check_email($vars[$field['name']]))
        return "$field[title] - incorrect email address";
}
function validate_integer($field, $vars){
    if (!preg_match('/^(\-|)\d+$/', $vars[$field['name']]))
        return "$field[title] - incorrect number";

}
function validate_password($field, $vars){
    $fname = str_replace('.', '_', $field['name']);
    if ($vars[$fname] != $vars[$fname . '_confirm'])
        return "$field[title] - password and confirmation different";
}



?>
