<?php 
/*
*   todo: + attachments (upload to data), 
*         + clean attachments
*         + redirect after some time period min(2 min, page_timeout)
*         admin can create e-mail subscriptions with access rights and automatic/user subscribing
*         admin has an additional tab on user editing screen to subscribe/unsubscribe member
*         user can subscribe/unsubscribe to available subscriptions
*         amember maintains list of subscribed/unsubscribed customers
*         admin can email to subscriber/s of some mailing list
*         mod to weekly emails (2 functions mod)
* 
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: Admin Info / PHP
*    FileName $RCSfile: email.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.5.4.9 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*/
$avoid_timeout = 1;

include "../config.inc.php";
$t = new_smarty();
include "login.inc.php";
ignore_user_abort(true);
@set_time_limit(0);
session_start();

check_lite();

function get_email_types(){
    global $db;
    $res = array();
    $res['all']      = '* All Users (pending, active and expired)';
    $res['active']     = '* Active Users (paid and not-expired)';
    $res['pending']  = '* Pending Users (never paid)';
    $res['expired']  = '* Expired Users (paid and expired)';
    $products = $db->get_products_list();
    foreach ($products as $p){
        $id = $p['product_id'];
        $n  = $p['title'];
        $res["PRODUCT-$id"] = "Active users of '$n'";
    }
    return $res;
}

function get_target_users($start, $count, &$total){
    global $db, $vars;

    $emails = array();
    $output = array();
    $total = 0;
    $skipped = 0;
    $today = date('Y-m-d');
    // products selected
    $product_ids = array();
    foreach (array_unique((array)$vars['email_type']) as $email_type){
        if (preg_match('/^PRODUCT-(\d+)$/', $email_type, $regs)){
            $product_ids[] = $regs[1];
        }
    }
    if ($product_ids){
        $q = $db->query($s = "
            SELECT DISTINCT u.*
            FROM {$db->config['prefix']}members u 
                LEFT JOIN {$db->config['prefix']}payments p 
                ON (p.member_id=u.member_id)
            WHERE p.completed > 0 AND p.product_id IN (".join(',',$product_ids).") 
            AND p.begin_date <= NOW() AND p.expire_date >= NOW()
            GROUP BY u.member_id
        ");
        while ($u = mysql_fetch_assoc($q)){
            if ($emails[$u['email']]) continue;
            // make output
            if ($skipped <= $start-1)  {  
                // skip, wait for $start
                $skipped++;
            } elseif (count($output) >= $count) {
                //skip - we had necessary records
            } else {
                $u['data'] = unserialize($data);
                $output[] = $u;
            }
//            print "skipped=$skipped;start=$start;count=$count;co=".count($output).";total=$total<br>";
            $total++;
            $emails[$u['email']]++;
        }
    }
    /// seek for all, paid, expired, pending
    $where_conds = array();
    foreach (array_unique((array)$vars['email_type']) as $email_type){
        switch ($email_type){
            case 'all': 
                $where_conds[] = 1; break;
            case 'active' : 
                $where_conds[] = "u.status = 1"; break;
            case 'expired':
                $where_conds[] = "u.status = 2"; break;
            case 'pending':
                $where_conds[] = "u.status = 0"; break;
        }
    }
    if ($where_conds){
        $where_conds = join(' OR ', $where_conds);    
        $q = $db->query($s = "
            SELECT DISTINCT u.*
            FROM {$db->config['prefix']}members u 
            WHERE $where_conds
        ");
        while ($u = mysql_fetch_assoc($q)){
            if ($emails[$u['email']]) continue;
            if ($skipped <= $start-1)  {  
                $skipped++;
            } elseif (count($output) >= $count) {
            } else {
                $u['data'] = unserialize($data);
                $output[] = $u;
            }
            $total++;
            $emails[$u['email']]++;
        }
    }
    return $output;
}

function get_email_message(&$vars, &$user){
    global $t, $config;
    global $_AMEMBER_TEMPLATE;
    $_AMEMBER_TEMPLATE['text'] = preg_replace('/\{([^$])/', '&#123;\\1', $vars['text']);
    $user['name'] = $user['name_f'] . ' ' . $user['name_l'];
    $t->assign('user', $user);
    $t->assign('config', $config);    
    return wordwrap($t->fetch('memory:text'));
}

function get_email_to(&$vars, &$user){
    return 
    '"' 
    . 
    preg_replace(
        '/[^A-Za-z_\.-]+/', ' ', 
        $user['name_f'] . ' ' . $user['name_l']  )
    .
    '" ' 
    . 
    '<' . $user['email'] . '>';
}

///////////////// smarty resource //////////////////////////////////
function memory_get_template($tpl_name, &$tpl_source, &$smarty){
    global $_AMEMBER_TEMPLATE;
    if (isset($_AMEMBER_TEMPLATE[$tpl_name])){
        $tpl_source = $GLOBALS['_AMEMBER_TEMPLATE'][$tpl_name];
        return true;
    } else {
        return false;
    }
}

function memory_get_timestamp($tpl_name, &$tpl_timestamp, &$smarty)
{
    global $_AMEMBER_TEMPLATE;
    if (isset($_AMEMBER_TEMPLATE[$tpl_name])){
        $tpl_timestamp = time();
        return true;
    } else {
        return false;
    }
}
function memory_get_secure($tpl_name, &$smarty){ return true; }
function memory_get_trusted($tpl_name, &$smarty){ }

//////////////// display ///////////////////////////////////////////

function display_form(){
    global $t, $config, $vars;    
    $t->assign('email_types', get_email_types());
    $t->assign('config', $config);
    $t->assign('vars', $vars);
    $t->assign('files', serialize($vars['files']));
    $uploaded_files = array();
    foreach ((array)$vars['files'] as $f){
        $uploaded_files[] = "$f[name] ($f[size] KB)";
    }
    if ($uploaded_files)
        $t->assign('uploaded_files', $uploaded_files);
    $t->display("admin/email.html");
}

function display_preview(){
    global $t, $config, $db, $vars;

    $users = get_target_users(0, 1, $total);
    $user  = $users[0];

    $preview = array(
        'text' => 
        $vars['is_html'] ? 
        get_email_message($vars, $user) :
        htmlspecialchars(get_email_message($vars, $user), ENT_NOQUOTES ) ,
        'subj' => htmlspecialchars($vars['subj'], ENT_NOQUOTES ),
        'to'   => htmlspecialchars(get_email_to($vars, $user), ENT_NOQUOTES ),
        'is_html' => intval($vars['is_html']),
        'files'   => serialize($vars['files'])
    );
    
    $t->assign('email_types', $email_types=get_email_types());
    $t->assign('vars', $vars);
    $t->assign('svars', serialize($vars));
    $t->assign('preview', $preview);
    $t->assign('total_members', $total);
    $uploaded_files = array();
    foreach ((array)$vars['files'] as $f){
        $uploaded_files[] = "$f[name] ($f[size] KB)";
    }
    if ($uploaded_files)
        $t->assign('uploaded_files', $uploaded_files);
    $t->display('admin/email_preview.html');

    $_SESSION['amember_send_mails'] = $vars;
}

function send_mails(){
    global $t, $config, $db, $vars;

    $start =  intval($vars['start']);
    $count =  50 ; // 20 emails per page call
    ////////////////////////////////////////////
    $vars = $_SESSION['amember_send_mails'];
    $users = get_target_users($start, $count, $total);

    // send emails to all users 
    $attachments = $vars['files'];
    foreach ($users as $user){
        $preview = array(
            'text' => get_email_message($vars, $user),
            'subj' => $vars['subj'],
            'to'   => get_email_to($vars, $user),
            'is_html' => $vars['is_html']
        );
        mail_customer($preview['to'], $preview['text'], $preview['subj'], 
            $preview['is_html'], $attachments);
    }
    $newstart = $start + $count;
    $left = $total - $newstart;
    if (!$users || ($left <= 0)){
        $x = $start + count($users);
        clean_attachments();
        unset($_SESSION['amember_send_mails']);
        html_redirect("email.php?count=$x&action=sent", $print_header=0, 
                "Sending emails (finsihed)", "Sending emails to users ... cleanup operations");
    } else {
        html_redirect("email.php?start=$newstart&action=send", $print_header=0, 
            "Sending emails (please don't close browser window)", "Sending emails to users ".($start+1)."-$newstart ($total total, $left e-mails left)");
    }
}



function display_sent(){
    global $t, $vars;

    $t->assign('count', $vars['count']);
    $t->display('admin/email_sent.html');
}

function clean_attachments(){
    global $config;
    foreach ((array)$_SESSION['amember_send_mails']['files'] as $f)
        unlink($f['tmp_name']);

    $dir = opendir($d = $config['root_dir']."/data/");
    while (($file = readdir($dir)) !== false) {
        if (preg_match("/^upload\-/", $file))
            unlink($d . $file);
    }  
    closedir($dir);
}

function process_uploaded_files(&$vars){
    global $db, $config;
    srand(time());
    for ($i=0;$i<=1;$i++){
        if ($_FILES['file']['size'][$i]){ // file uploaded
            if (!move_uploaded_file($tmp=$_FILES['file']['tmp_name'][$i], 
                $new = $config['root_dir']."/data/upload-".rand(10000,99999).'-'.basename($tmp)))
                fatal_error("Unable to move downloaded file: $tmp to $new",0);
            $vars['files'][] = array(
                'tmp_name' => $new,
                'type'     => $_FILES['file']['type'][$i],
                'name'     => basename($_FILES['file']['name'][$i]),
                'size'     => sprintf("%.2f", $_FILES['file']['size'][$i] / 1024)
            );
        }
    }
}


//////////////////// main ////////////////////////////////////////
$t->register_resource("memory", array("memory_get_template",
                                       "memory_get_timestamp",
                                       "memory_get_secure",
                                       "memory_get_trusted"));

$vars = get_input_vars();
if ($vars['files'])
    $vars['files'] = unserialize($vars['files']);
if ($vars['upload'] || $_FILES['file']['size'][0] || $_FILES['file']['size'][1] ){
    process_uploaded_files($vars);
    if ($vars['upload'])
        $vars['action'] = '';
}
if ($vars['back']){
    $vars = unserialize($vars['vars']);
    $vars['action'] = '';
}
switch ($vars['action']){
    case 'preview':
        display_preview();
        break;
    case 'send':
        check_demo();
        send_mails();
        break;
    case 'sent':
        display_sent();
        break;
    default: 
        $_SESSION['send_emails'] = array();
        display_form();
        break;
}

?>
