<?php                   
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: Admin Payments
*    FileName $RCSfile: import.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.2.4.13 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*/

include "../config.inc.php";
$t = new_smarty();
include "login.inc.php";
@set_time_limit(3600);

check_lite();



function display_form(){
    global $t, $db;
    $fields_list = array();
    for ($i=0;$i<16;$i++)
        $fields_list[ 'FIELD-' . $i ] = "Field " . ($i+1);
    $t->assign('fields', $fields_list);
    $t->assign('fields_gen', array('GENERATE' => 'Generate') + $fields_list);
    $t->assign('fields_gen_fixed', array('GENERATE' => 'Generate', 'FIXED' => 'Fixed') + $fields_list);
    $t->assign('fields_emp', array('' => '-- Please select --') + $fields_list);
    $products = array();
    foreach ($db->get_products_list() as $p)
        $products[ $p['product_id'] ] = $p['title'];
    $t->assign('fields_prod', array("" => "-- Please select --", "EMPTY" => "Don't add subscription") + $products + $fields_list);
    $t->assign('fields_emp_fixed', array('' => '-- Please select --', 'FIXED' => 'Fixed - please enter') + $fields_list);
    global $member_additional_fields, $input_fields;
    $t->assign('member_additional_fields',$member_additional_fields);
    $t->display('admin/import.html');
}

function check_form(){
    global $t, $vars;
    $err = array();
    if (!$vars['login']) 
        $err[] = "Please select field where login stored in your file";
    if (!$vars['pass']){
        $err[] = 'Please select something for pass';
    } elseif (($vars['pass'] == 'FIXED') && (!$vars['pass_fixed'])) {
        $err[] = "Please enter fixed password";
    }
    if (!$vars['product_id']){
        $err[] = "Please select something for subscription type";
    }
    if (($vars['product_id'] != 'EMPTY') && !$vars['expire_date']){
        $err[] = "Please select something for expire date";
    }
    if (($vars['expire_date'] == 'FIXED') && !$vars['expire_date_fixed']){
        $err[] = "Please enter fixed expired date";
    }
    if (($vars['begin_date'] == 'FIXED') && !$vars['begin_date_fixed']){
        $err[] = "Please enter fixed begin date";
    }
    if (!preg_match('/^(|\d\d\d\d\-\d\d\-\d\d)$/', $vars['expire_date_fixed'])){
        $err[] = "Incorrect expire date format. Use yyyy-mm-dd";
    }
    if (!preg_match('/^(|\d\d\d\d\-\d\d\-\d\d)$/', $vars['begin_date_fixed'])){
        $err[] = "Incorrect begin date format. Use yyyy-mm-dd";
    }
    if ($err) {
        $t->assign('error', $err);
        return 0;
    }
    return 1;
}

$input_fields = array(
    'login', 'pass', 'email', 
    'name_f', 'name_l',
    'street', 'city',
    'state', 'zip', 
    'country', 'is_male',
    'product_id', 'expire_date', 'begin_date'
);
foreach ($member_additional_fields as $f){
    if ($f['type'] != 'hidden')
        $input_fields[] = $f['name'];        
}

function get_fields($vars){
    //get vars, return $fields
    global $input_fields;
    $fields = array();
    $max_num = 0;
    foreach ($input_fields as $k){
        if (preg_match('/^FIELD-(\d+)$/', $vars[$k], $regs)){
            $num = intval($regs[1]);
            if (isset($fields[$num])){
                $warn[] = "Field $num selected twice: for <i>$k</i> and for <i>" . $fields[$num] . '</i>. Please return back and FIX IT';
            }
            $fields[$num] = $k;
            if ($num > $max_num) $max_num = $num;
        }
    }
    for ($i=0;$i<=$max_num;$i++){
        if (!isset($fields[$i])) $fields[$i] = 'SKIPPED';
    }
    ksort($fields);
    return $fields;
}
function get_rev_fields($vars){
    //get vars, return $rev_fields
    global $input_fields;
    $fields = array();
    $max_num = 0;
    foreach ($input_fields as $k){
        if (preg_match('/^FIELD-(\d+)$/', $vars[$k], $regs)){
            $fields[$k] = $regs[1];
        }
    }
    return $fields;
}

function display_upload_form(){
    global $t, $vars, $db;

    $fields  = get_fields($vars);

    $format = join($vars['delim'], $fields);
    $t->assign('format', $format);
    $t->assign('warn', $warn);

    $str = '';
    foreach ($vars as $k=>$v){
        if ($k != 'action'){
            $str .= "<input type=hidden name=\"$k\" value=\"$v\">\n";
        }
    }
    $t->assign('hidden', $str);

    $t->display('admin/import_format.html');
}

function convert_date($d){
    if ($d > 1000000) /// timestamp
        return date('Y-m-d', $rec['expire_date']);
    else if (preg_match('/^\d{5}$/', $d)) //from mc_pro
        return date('Y-m-d', $d * 3600 * 24 + mktime(0,0,0,1,1,1970));
    else  // assume mysql yyyy-mm-dd
        return date('Y-m-d', strtotime($d));
}

function get_visible_cc_number($cc){
    $cc = preg_replace('/\D+/', '', $cc);
    return '**** **** **** '.substr($cc, -4);
}

function format_cc_expire($s){
    $s = preg_replace('/\D+/', '', $s);
    switch (strlen($s)){
        case 4: // mmyy 
            return $s;
        case 6: // mmyyyy
            return substr($s, 0, 2) . substr($s, 4, 2);
        default: return $s;
    }
}

function extract_to_session(){
    global $vars, $t, $db;
    global $HTTP_POST_FILES, $HTTP_SESSION_VARS;
    if (!($fn=$HTTP_POST_FILES['file']['tmp_name']) ||
      !is_uploaded_file($fn)) {    
        $t->assign('error', array('Please specify upload file for import'));
        return 0;
    }
    $f = fopen($fn, 'r');
    if (!$f) fatal_error("Cannot open file: $fn", 0);
    $HTTP_SESSION_VARS['file_content'] = array();
    $fields = get_rev_fields($vars);
    while ($l = fgetcsv($f, 8049, $vars['delim'])){
        $rec = array();
        foreach ($fields as $fn => $nn)
            $rec[$fn] = trim($l[$nn]);
        if ($vars['login'] == 'GENERATE')
            $rec['login'] = generate_login();
        if ($vars['pass'] == 'FIXED')
            $rec['pass'] = $vars['pass_fixed'];
        if ($vars['pass'] == 'GENERATE')
            $rec['pass'] = generate_password();
        if ($rec['cc']){
            $cc = preg_replace('/\D+/', '', $rec['cc']);
            $rec['cc-hidden'] = amember_crypt($cc);
            $rec['cc'] = get_visible_cc_number($cc);
            $cc='';
        }
        if ($rec['cc-expire']){
            $rec['cc-expire'] = format_cc_expire($rec['cc-expire']);
        }
        if ($vars['product_id'] != 'EMPTY'){
            if (intval($vars['product_id'])) 
                $rec['product_id'] = $vars['product_id'];
            if ($vars['expire_date'] == 'FIXED')
                $rec['expire_date'] = $vars['expire_date_fixed'];
            if ($vars['begin_date'] == 'FIXED')
                $rec['begin_date'] = $vars['begin_date_fixed'];
            $rec['is_completed'] = intval($vars['is_completed']);
        }
        $rec['begin_date'] = convert_date($rec['begin_date']);
        $rec['expire_date'] = convert_date($rec['expire_date']);
        
        $HTTP_SESSION_VARS['file_content'][] = $rec;
    }
    return 1;
}

function display_confirm(){ 
    global $t, $db, $HTTP_SESSION_VARS;
    global $file_content;
    $products = $db->get_products_list();
    foreach ($products as $k=>$v)
        $pp[$v['product_id']] = $v;
    foreach ($HTTP_SESSION_VARS['file_content'] as $k=>$v){
        $$HTTP_SESSION_VARS['file_content'][$k]['product'] = $pp [ $v['product_id']  ]['title'];
    }
    $t->assign('file_content', @array_slice($HTTP_SESSION_VARS['file_content'], 0, 20));
    $t->assign('member_additional_fields', $GLOBALS['member_additional_fields']);
    $t->display('admin/import_confirm.html');
}

function do_import(){
    global $t, $db;
    global $file_content;
    global $HTTP_SESSION_VARS;
    global $imported;
    global $config;
    $config['send_signup_mail'] = 0;
    global $__hooks;
    $__hooks = array(); // disable all things

    foreach ($HTTP_SESSION_VARS['file_content'] as $r){
        if (!$db->check_uniq_login($r['login'])){
            print "Duplicate login: $r[login]. This record won't be imported<br>";
            continue;
        }
        $r['pass0'] = $r['pass'];
        $member_id = $db->add_pending_user($r);
        if ($r['product_id']){
            $pm = array(
                'product_id'  => $r['product_id'],
                'begin_date'  => $r['begin_date'],
                'expire_date' => $r['expire_date'],
                'paysys_id'   => 'manual',
                'amount'      => 0,
                'receipt_id'  => 'IMPORT',
                'member_id'   => $member_id,
                'completed'   => $r['is_completed']
            );
            $db->add_payment($pm);
        }
    }
}

/////////////// MAIN //////////////////////
session_register('file_content');
session_register('imported');
$vars = get_input_vars();
switch ($vars['action']){
    case 'do_import':
        html_redirect("import.php?action=do_real_import", 
            $print_header=0, 
            $title='Import...', 
            $text='Import processing may take some time, please be patient');
        break;
    case 'do_real_import':
        check_demo();
        do_import();
        print "Import done";
        break;
    case 'upload':
        check_demo();
        if (extract_to_session()){
            display_confirm();
            break;
        }
    case 'check_form':
        check_demo();
        if (check_form()){
            display_upload_form();
            break;
        } 
    default: display_form();
}



?>
