<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: Admin Products
*    FileName $RCSfile: products.php,v $
*    Release: 2.1.8PRO ($Revision: 1.12.2.3.4.9 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*/

include "../config.inc.php";
$t = new_smarty();
include "login.inc.php";

$vars = get_input_vars();
extract($vars, EXTR_OVERWRITE);


function display_products_list(){
    global $db,$t;
    $pl = $db->get_products_list();
    $t->assign(pl, $pl);
    $t->display("admin/products.html");
}

function display_reorder_list(){
    global $db,$t;
    $pl = $db->get_products_list();
    $t->assign(pl, $pl);
    $t->display("admin/products_order.html");
}

function save_reorder_list(){
    global $db,$t;
    $vars = get_input_vars();
    $arr = array();
    foreach ($vars as $k=>$v)
        if (preg_match('/^(\w+)-(\d+)$/', $k, $regs))
            $arr[$regs[2]][$regs[1]] = $v;
    foreach ($arr as $product_id=>$v){
        $pr = $db->get_product($product_id);
        if (!$pr['product_id']) continue;
        $pr['order'] = $v['order'];
        $pr['price_group'] = $v['price_group'];
        $pr['renewal_group'] = $v['renewal_group'];
        $db->update_product($product_id, $pr);
    }        
    ////
    $pl = $db->get_products_list();
    $t->assign(pl, $pl);
    $t->display("admin/products_order.html");
}

function edit_product(){
    global $product_id;
    global $t, $db;
    global $t, $db, $vars, $error;
    $t->assign('edit', 1);
    $t->assign('error', $error);
    $p = $db->get_product($product_id);
    if (!$p) {
        fatal_error("Cannot open product #$product_id");
    }
    $t->assign('p', $vars['action'] == 'edit_save' ? $vars : $p);
    global $product_additional_fields;
    $t->assign('product_additional_fields', $product_additional_fields);
    $t->display('admin/product.html');
}

function add_product(){
    global $product_id;
    global $t, $db, $vars, $error;
    $t->assign('add', 1);
    $t->assign('error', $error);
    $t->assign('p', $vars);
    global $product_additional_fields;
    $t->assign('product_additional_fields', $product_additional_fields);
    $t->display('admin/product.html');
}

function edit_save(){
    global $PHP_SELF;
    global $db, $t, $error, $vars;

    $p = new product($vars);

    global $product_additional_fields;
    foreach ($product_additional_fields as $f){
        if ($f['validate_func'])
            foreach ((array)$f['validate_func'] as $func){
                if (!$func) 
                    continue;
                if (!function_exists($func))
                    $error[] = "Validation function '$func' for field: '$f[name]' not defined. Internal error";
                if ($err = $func($p, $f['name']))
                    $error[] = "Cannot update product: $err";
            }
    }
    if ($error) {
        edit_product();
        return;
    }


    $err = $db->update_product($vars['product_id'], $p->config);

    if ($err) {
        fatal_error("Cannot update product info: $err");
    }
    $t->assign('link', $PHP_SELF);
    $t->display("admin/product_saved.html");
}

function add_save(){
    global $PHP_SELF;
    global $db, $t;
    global $error;
    $vars = get_input_vars();

    $p = new product($vars);
    global $product_additional_fields;
    foreach ($product_additional_fields as $f){
        if ($f['validate_func'])
            foreach ((array)$f['validate_func'] as $func){
                if (!$func) 
                    continue;
                if (!function_exists($func))
                    $error[] = "Validation function '$func' for field: '$f[name]' not defined. Internal error";
                if ($err = $func($p, $f['name']))
                    $error[] = "Cannot add product: $err";
            }
    }
    if ($error) {
        add_product();
        return;
    }
    $product_id = $db->add_product($p->config);
    if (!$product_id) {
        $error = "Cannot insert product. INTERNAL ERROR";
    }
    $t->assign('link', $PHP_SELF);
    $t->display("admin/product_saved.html");
}

function delete(){
    global $product_id;
    global $PHP_SELF;
    global $db, $t;

    $c_act = $db->users_find_by_product_c($product_id, $include_expired=0);
    $c_all  =$db->users_find_by_product_c($product_id, $include_expired=1); 
    $c_exp = $c_all - $c_act;
    $c_exp = $c_exp ? "($c_exp expired)" : "";

    if ($c_all)
        fatal_error("There are $c_all user(s) $c_exp having 
        subscription<br>
        to this product. It is impossible to delete product if<br>
        someone subscribed to this.<br>
        Please delete these customers or re-subscribe them to another product.<br>
        <br>
        As immediate workaround, you may hide this product using 'Scope' field", 0);

    $err = $db->delete_product($product_id);
    if ($err) {
        fatal_error("Cannot delete product: $err");
    }
    $t->assign('msg', 'Product deleted');
    $t->assign('link', "products.php");
    $t->display("admin/product_saved.html");
}

////////////////////////////////////////////////////////////////////////////
//
//                      M A I N
//
////////////////////////////////////////////////////////////////////////////

$vars = get_input_vars();
$error = array();
switch ($vars['action']){
    case 'edit':
        edit_product();
        break;
    case 'edit_save':
        check_demo();
        edit_save();
        break;
    case 'add':
        add_product();
        break;
    case 'add_save':
        check_demo();
        add_save();
        break;
    case 'delete':
        check_demo();
        delete();
        break;
    case 'reorder':
        display_reorder_list();
        break;
    case 'reorder_save':
        save_reorder_list();
        break;
    case 'browse': case '': 
        display_products_list();
        break;
    default: 
        fatal_error("Unknown action: '$action' for $PHP_SELF");
}


?>
