<?php
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: Admin users
*    FileName $RCSfile: users.php,v $
*    Release: 2.1.8PRO ($Revision: 1.13.2.5.4.28 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*/

include "../config.inc.php";
$t = new_smarty();
include "login.inc.php";

$vars = get_input_vars();
extract($vars, EXTR_OVERWRITE);

$count = 20;

function get_az(){
    $az = array();
    for ($c=ord('A');$c<=ord('Z');$c++){
        $az[chr($c)] = 0;
    }
    return $az;
}

function display_not_approved_user_list(){
    global $db, $t;
    $ul = & $db->users_find_by_string("", "additional:is_approved");
    global $all_count, $count, $start;
    $all_count = count($ul);
    $t->assign('ul', @array_slice($ul, $start, $count));
    $t->assign('Not-Approved Users');
    $t->assign('users_total', $all_count);
    $t->assign('az', array());
    $t->display('admin/users.html');
}

function get_status_options(){
    return array(
        '' => 'All members',
        '00' => 'Pending',
        '1' => 'Active', 
        '2' => 'Expired'
    );
}

function display_user_list(){
    global $letter;
    global $active;
    global $db, $t, $vars;
    global $all_count, $count, $start;
    $all_count = $db->get_users_list_c($letter, $vars['status']);
    $ul = & $db->get_users_list($letter, $vars['status'], $start, $count);
    $t->assign('ul', $ul);
    $t->assign('az', get_az());
    $t->assign('users_total', $db->get_users_list_c('', $vars['status']));
    $t->assign('status_options', get_status_options());
    $t->display('admin/users.html');
}

function display_access_log(){
    global $member_id;
    global $start, $count;
    global $all_count;
    global $db, $t;

    if (!$count) $count = 20;
    $list = $db->get_access_log($member_id, $start, $count);
    $all_count = $db->get_access_log_c($member_id);

    $t->assign('list', $list);
    $t->assign('count', $count);
    $t->display("admin/user_access_log.html");
}
function display_aff_clicks(){
    global $member_id;
    global $start, $count;
    global $all_count;
    global $db, $t;

    if (!$count) $count = 20;
    $list = $db->get_aff_clicks($member_id, $start, $count);
    $all_count = $db->get_aff_clicks_c($member_id);

    $t->assign('list', $list);
    $t->assign('count', $count);
    $t->display("admin/user_aff_clicks.html");
}

function display_search_form(){
    global $db, $t;

    $t->assign('az', get_az());

    $products = & $db->get_products_list();
    $pp = array();
    foreach ($products as $p) $pp[ $p['product_id'] ] = $p['title'] ;
    $t->assign('products', $pp);

    $user_fields = array();
    foreach ($GLOBALS['member_additional_fields'] as $f){
        if ($f['name'] == 'is_locked') continue;
        if ($f['name'] == 'i_agree') continue;
        if ($f['name'] == 'is_approved') continue;
        if ($f['type'] == 'hidden') continue;
        $user_fields[$f['name']] = $f['title'];
    }
    $t->assign('member_fields', $user_fields);

    $t->display('admin/user_search.html');
}

function search_by_string(){
    global $q, $q_where;
    global $db, $t;
    $ul = & $db->users_find_by_string($q, $q_where);
    if (count($ul) == 0){
        $t->assign('error', 'Nothing was found by your request. Try to redefine search terms');
        display_search_form();
        return;
    }
    global $all_count, $count, $start;
    $all_count = count($ul);
    $t->assign('ul', @array_slice($ul, $start, $count));
    $t->display('admin/user_search_res.html');
}

function search_by_product(){
    global $product_id, $include_expired;
    global $db, $t;
    $ul = & $db->users_find_by_product($product_id, $include_expired);
    if (count($ul) == 0){
        $t->assign('error', 'Nothing was found by your request. Try to redefine search terms');
        display_search_form();
        return;
    }
    global $all_count, $count, $start;
    $all_count = count($ul);
    $t->assign('ul', @array_slice($ul, $start, $count));
    $t->display('admin/user_search_res.html');
}

function search_by_date(){
    global $HTTP_GET_VARS, $search_type;
    global $db, $t;
    set_date_from_smarty('date', $HTTP_GET_VARS);
    $ul = & $db->users_find_by_date($HTTP_GET_VARS['date'], $search_type);
    if (count($ul) == 0){
        $t->assign('error', 'Nothing was found by your request. Try to redefine search terms');
        display_search_form();
        return;
    }
    global $all_count, $count, $start;
    $all_count = count($ul);
    $t->assign('ul', @array_slice($ul, $start, $count));
    $t->display('admin/user_search_res.html');
}

function display_add_form($vars=''){
    global $db, $t;
    $t->assign('add', 1);
    settype($vars, 'array');

    global $member_additional_fields;
    $u = $vars;
    $t->assign('u', $u);
    $t->assign('member_additional_fields', $member_additional_fields);
    $t->assign('additional_fields_html', get_additional_fields_html($u, 'admin', 1));
    $t->display('admin/user_form.html');
}

function display_edit_form($vars=array()){
    global $member_id;
    global $db, $t;
    $u = & $db->get_user(intval($member_id));
    global $member_additional_fields;
    if ($u['aff_id']){
        $a = $db->get_user($u['aff_id']);
        $t->assign('aff', $a);
    }
    foreach ((array)$vars['data'] as $k=>$v)
        $u['data'][$k] = $v;
    foreach ($vars as $k=>$v){
        if ($k != 'data')
            $u[$k] = $v;
    }
    $t->assign('u', $u);
    $t->assign('member_additional_fields', $member_additional_fields);
    $t->assign('additional_fields_html', get_additional_fields_html($u, 'admin', 1));
    $t->display('admin/user_form.html');
}

function get_visible_cc_number($cc){
    $cc = preg_replace('/\D+/', '', $cc);
    return '**** **** **** '.substr($cc, -4);
}

function update_cc_info($member_id, $vars){
    global $db;
    if (!strlen($vars['cc_number'])) return;
    $vars['cc_number'] = preg_replace('/\D+/', '', $vars['cc_number']);
    ////////////////////////////////////////////////////////////////////
    $m = $db->get_user($member_id);
    $m['data']['cc-hidden'] = amember_crypt($vars['cc_number']);
    $m['data']['cc']        = get_visible_cc_number($vars['cc_number']);
    $m['data']['cc-expire'] = sprintf('%02d%02d',
        $vars['cc_expire_Month'],
        substr($vars['cc_expire_Year'], 2, 2));
    $db->update_user($member_id, $m);        
}

function add_save(){
    global $PHP_SELF;
    global $db, $t;
    global $member_additional_fields;

    $errors = array();
    $vars = get_input_vars();

    if (strlen($vars['generate_login']))
        $vars['login'] = generate_login($vars);
    if (strlen($vars['generate_pass']))
        $vars['pass'] = generate_password($vars);

    $vars['pass0'] = $vars['pass'];
    if (!strlen($vars['login'])){
        $errors[] = "'Login' is a required field";
    } elseif ($db->check_uniq_login($vars['login'], $vars['email'], $vars['pass0'], 1)>=0) {
        $errors[] = "User '$vars[login] already exists' - please choose another username";
    }
    if (!strlen($vars['pass0'])){
        $errors[] = "'Password' is a required field";
    }
    foreach ($member_additional_fields as $f){
        $fname = $f['name'];
        if ($f['validate_func'])
            foreach ((array)$f['validate_func'] as $func){
                if (!function_exists($func))
                    fatal_error("Validation function '$func' for field: '$fname' not defined. Internal error", 0);
                if ($err = $func($vars[$fname], $f['title'], $f))
                    $errors[] ="$err";
            }
    }
    foreach ($member_additional_fields as $f){
        $fname = $f['name'];
        if (isset($vars[$fname]))
            $vars['data'][$fname] = $vars[$fname];
    }
    if ($errors){
        $t->assign('errors', $errors);
        return display_add_form($vars);
    }
    foreach ($member_additional_fields as $f){
        $fname = $f['name'];
        $vars[$fname] = $vars['data'][$fname];
        unset($vars['data'][$fname]);
    }

    $member_id = $db->add_pending_user( $vars);

    update_cc_info($member_id, $vars);

    $t->assign('member_id', $member_id);
    $t->assign('msg', "User added. Click on 'User Payments' link in top to subscribe him.");
    $t->assign('link', "users.php?action=payments&member_id=$member_id");
    $t->display("admin/user_saved.html");
}

function delete_user(){
    global $member_id;
    global $PHP_SELF;
    global $db, $t, $vars;
    if (!$vars['confirm']){
        $user = $db->get_user($member_id);
        display_confirm("Delete user: $user[login]", "
        <center>Do you really want to delete user: $user[login]?
        It will be impossible to restore customer records.
        </center>
        ");
        return;
    } elseif ($vars['confirm'] != 'Yes'){
        display_edit_form();
        return;
    }
    $db->delete_user($member_id);
    $t->assign('msg', "User deleted");
    $t->assign('link', 'users.php');
    $t->assign('hide_notebook', 1);
    $t->display("admin/user_saved.html");
}


function edit_save(){
    global $PHP_SELF;
    global $db, $t;
    global $member_additional_fields, $config;

    $vars = get_input_vars();

    $errors = array();

    if (strlen($vars['generate_login']))
        $vars['login'] = generate_login($vars);
    if (strlen($vars['generate_pass']))
        $vars['pass'] = generate_password($vars);

    
    $vars['pass0'] = $vars['pass'];
    if (!strlen($vars['login'])){
        $errors[] = "'Login' is a required field";
    }
    if (!strlen($vars['pass0'])){
        $errors[] = "'Password' is a required field";
    }

    foreach ($member_additional_fields as $f){
        $fname = $f['name'];
        if ($f['validate_func'])
            foreach ((array)$f['validate_func'] as $func){
                if (!function_exists($func))
                    fatal_error("Validation function '$func' for field: '$fname' not defined. Internal error");
                if ($err = $func($vars[$fname], $f['title'], $f))
                    $errors[] = $err;
            }
    }
    foreach ($member_additional_fields as $f){
        if ($f['sql']) continue;
        $fname = $f['name'];
        if (isset($vars[ $fname ]))
            $vars['data'][ $fname ] = $vars[ $fname ];
        unset($vars[ $fname ]);
    }
    if ($errors){
        $t->assign('errors', $errors);
        return display_edit_form($vars);
    }
    $oldm = $db->get_user($vars['member_id']);

    $err = $db->update_user($vars['member_id'], $vars);
    if ($err) {
        fatal_error("Cannot update user info: $err");
    }
    update_cc_info($vars['member_id'], $vars);

    if ($config['manually_approve']){
        if (($oldm['data']['is_approved'] != $vars['data']['is_approved'])
             && $vars['data']['is_approved'])
            check_for_signup_mail(0, $vars['member_id']);
    }

    $t->assign('link', "users.php?member_id=$vars[member_id]&action=edit");
    $t->display("admin/user_saved.html");
}

function edit_payment(){
    global $member_id, $payment_id;
    global $db, $t;
    $p = $db->get_payment(intval($payment_id));
    $t->assign('p', $p);

    $products = & $db->get_products_list();
    $pp = array();
    foreach ($products as $p) $pp[ $p['product_id'] ] = $p['title'] ;
    $t->assign('products', $pp);

    $paysystems = get_paysystems_list();
    $pp = array();
    foreach ($paysystems as $p) $pp[ $p['paysys_id'] ] = $p['title'] ;
    $t->assign('paysystems', $pp);

    global $payment_additional_fields;
    $t->assign('payment_additional_fields', $payment_additional_fields);
    $t->display('admin/user_payment.html');
}

function del_payment(){
    global $member_id, $payment_id;
    global $PHP_SELF;
    global $db, $t;

    $oldp = $db->get_payment($payment_id);
    $err = $db->delete_payment($payment_id);
    if ($err) {
        fatal_error("Cannot delete payment: $err");
    }

    $t->assign('msg', 'Payment deleted');
    $t->assign('link', "users.php?action=payments&member_id=$oldp[member_id]");
    $t->display('admin/user_saved.html');
}

function display_payments_form(){
    global $member_id;
    global $db, $t;
    $payments = & $db->get_user_payments(intval($member_id));
    foreach ($payments as $k=>$p){
        $payments[$k]['items_count'] = count($p['data'][0]['BASKET_PRODUCTS']);
    }
    $t->assign('payments', $payments);

    $products = & $db->get_products_list();
    $pp = array();
    foreach ($products as $p) $pp[ $p['product_id'] ] = $p['title'] ;
    $t->assign('products', $pp);
    $t->assign('member_id', $member_id);

    $paysystems = get_paysystems_list();
    $pp = array();
    foreach ($paysystems as $p) $pp[ $p['paysys_id'] ] = $p['title'] ;
    $t->assign('paysystems', $pp);

    global $payment_additional_fields;
    $t->assign('payment_additional_fields', $payment_additional_fields);
    $t->display('admin/user_payments.html');
}

function display_confirm($title, $message){
    global $t, $vars;
    $t->assign('title', $title);
    $t->assign('message', $message);
    $t->assign('vars', $vars);
    $t->display('admin/confirm.html');
    exit();
}


function payment_save(){
    $vars = $GLOBALS['vars'];
    global $PHP_SELF;
    global $db, $t;

    set_date_from_smarty('begin_date',  $vars);
    set_date_from_smarty('expire_date',  $vars);

    global $payment_additional_fields;
    foreach ($payment_additional_fields as $f){
        $fname = $f['name'];
        if ($f['validate_func'])
            foreach ((array)$f['validate_func'] as $func){
                if (!function_exists($func))
                    fatal_error("Validation function '$func' for field: '$fname' not defined. Internal error", 0);
                if ($err = $func($vars, $fname))
                    fatal_error("Cannot update payment: $err", 0);
            }
        $vars['data'][$fname] = $vars[$fname];
        unset($vars[$fname]);
    }

    $oldp = $db->get_payment($vars['payment_id']);

    if ($vars['completed'] != $oldp['completed'] &&
        (count((array)$oldp['data'][0]['BASKET_PRODUCTS'])>1)){
        if (!$vars['confirm']){
        display_confirm('This change will affect multiple payments', "This payment
        record is a 'parent' invoice for multiple subscriptions.
        If you want to change status (paid/not-paid) for all
        subscriptions in the batch, click YES, if you want to
        change status only for one product, click NO.
        ");
        } elseif ($vars['confirm'] == 'Yes') { // confirmed
            if ($vars['completed']){
                $vars['completed'] = 0;
                $err = $db->update_payment($vars['payment_id'], $vars);
                $vars['completed'] = 1;
                if ($err) {
                    fatal_error("Cannot update payment info: $err");
                }
                $db->finish_waiting_payment($vars['payment_id'],
                    $oldp['paysys_id'], $vars['receipt_id'], '', $x=array());
                $oldp = $db->get_payment($vars['payment_id']);
                $vars['amount'] = $oldp['amount'];
                $t->assign('link', "users.php?action=payments&member_id=$oldp[member_id]");
                $t->display("admin/user_saved.html");
                return; ///////////////////////////!!!!!!!!!!!!!
            } else {
                foreach ($db->get_user_payments($oldp['member_id'], 1) as $p){
                    if ($p['data'][0]['ORIG_ID'] == $oldp['payment_id']){
                        $db->delete_payment($p['payment_id']);
                    }
                }
                $vars['amount'] = array_sum($oldp['data'][0]['BASKET_PRICES']);
            }
        }
    }

    $err = $db->update_payment($vars['payment_id'], $vars);
    if ($err) {
        fatal_error("Cannot update payment info: $err");
    }
    $t->assign('link', "users.php?action=payments&member_id=$oldp[member_id]");
    $t->display("admin/user_saved.html");
}

function payment_add(){
    $vars = $GLOBALS['vars'];
    global $PHP_SELF;
    global $db, $t;
    global $payment_additional_fields;
    foreach ($payment_additional_fields as $f){
        $fname = $f['name'];
        if ($f['validate_func'])
            foreach ((array)$f['validate_func'] as $func){
                if (!function_exists($func))
                    fatal_error("Validation function '$func' for field: '$fname' not defined. Internal error", 0);
                if ($err = $func($vars, $fname))
                    fatal_error("Cannot update payment: $err", 0);
            }
        $vars['data'][$fname] = $vars[$fname];
        unset($vars[$fname]);
    }

    set_date_from_smarty('begin_date',  $vars);
    set_date_from_smarty('expire_date',  $vars);
    $err = $db->add_payment($vars);
    if ($err) {
        fatal_error("Cannot add payment: $err");
    }
    $t->assign('link', "users.php?member_id=$vars[member_id]&action=payments");
    $t->assign('member_id', $vars['member_id']);
    $t->display("admin/user_saved.html");
}

function display_actions(){
    global $t;
    $t->display("admin/user_actions.html");
}

function move_user(){
    global $t, $db, $vars;
    $new_members = $db->users_find_by_string($vars['new_login'], 'login', 1);
    $new_member_id = $new_members[0]['member_id'];
    if (!$new_member_id)
        fatal_error("Cannot find user for move to: username '$vars[new_login]'");
    //// find payments for old user
    $op = $db->get_user_payments($vars['member_id'], 1);
    $np = $db->get_user_payments($new_member_id, 1);
    /// find last dates for each product in new account
    $dates = array();
    foreach ($np as $p){
        if ($dates[ $p['product_id'] ] < $p['expire_date'])
            $dates[ $p['product_id'] ] = $p['expire_date'];
    }
    /// move not-existing subscriptions without changes
    foreach ($op as $k => $p){
        $p['member_id'] = $new_member_id;
        $db->update_payment($p['payment_id'], $p);
        unset($op[$k]);
    }
    $db->delete_user($vars['member_id']);
    /*
    /// convert existing subscriptions into number of days
    /// which not used
    foreach ($op as $p){
        $b = sql_to_timestamp($p['begin_date']);
        $e = sql_to_timestamp($p['expire_date']);
        $t = sql_to_timestamp(date('Y-m-d'));
        $days_total = $e - max($b, $t);

    }
    */
    $t->assign('link', "users.php?member_id=$new_member_id&action=edit");
    $t->assign('member_id', $new_member_id);
    $t->display("admin/user_saved.html");
}

function member_send_signup_email(){
    global $t, $db, $vars;
    mail_signup_user($vars['member_id']);
    $t->assign('title', 'E-Mail sent');
    $t->assign('msg', 'Signup E-Mail has been sent');
    $t->assign('link', "users.php?member_id=$vars[member_id]&action=actions");
    $t->assign('member_id', $member_id);
    $t->display("admin/user_saved.html");
}

////////////////////////////////////////////////////////////////////////////
//
//                      M A I N
//
////////////////////////////////////////////////////////////////////////////
$vars = get_input_vars();
if ($vars['member_id']) $t->assign('member_id', $vars['member_id']);
switch (@$vars['action']){
    case 'access_log':
        display_access_log();
        break;
    case 'aff_clicks':
        display_aff_clicks();
        break;
    case 'add_form':
        display_add_form();
        break;
    case 'add_save':
        add_save();
        break;
    case 'search_form':
        display_search_form();
        break;
    case 'search_by_string':
        search_by_string();
        break;
    case 'search_by_product':
        search_by_product();
        break;
    case 'search_by_date':
        search_by_date();
        break;
    case 'edit':
        display_edit_form();
        break;
    case 'delete':
        delete_user();
        break;
    case 'edit_save':
        edit_save();
        break;
    case 'payments':
        display_payments_form();
        break;
    case 'edit_payment':
        edit_payment();
        break;
    case 'del_payment':
        del_payment();
        break;
    case 'payment_save':
        payment_save();
        break;
    case 'payment_add':
        payment_add();
        break;
    case 'actions':
        display_actions();
        break;
    case 'move':
        move_user();
        break;
    case 'send_signup_email':
        check_demo();
        member_send_signup_email();
        break;
    case 'not_approved':
        display_not_approved_user_list();
        break;
    case 'browse': case '':
        display_user_list();
        break;
    default:
        fatal_error("Unknown action: '$action' for users.php");
}


?>
