<?php                          
/**
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: Affiliate management routines
*    FileName $RCSfile: aff.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.3 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
*
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*                                                                                 
*/

global $payout_methods;
$payout_methods = array(
    'paypal' => 'PayPal Mass Pay',
);

function aff_get_payout_methods(){
    global $payout_methods;
    return $payout_methods;
}
function aff_config(){
    global $config;
    config_set_notebook_comment('Affiliates', 'affiliate program configuration');
    add_config_field('aff.payout_methods', 'Accepted Payout methods',
    'multi_select', "affiliate can choose a method for payout comissions.<br>
    If nothing will be selected, comissions will not be included to automated<br>
    payout report.
    ",
    "Affiliates", 
    '', '', '',    
    array(
        'store_type' => 1,
        'options' => aff_get_payout_methods()
    ));
    foreach ((array)$config['aff']['payout_methods'] as $m){
        // period to credit, days or months
        add_config_field("aff.$m.period", "$m payout period",
        'integer', 'period for calculate affiliate payouts, months',
        'Affiliates');
        // delay credit for periods
        add_config_field("aff.$m.delay", "$m payout delay",
        'integer', "delay payout for xx periods - to not pay for refunds",
        'Affiliates');
    }
    add_config_field('aff.min_payout', 'Minimum payout',
    'integer', "minimum payout (\$) for pay affiliates<br>
    If affiliate earned less, payout will be delayed until<br>
    next payout date
    ",
    "Affiliates", 
    '', '', '');
    add_config_field('aff.cookie_lifetime', 'Affiliate cookie lifetime',
    'integer', "how long (in days) store cookies about referrer.<br>
    So if customer will return to the site later, comission will be<br>
    paid to referring affiliate. 
    ",
    "Affiliates", 
    '', '', '');
}

function aff_set_cookie($aff_id){
    global $config;
    $aff_id = intval($aff_id);
    if (!$aff_id) return;
    setcookie('amember_aff_id', $aff_id, 
        time()+$config['aff']['cookie_lifetime'] * 3600 * 24, '/');
}

function aff_decrypt($s){ // easy encryption to hide texts in URL
    $from = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $to   = 'nopqrstuvwxyzabcdefghijklmNOPQRSTUVWXYZABCDEFGHIJKLM';
    return strtr($s, $from, $to);    
}

function aff_encrypt($s){ // easy encryption to hide texts in URL
    return aff_decrypt($s);
}

function aff_get_commission($product_id, $is_first, $aff_id=0, $paid=''){
    $pr = get_product($product_id);
    $cexp = $is_first ? $pr->config['aff_commission'] : $pr->config['aff_commission_rec'];
    if (preg_match('/^([\d\.])\s*\%$/', $cexp, $regs)){ // %
        $price  = $paid ? $paid : $pr->config['price'];
        return round($regs[1] * 0.01 * $price, 2);
    } else { // absolute
        return $cexp;
    }
    return 0;
}

function add_affiliate_commission($payment_id){
    global $db;
    $oldp = $db->get_payment($payment_id);
    /// affiliate thing
    if (!$oldp['member_id']) return;
    $u = $db->get_user($oldp['member_id']);
    $aff_id = $u['aff_id'];
    if ($aff_id){
        $pl = $db->get_user_payments($oldp['member_id'], 1);
        $is_first = 1;
        if (count($pl))
            foreach ($pl as $v){
                if ($vars['ORIG_ID'] && ($pl['payment_id'] == $vars['ORIG_ID']))
                    continue;
                if ($vars['ORIG_ID'] && ($pl['data'][0]['ORIG_ID'] == $vars['ORIG_ID']))
                    continue;
                $is_first = 0;
                break;
            }
        $comission = aff_get_commission($oldp['product_id'], 
            $is_first, $aff_id, $oldp['amount']);
        if ($comission){
            $db->aff_add_commission($aff_id, $comission, 
                $payment_id, $receipt_id,
                $oldp['product_id'], $is_first);
        }                        
    }
}


global $config;
if ($config['use_affiliates']){
    add_member_field('aff_paypal', 'PayPal address',
        'text', 'to receive affiliate commission');
    add_product_field('aff_commission', 'Affiliate commission',
        'text', 'affiliate comissions for first payment, ex.: 1.5 or 2.5%');
    add_product_field('aff_commission_rec', 'Affiliate commission for recurring payment',
        'text', 'affiliate comissions for following payments, ex.: 0 or 5%');
    setup_plugin_hook('finish_waiting_payment', 'add_affiliate_commission');
}

?>
