#
# WARNING! If you want to apply it manually
# REPLACE @DB_MYSQL_PREFIX to desired value -
# possible empty string
#
#
# aMember MySQL database dump
#
#
#
# Table structure for table 'access_log'
#

CREATE TABLE @DB_MYSQL_PREFIX@access_log(
log_id int(11) NOT NULL auto_increment,
member_id int(11) NOT NULL,
time timestamp(14) NOT NULL,
url varchar(255) default NULL,
remote_addr varchar(15) default NULL,
referrer varchar(255) default NULL,
PRIMARY KEY (log_id),
INDEX (member_id, time, remote_addr),
INDEX (time)
)
;

#
# Table structure for table 'aff_clicks'
#
CREATE TABLE @DB_MYSQL_PREFIX@aff_clicks(
log_id int(11) NOT NULL auto_increment,
aff_id int(11) NOT NULL,
time timestamp(14) NOT NULL,
url varchar(255) default NULL,
remote_addr varchar(15) default NULL,
referrer varchar(255) default NULL,
PRIMARY KEY (log_id),
INDEX (aff_id, time, remote_addr),
INDEX (time)
)
;

#
# Table structure for table 'cron_run'
#

CREATE TABLE @DB_MYSQL_PREFIX@cron_run (
id int(11) NOT NULL default '0',
time datetime NOT NULL default '0000-00-00 00:00:00',
PRIMARY KEY (id)
);



#
# Table structure for table 'error_log'
#

CREATE TABLE @DB_MYSQL_PREFIX@error_log (
log_id int(11) NOT NULL auto_increment,
member_id int(11) default '0',
time timestamp(14) NOT NULL,
url varchar(255) default NULL,
remote_addr varchar(15) default NULL,
referrer varchar(255) default NULL,
error text,
PRIMARY KEY (log_id)
) ;



#
# Table structure for table 'members'
#

CREATE TABLE @DB_MYSQL_PREFIX@members (
member_id int(11) NOT NULL auto_increment,
login varchar(32) NOT NULL,
pass varchar(32) default NULL,
email varchar(64) default NULL,
name_f varchar(32) NOT NULL default '',
name_l varchar(32) NOT NULL default '',
street varchar(255) default NULL,
city varchar(255) default NULL,
state varchar(255) default NULL,
zip varchar(255) default NULL,
country varchar(255) default NULL,
is_male smallint(6) default NULL,
added datetime NOT NULL default '0000-00-00 00:00:00',
remote_addr varchar(15) default NULL,
data text NOT NULL,
PRIMARY KEY (member_id),
UNIQUE KEY login (login)
) ;



#
# Table structure for table 'payments'
#

CREATE TABLE @DB_MYSQL_PREFIX@payments (
payment_id int(11) NOT NULL auto_increment,
member_id int(11) NOT NULL ,
product_id int(11) NOT NULL ,
begin_date date NOT NULL ,
expire_date date NOT NULL ,
paysys_id varchar(32) NOT NULL default '',
receipt_id varchar(32) NOT NULL default '',
amount decimal(12,2) NOT NULL default '0.00',
completed smallint(6) default '0',
remote_addr varchar(15) NOT NULL default '',
data text,
time timestamp(14) NOT NULL,
PRIMARY KEY (payment_id),
KEY member_id (member_id)
) ;



#
# Table structure for table 'products'
#

CREATE TABLE @DB_MYSQL_PREFIX@products (
product_id int(11) NOT NULL auto_increment,
title varchar(255) NOT NULL default '',
description text,
price decimal(12,2) default NULL,
data text,
PRIMARY KEY (product_id)
) ; 


#### *** 1.9.1 ***
CREATE TABLE @DB_MYSQL_PREFIX@coupon (
  coupon_id int(11) unsigned NOT NULL auto_increment PRIMARY KEY,
  batch_id int(10) unsigned NOT NULL,
  code varchar(32) NOT NULL,
  comment varchar(64),
  discount varchar(32) NOT NULL,
  begin_date date,
  expire_date date,
  locked tinyint(3) unsigned NOT NULL,
  product_id varchar(255),
  use_count int(11),
  member_use_count int(11),
  used_count int(11),
  used_for text,
  data text,
  UNIQUE KEY code (code)
);

CREATE TABLE @DB_MYSQL_PREFIX@config (
  config_id int(11) NOT NULL auto_increment PRIMARY KEY,
  name varchar(64) NOT NULL,
  type smallint(6) default '0',
  value varchar(255) ,
  blob_value blob,
  UNIQUE KEY name (name)
);

CREATE TABLE @DB_MYSQL_PREFIX@aff_commission (
  comission_id int(11) NOT NULL auto_increment PRIMARY KEY,
  aff_id int NOT NULL,
  date DATE NOT NULL,
  amount DECIMAL(12,2),
  record_type char(16) NOT NULL,
  payment_id int NOT NULL,
  receipt_id char(32) NOT NULL,
  product_id int not null,
  is_first int not null,
  payout_date date,
  payout_type char(32),
  payout_id char(32),
  INDEX aff_id (aff_id, date),
  UNIQUE KEY payment (payment_id, receipt_id, record_type)
);

CREATE TABLE @DB_MYSQL_PREFIX@folders (
  folder_id int(11) NOT NULL auto_increment,
  path varchar(255) NOT NULL default '',
  url varchar(255) NOT NULL default '',
  method varchar(64) default NULL,
  product_ids varchar(64) NOT NULL default '',
  files_content blob,
  PRIMARY KEY  (folder_id),
  UNIQUE KEY path (path),
  UNIQUE KEY url (url)
);

#### fill-in config values

REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('root_url', 0, '@ROOT_URL@', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('root_surl', 0, '@ROOT_SURL@', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('admin_email', 0, '@ADMIN_EMAIL@', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('admin_login', 0, '@ADMIN_LOGIN@', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('admin_pass', 0, '@ADMIN_PASS@', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('tpl_cache_level', 0, '@TPL_CACHE_LEVEL@', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('generate_login', 0, '0', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('login_min_length', 0, '4', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('login_max_length', 0, '32', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('generate_pass', 0, '0', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('pass_min_length', 0, '4', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('pass_max_length', 0, '32', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('clear_access_log', 0, '1', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('clear_access_log_days', 0, '7', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('max_ip_count', 0, '5', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('max_ip_period', 0, '1440', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('select_multiple_products', 0, '0', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('multi_title', 0, 'Membership', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('use_coupons', 0, '0', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('date_format', 0, '%m/%d/%Y', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('time_format', 0, '%m/%d/%Y %H:%M:%S', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('send_signup_mail', 0, '1', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('mail_expire', 0, '0', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('mail_expire_days', 0, '1', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('display_member_pw_urls', 0, '0', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('use_address_info', 0, '0', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('unique_email', 0, '1', '');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('profile_fields', 1, '', 'a:4:{i:0;s:5:"pass0";i:1;s:6:"name_f";i:2;s:6:"name_l";i:3;s:5:"email";}');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('license', 2, '', '@LICENSE@');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('plugins.payment', 1, '', '@PAYMENT_PLUGINS@');
REPLACE INTO @DB_MYSQL_PREFIX@config 
(name,type,value,blob_value) VALUES ('plugins.protect', 1, '', '@PROTECT_PLUGINS@');

MODIFY @DB_MYSQL_PREFIX@members FIELD status smallint NOT NULL DEFAULT 0;
#MODIFY @DB_MYSQL_PREFIX@members FIELD aff_id int;
### add affiliate id field if it don't exists
MODIFY @DB_MYSQL_PREFIX@payments FIELD aff_id int NOT NULL;
### add payer_id field if it don't exists
MODIFY @DB_MYSQL_PREFIX@payments FIELD payer_id VARCHAR(255) NOT NULL;
### add indexes
MODIFY @DB_MYSQL_PREFIX@payments INDEX payer_id (payer_id);

### 1.9.3RC..
##
MODIFY @DB_MYSQL_PREFIX@coupon FIELD use_count int NOT NULL DEFAULT 0;
MODIFY @DB_MYSQL_PREFIX@coupon FIELD member_use_count int NOT NULL DEFAULT 0;
MODIFY @DB_MYSQL_PREFIX@coupon FIELD used_count int NOT NULL DEFAULT 0;
MODIFY @DB_MYSQL_PREFIX@payments FIELD coupon_id int NOT NULL;
MODIFY @DB_MYSQL_PREFIX@payments INDEX coupon_id (coupon_id);
MODIFY @DB_MYSQL_PREFIX@payments FIELD tm_added datetime NOT NULL;
MODIFY @DB_MYSQL_PREFIX@payments INDEX tm_added (tm_added, product_id);
MODIFY @DB_MYSQL_PREFIX@payments FIELD tm_completed datetime NULL;
MODIFY @DB_MYSQL_PREFIX@payments INDEX tm_completed (tm_completed, product_id);