<?php
/*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: Members handling functions
*    FileName $RCSfile: member.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.6.4.21 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*                                                                                 
*/
global $member_fields;
$member_fields = array(
    array(
        'name'         => 'member_id',
        'title'        => 'Member #',
        'type'         => 'hidden'
    ),
    array(
        'name'         => 'login',
        'title'        => 'Login',
        'type'         => 'text'
    ),
    array(
        'name'         => 'pass',
        'title'        => 'Password',
        'type'         => 'text'
    ),
    array(
        'name'         => 'email',
        'title'        => 'EMail',
        'type'         => 'text'
    ),
    array(
        'name'         => 'name_f',
        'title'        => 'First Name',
        'type'         => 'text'
    ),
    array(
        'name'         => 'name_l',
        'title'        => 'Last Name',
        'type'         => 'text'
    ),
    array(
        'name'         => 'street',
        'title'        => 'Street',
        'type'         => 'text'
    ),
    array(
        'name'         => 'city',
        'title'        => 'City',
        'type'         => 'text'
    ),
    array(
        'name'         => 'state',
        'title'        => 'State',
        'type'         => 'text'
    ),
    array(
        'name'         => 'zip',
        'title'        => 'ZIP',
        'type'         => 'text'
    ),
    array(
        'name'         => 'country',
        'title'        => 'Country',
        'type'         => 'text'
    ),
    array(
        'name'         => 'is_male',
        'title'        => 'Gender (female:0/male:1)',
        'type'         => 'radio'
    ),
    array(
        'name'         => 'aff_id',
        'title'        => 'Affiliate #',
        'type'         => 'readonly'
    )
);

global $member_additional_fields;
$member_additional_fields = array(
);

function add_member_field($name, $title, 
                            $type, $description='', $validate_func='',
                            $additional_fields=NULL){
    settype($additional_fields, 'array');
    global $member_additional_fields;
    foreach ($member_additional_fields as $k=>$v){
        if ($v['name'] == $name) {
            if ($v['validate_func'] && 
                ($v['validate_func'] != $validate_func)){
                $member_additional_fields[$k]['validate_func'] = 
                        (array)$v['validate_func'];
                $member_additional_fields[$k]['validate_func'][] = 
                    $validate_func;
            }
            return;
        }
    }    
    $member_additional_fields[] = array_merge(
        $additional_fields,
        array(
            'name'          => $name,
            'title'         => $title,
            'type'          => $type,
            'description'   => $description,
            'validate_func' => $validate_func
        )
    );
}

function mail_expire_members(){
    // send mail to members having
    // expiration_date = today() + $config['expire_mail_days']
    global $config, $db, $t;
    if (!$config['mail_expire']) return;
    if (!is_object($t))
        $t = & new_smarty();
    $days = intval($config['mail_expire_days']);
    $dat = date('Y-m-d', time() + 3600 * 24 * $days);
    $plist = $db->get_expired_payments($dat, $dat, '', 0);
    $msent = array();
    foreach ($plist as $p){ // go through expired payments and send mail
        if ($msent[$p['member_id'] ]) continue; //dont send second mail !
        $paysys = get_paysystem($p['paysys_id']);
        $product = $db->get_product($p['product_id']);
        if ($paysys['recurring'] && $product['is_recurring']) continue; // don't send if auto-recurring
        $u = $db->get_user($p['member_id']);
        $product = get_product($p['product_id']);

        ///////////////////////////////////
        $t->assign('login',  $u['login']);
        $t->assign('pass',   $u['pass']);
        $t->assign('name_f', $u['name_f']);
        $t->assign('name_l', $u['name_l']);
        ///////////////////////////////////
        $t->assign('user',   $u);
        $t->assign('payment',$p);
        $t->assign('product',$product->config);
        ///////////////////////////////////
        $mail = $t->fetch("expire_mail.txt");
        mail_customer($u['email'], $mail, "Your Subscription Expires");
        $msent[$p['member_id'] ]++;
    }
}

function mail_not_completed_members(){
    // send mail to all members having no active subscriptions
    // and pending payment completed before 'max_not_completed_days' days
    global $config, $db, $t;
    if (!$config['mail_not_completed']) return;
    if (!is_object($t))
        $t = & new_smarty();
    $days = intval($config['mail_not_completed_days']);
    $dat = date('Y-m-d', time() - 3600 * 24 * $days);
    $plist = $db->get_payments($dat, $dat, -1);
    $msent = array();
    foreach ($plist as $p){ // go through expired payments and send mail
        if ($msent[$p['member_id'] ]) continue; //dont send second mail !
        // check for customers with the same email and last name
        $u = $db->get_user($p['member_id']);
        
        $email = $db->escape($u['email']);
        $name_l = $db->escape($u['name_l']);
        $name_f = $db->escape($u['name_f']);
        $q = $db->query($s = "SELECT SUM(p.completed)
            FROM {$db->config[prefix]}members m LEFT JOIN 
                {$db->config[prefix]}payments p USING (member_id)
            WHERE (m.name_l = '$name_l' AND m.name_f = '$name_f') OR m.email = '$email'
                OR m.member_id = {$p[member_id]} 
            ");
        list($c_count) = mysql_fetch_row($q);
        if ($c_count) continue;

        $product = get_product($p['product_id']);
        ///////////////////////////////////
        $t->assign('login',  $u['login']);
        $t->assign('pass',   $u['pass']);
        $t->assign('name_f', $u['name_f']);
        $t->assign('name_l', $u['name_l']);
        ///////////////////////////////////
        $t->assign('user',   $u);
        $t->assign('payment',$p);
        $t->assign('product',$product->config);
        ///////////////////////////////////
        $mail = $t->fetch("not_completed_mail.txt");
        mail_customer($u['email'], $mail, "Not Completed Payment");
        $msent[$p['member_id'] ]++;
    }
}

function mail_recurring_members(){
    // send mail to members having
    // expiration_date = today() + $config['expire_mail_days']
    global $config, $db, $t;
    if (!$config['mail_recurring']) return;
    $msent = array(); // sent to members
    if (!is_object($t))
        $t = & new_smarty();
    foreach ((array)$config['mail_recurring'] as $days => $template){
      $dat = date('Y-m-d', time() + 3600 * 24 * $days);
      $plist = $db->get_beginned_payments($dat);
      foreach ($plist as $p){ // go through beginned payments and send mail
          if ($msent[$p['member_id'] ]) continue; //dont send second mail !
          $u = $db->get_user($p['member_id']);
          $product = get_product($p['product_id']);
          ///////////////////////////////////
          $t->assign('login',  $u['login']);
          $t->assign('pass',   $u['pass']);
          $t->assign('name_f', $u['name_f']);
          $t->assign('name_l', $u['name_l']);
          ///////////////////////////////////
          $t->assign('user',   $u);
          $t->assign('payment',$p);
          $t->assign('product',$product->config);
          ///////////////////////////////////
          $mail = $t->fetch($template);
          mail_customer($u['email'], $mail, "Recurring Payment");
          $msent[$p['member_id'] ]++;
      }
    }
}

function check_expire_members(){
    // check that internal hooks for subscription_delete
    // was called for expired members (for the last week)
    global $config, $db, $t;
    $dat1 = date('Y-m-d', time() - 3600 * 24 * 7);
    $dat2 = date('Y-m-d');
    $plist = $db->get_expired_payments($dat1, $dat2);
    $msent = array();
    foreach ($plist as $p){ // go through expired payments and send mail
        if ($msent[$p['member_id'] ]) continue; //dont send second mail !
        $db->check_subscriptions($p['member_id']);
        $msent[$p['member_id'] ]++;
    }
}

////////////////// ACCESS CHECKER CODE /////////////////////////////////
add_member_field(
    'is_locked', 'Locked',
    'select', 'auto-locking by IP',
    '',
    array('options' => array(
        '' => 'No',
        1  => 'Yes',
        -1 => "Disable auto-lock for this user"
    ))
);
global $config;
if ($config['manually_approve']){
    add_member_field(
        'is_approved', 'Approved',
        'select', 'is member manually approved?',
        '',
        array('options' => array(
            '' => 'No',
            1  => 'Yes',
        ))
    );
}
add_member_field(
    'i_agree', 'Agreed With User Agreement',
    'hidden', '', 
    '',
    array('hidden_anywhere' => 1));
add_member_field(
    'signup_email_sent', 'Signup Email Sent',
    'hidden', '',
    '',
    array('hidden_anywhere' => 1));
add_member_field(
    'approval_email_sent', 'Approval Email Sent',
    'hidden', '',
    '',
    array('hidden_anywhere' => 1));
add_member_field(
    'bf_time', 'BruteForce time',
    'hidden', '',
    '',
    array('hidden_anywhere' => 1));
add_member_field(
    'bf_value', 'BruteForce value',
    'hidden', '',
    '',
    array('hidden_anywhere' => 1));

// running from cron
function clear_access_log(){
    global $db, $config;
    if (!$config['clear_access_log']) return;
    $dat = date('Y-m-d', time() - $config['clear_access_log_days'] * 3600 * 24);
    $db->clear_access_log($dat);
}
//

function member_lock_by_ip($member_id){
    global $db, $config;
    $m = $db->get_user($member_id);
    if ($m['data']['is_locked'] < 0) return; // auto-lock disabled
    $m['data']['is_locked'] = 1;
    $db->update_user($member_id, $m);
}

function member_check_ip_ban(){ //return 1 if should be banned
    global $config, $HTTP_SERVER_VARS;
    foreach (preg_split('/[\r\n]+/', $config['ban']['ip']) as $i)
        if (compare_with_pattern($i, $HTTP_SERVER_VARS['REMOTE_ADDR']))
            return 1;
}

function member_check_email_ban($email){ //return 1 if should be banned
    global $config;
    foreach (preg_split('/[\r\n]+/', $config['ban']['email']) as $i)
        if (compare_with_pattern($i, $email))
            return 1;
}

function member_check_login_ban($login){ //return 1 if should be banned
    global $config;
    foreach (preg_split('/[\r\n]+/', $config['ban']['login']) as $i)
        if (compare_with_pattern($i, $login))
            return 1;
}

function member_check_ban($vars){
    global $config, $db;
    $err = array();
    if (member_check_ip_ban()) 
        if ($config['ban']['ip_action'] == 'die'){
            $db->log_error("Attempt to signup from denied IP: $_SERVER[REMOTE_ADDR]");
            header("Status: 500 Internal Error");
            header("Status: 500 Internal Error");
            exit();
        } else {
            $db->log_error("Attempt to signup from denied IP: $_SERVER[REMOTE_ADDR]");
            $err[] = "Signup from this IP address denied";
        }
    if ($vars['email'] && member_check_email_ban($vars['email']))
        if ($config['ban']['email_action'] == 'die'){
            $db->log_error("Attempt to signup from denied E-Mail: $vars[email]");
            header("HTTP/1.0 500 Internal Error");
            header("Status: 500 Internal Error");
            exit();
        } else {
            $db->log_error("Attempt to signup from denied E-Mail: $vars[email]");
            $err[] = "Signup from this E-Mail address is not allowed";
        }
    if ($vars['login'] && member_check_login_ban($vars['login']))
        if ($config['ban']['login_action'] == 'die'){
            header("HTTP/1.0 500 Internal Error");
            header("Status: 500 Internal Error");
            exit();
        } else {
            $err[] = "Username is already taken. Please choose another username";
        }
            
    return $err;
}

function member_send_autoresponders(){
    global $db, $config, $t;
    if (!is_object($t))
        $t = &new_smarty();
    $pl = $db->get_products_list();
    $pl[] = array(
        'product_id' => -1,
        'autoresponder' => $config['autoresponder'],
        'autoresponder_renew' => $config['autoresponder_renew']
    );
    foreach ($pl as $pr){
        if (!$pr['autoresponder']) continue;
        if (!preg_match_all('/^\s*(\d+)\s*\-\s*(.+?)\s*$/m', $pr['autoresponder'], $regs))
            continue;
        if ($pr['product_id'] > 0)
            $product_where = "AND p.product_id=$pr[product_id]";
        else
            $product_where = "";
        foreach ($regs[1] as $k=>$days){
            $tpl = $regs[2][$k];
            $dat = date('Y-m-d', time()-$days*3600*24);
            $today = date('Y-m-d');
            if ($pr['autoresponder_renew'])
                $q = $db->query($s = "SELECT m.*
                FROM {$db->config['prefix']}payments p
                LEFT JOIN {$db->config['prefix']}members m USING (member_id)
                WHERE p.begin_date='$dat' AND p.completed>0
                    $product_where
                GROUP BY m.member_id ");
            else 
                $q = $db->query($s = "SELECT m.*
                FROM {$db->config['prefix']}members m
                LEFT JOIN {$db->config['prefix']}payments p USING (member_id)
                WHERE p.completed > 0 
                AND p.begin_date <= '$today' $product_where
                GROUP BY m.member_id
                HAVING 
                SUM(to_days(if(p.expire_date>'$today', '$today', p.expire_date)) - to_days(p.begin_date)) = $days
                AND 
                MAX(p.expire_date) >= '$today'
                ");
            while ($u = mysql_fetch_assoc($q)){
                $u['data'] = $db->decode_data($u['data']);
                $t->assign('user', $u);
                $t->assign('product', $pr);
                $t->assign('login',  $u['login']);
                $t->assign('pass',   $u['pass']);
                $t->assign('name_f', $u['name_f']);
                $t->assign('name_l', $u['name_l']);
                $mail = $t->fetch($tpl);
                if (preg_match('/unable to read template resource/', $mail)){
                    mail_admin("Email template: \"$tpl\" is not found in {$config[root_dir]}/templates/ folder or is empty.
===========================
$mail");
                } else {
                    mail_customer($u['email'], $mail, "Periodic E-Mail");
                }
            }
        }
    }
}

function member_send_zero_autoresponder($payment_id, $member_id=0){
    global $db, $config, $t;

    $p = $db->get_payment($payment_id);
    $member_id = $p['member_id'];
    $pr = $db->get_product($p['product_id']);


    if (!is_object($t))
        $t = &new_smarty();
    $pl = array($pr);
    $pl[] = array(
        'product_id' => -1,
        'autoresponder' => $config['autoresponder'],
        'autoresponder_renew' => $config['autoresponder_renew']
    );
    foreach ($pl as $pr){
        if (!$pr['autoresponder']) continue;
        if (!preg_match_all('/^\s*(0)\s*\-\s*(.+?)\s*$/m', $pr['autoresponder'], $regs))
            continue;
        if ($pr['product_id'] > 0)
            $product_where = "AND p.product_id=$pr[product_id]";
        else
            $product_where = "";
        foreach ($regs[1] as $k=>$days){
            $tpl = $regs[2][$k];
            $dat = date('Y-m-d', time()-$days*3600*24);
            $today = date('Y-m-d');
            if ($pr['autoresponder_renew'])
                $q = $db->query($s = "SELECT m.*
                FROM {$db->config['prefix']}payments p
                LEFT JOIN {$db->config['prefix']}members m USING (member_id)
                WHERE m.member_id='$member_id' AND 
                    p.begin_date='$dat' AND p.completed>0
                    $product_where
                GROUP BY m.member_id
                    ");
            else 
                $q = $db->query($s = "SELECT m.*
                FROM {$db->config['prefix']}members m
                LEFT JOIN {$db->config['prefix']}payments p USING (member_id)
                WHERE m.member_id='$member_id' AND p.completed > 0 
                AND p.begin_date <= '$today' $product_where
                GROUP BY m.member_id
                HAVING 
                SUM(to_days(if(p.expire_date>'$today', '$today', p.expire_date)) - to_days(p.begin_date)) = $days
                AND 
                MAX(p.expire_date) >= '$today'
                ");
            while ($u = mysql_fetch_assoc($q)){
                $u['data'] = $db->decode_data($u['data']);
                $t->assign('user', $u);
                $t->assign('product', $pr);
                $t->assign('login',  $u['login']);
                $t->assign('pass',   $u['pass']);
                $t->assign('name_f', $u['name_f']);
                $t->assign('name_l', $u['name_l']);
                $mail = $t->fetch($tpl);
                if (preg_match('/unable to read template resource/', $mail)){
                    mail_admin("Email template: \"$tpl\" is not found in {$config[root_dir]}/templates/ folder or is empty.
===========================
$mail");
                } else {
                    mail_customer($u['email'], $mail, "Periodic E-Mail");
                }
            }
        }
    }
}

function get_additional_field_html($f, $val){
    global $t, $config;
    $t->assign('f', $f);
    $t->assign('value', "");
    $t->assign('value', $val);
    return $t->fetch('add_field.inc.html');
}

function get_additional_field_html_readonly($f, $val){
    global $t, $config;
    $t->assign('f', $f);
    if ($f['type'] == 'select'){
        $val = $f['options'][$val];
    } elseif ($f['type'] == 'radio'){
        $val = $f['options'][$val];
    } elseif ($f['type'] == 'multi_select'){
        $s = array();
        foreach ((array)$val as $v)
            $s[] = $f['options'][$v];
        $val = join(',', $s);
    } elseif ($f['type'] == 'checkbox'){
        $s = array();
        foreach ((array)$val as $v)
            $s[] = $f['options'][$v];
        $val = join(',', $s);
    }
    $t->assign('value', $val);
    return $t->fetch('add_field_ro.inc.html');
}

function get_additional_fields_html($vars, $scope, $display_all=0){
    global $db, $config, $member_additional_fields;
    $ret = "";
    if (!isset($vars['data'])) 
        $vars['data'] = $vars; // hack for signup form
    foreach ($member_additional_fields as $f){
        $val = $f['sql'] ? 
            (isset($vars[$f['name']])?$vars[$f['name']]: $f['default']) : 
            (isset($vars['data'][$f['name']])?$vars['data'][$f['name']]:$f['default']);
        if ($f['type'] == 'hidden') continue;
        if (($f['display_'.$scope] == 1) || ($display_all == 1)){
            $ret .= get_additional_field_html($f, $val);
        } elseif (($f['display_'.$scope] == -1) || ($display_all == -1)){
            $ret .= get_additional_field_html_readonly($f, $val);
        }
    }
    return $ret;
}

function member_check_additional_fields(&$vars){
    global $member_additional_fields;
    $error = array();
    foreach ($member_additional_fields as $f){
        if (!$f['display_signup']) continue;
        $v = $vars[$fn = $f['name']];
        foreach ((array)$f['validate_func'] as $func){
            if (!strlen($func)) continue;
            if ($err = $func($v, $f['title'], $f)){
                $error[] = $err;
            }
        }
    }
    return $error;
}

function vf_integer($val, $field_title, $f){
    if (!preg_match('/^\d+$/', $val))
        return "Please enter integer number value for '$field_title'";
}
function vf_number($val, $field_title, $f){
    if (!is_numeric($val))
        return "Please enter numeric value for '$field_title'";
}
function vf_require($val, $field_title, $f){
    if (!strlen($val))
        return "Please fill-in '$field_title' field";
}
function vf_email($val, $field_title, $f){
    if (!check_email($val))
        return "Please enter valid email address for '$field_title'";
}
function vf_regex($val, $field_title, $f){
    if (!preg_match($f['re'], $val))
        return $f['re_msg'];
}
?>