<?php 
/**
* Defines payment base class and additional functions
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: Payment System Handling Functions
*    FileName $RCSfile: paysys.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.8.2.2.4.6 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*                                                                                 
*/

global $__paysystems_list;
$__paysystems_list = array();

/**
* Defines base for payment system plugins
*
*/
class payment {
    var $config = array();
    function payment($config){
        $this->config = $config;
    }
    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){
        fatal_error("do_payment is not implemented");
    }
    function validate_thanks(&$vars){
        return '';
    }
    function process_thanks(&$vars){
        return '';
    }
}

class amember_payment extends payment {
    var $public=1;
    ////
    var $title="Credit Card";
    var $description="secure credit card payment";
    var $fixed_price=0;
    var $recurring=0;
    var $built_in_trials=0;
    ///
    function amember_payment($config){
        $this->payment($config);
        $this->init();
    }
    function init(){
        add_paysystem_to_list(
        array(
                    'paysys_id'   => $this->get_plugin_name(),
                    'title'       => ($this->config['title']=='') ? $this->title : $this->config['title'],
                    'description' => ($this->config['description']=='') ? $this->description : $this->config['description'],
                    'fixed_price' => $this->fixed_price,
                    'public'      => $this->public,
                    'recurring'   => $this->recurring,
                    'built_in_trials' => $this->built_in_trials,
                )
        );
        if ($this->recurring) {
            add_product_field(
                        'is_recurring', 'Recurring Billing',
                        'select', 'should user be charged automatically<br>
                         when subscription expires',
                        '',
                        array('options' => array(
                            '' => 'No',
                            1  => 'Yes'
                        ))
            );
        }
        if ($this->built_in_trials){
            add_product_field('trial1_days', 
                'Trial 1 Duration',
                'period',
                'trial period duration'
                );

            add_product_field('trial1_price', 
                'Trial 1 Price',
                'money',
                'enter 0.0 to offer free trial'
                );
        }
    }
    function get_plugin_name(){
        if (preg_match('/^payment_(.+?)$/', get_class($this), $regs))
            return $regs[1];
        else
            die("Cannot determine payment plugin name: " . get_class($this));
    }
    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){
        global $db;
        $payment = $db->get_payment($payment_id);
        if ($payment['data'][0]['BASKET_PRODUCTS'])
            $product_ids = (array)$payment['data'][0]['BASKET_PRODUCTS'];
        else 
            $product_ids = array($payment['product_id']);
        $products = array();
        foreach ($product_ids as $product_id)
            $products[] = $db->get_product($product_id);
        $member  = $db->get_user($member_id);
        $title = (count($products) == 1) ? $products[0]['title'] : $config['multi_title'];
        $invoice = $payment_id;
        return $this->do_bill($price, $title, $products, $member, $invoice);
    }
    function do_bill($amount, $title, $products, $member, $invoice){
        die("do_bill is not implemented in this plugin: " . get_class($this));
    }
    function add_config_items($notebook_page){
         $plugin = $this->get_plugin_name();
         add_config_field("payment.$plugin.title", "Payment system title",
             'text', "to be displayed on signup.php and member.php pages",
             $notebook_page, 
             '','','',
             array('default' => $this->title));
         add_config_field("payment.$plugin.description", "Payment system description",
             'text', "to be displayed on signup page",
             $notebook_page, 
             '','','',
             array('default' => $this->description));
         add_config_field("payment.$plugin.disable_postback_log", "PostBack messages Logging",
             'select', "by default aMember will log payment system postback messages<br>
             you can disable this functionality by changing this configuration value.<br>
             It is recommended to keep this enabled at least for first 1-2 months.",
             $notebook_page, 
             '','','',
             array('options' => array('' => 'Log Postback Messages (default)', 1 => 'Disable PostBack Logging')));
    }
    function encode_and_redirect($url, $vars){
        $vars1 = array();
        foreach ($vars as $k=>$v)
            $vars1[] = urlencode($k) . '=' . urlencode($v);
        $x = join('&', $vars1);
        html_redirect("$url?$x", 0, "Redirecting you to secure payment page", 
        "You will be automatically redirected to secure payment page in about 2 seconds");
    }
    function get_dump($var){
        $s = "";
        foreach ($var as $k=>$v)
            $s .= "$k => $v<br>\n";
        return $s;
    }
    function postback_error($err){
        global $db;
        $plugin = $this->get_plugin_name();
        fatal_error("$plugin ERROR: $err<br>\n".$this->get_dump($this->postback_vars));
    }
    function postback_log($msg=''){
        global $db;
        if ($this->config['disable_postback_log'] != '') return;
        $db->log_error("$plugin DEBUG: $msg<br>\n".$this->get_dump($this->postback_vars));
    }
    function handle_postback($vars){
        $this->postback_vars = $vars;
        $this->postback_log();

        $ret = $this->process_postback($vars);
        
        if ($ret)
            $this->postback_log("successfully handled");

        return $ret;
    }
}

class amember_protect {
    function amember_protect($config){
        $this->config = $config;
    }
    function init(){     
    }
    function get_plugin_name(){
        if (preg_match('/^protect_(.+?)$/', get_class($this), $regs))
            return $regs[1];
        else
            die("Cannot determine protect plugin name: " . get_class($this));
    }
}

class amember_integration_plugin extends amember_protect {
    var $hooks = array(
            'subscription_added',
            'subscription_updated',
            'subscription_deleted',
            'subscription_removed',
            'subscription_check_uniq_login',
            'subscription_rebuild',
            'check_logged_in',
            'after_login',
            'after_logout',
            'fill_in_signup_form'
        );
    var $debug_sql = false;
    ///////////////////////////////////
    function subscription_added()  { }
    function subscription_updated(){ }
    function subscription_deleted(){ }
    function subscription_removed(){ }
    function subscription_check_uniq_login($login, $email, $pass){ 
        return 1; 
    }
    function subscription_rebuild(){}
    function check_logged_in(){}
    function after_login(){}
    function after_logout(){}
    function fill_in_signup_form(&$vars){}
    ////////////////////////////////////                                        
    function get_db(){
        return $GLOBALS['db'];
    }
    function query($sql){
        if ($this->debug_sql) 
            print "<br><b>SQL query:</b><pre>$sql</pre>";
        $db = & $this->get_db();
        $sql = str_replace("[db]", $this->config['db'], $sql);
        return $db->query($sql);
    }
    function query_first($sql){
        $q = $this->query($sql);
        return mysql_fetch_assoc($q);
    }
    function query_one($sql){
        $q = $this->query($sql);
        $x = mysql_fetch_array($q);
        return $x[0];
    }
    function escape_record($record){
        $db = & $this->get_db();
        settype($record, 'array');
        if (isset($record['data']))
            foreach ($record['data'] as $k=>$v)
                $d[$k] = is_array($v) ? $v : $db->escape($v);
        foreach ((array)$record as $k => $v)
            $record[$k] = mysql_escape_string($v);
        if (isset($record['data']))
            $record['data'] = $d;
        return $record;
    }
    function set_cookie($k, $v){
        $tm = 0;
        $d = $_SERVER['HTTP_HOST'];
        if (preg_match('/([^\.]+)\.(org|com|net|biz|info)/', $d, $regs))
            setcookie($k,$v,$tm,"/",".{$regs[1]}.{$regs[2]}");
        else
            setcookie($k,$v,$tm,"/");
    }
    function del_cookie($k){
        $tm = time()-24*3600;
        $d = $_SERVER['HTTP_HOST'];
        if (preg_match('/([^\.]+)\.(org|com|net|biz|info)/', $d, $regs))
            setcookie($k,"",$tm,"/",".{$regs[1]}.{$regs[2]}");
        else
            setcookie($k,"",$tm,"/");
    }
    function init(){
        set_protect_plugin_hooks($this);
    }
}

function set_protect_plugin_hooks(&$protect){
    $pn = $protect->get_plugin_name();
    foreach ($protect->hooks as $f) {
        eval ("function {$pn}_$f(\$a1='',\$a2='',\$a3='',\$a4='',\$a5='',\$a6='',\$a7='',\$a8='',\$a9=''){ 
            \$protect = & instantiate_plugin('protect', '{$pn}');
            return \$protect->$f(\$a1,\$a2,\$a3,\$a4,\$a5,\$a6,\$a7,\$a8,\$a9);
        };");
        setup_plugin_hook("$f", "{$pn}_$f");
    }
}

function get_paysystems_list(){
    global $__paysystems_list;
    return $__paysystems_list;
}

function add_paysystem_to_list($desc){
    global $__paysystems_list;
    $__paysystems_list[$desc['paysys_id']] = $desc;
}

function get_paysystem($paysys_id){
    global $__paysystems_list;
    return $__paysystems_list[$paysys_id];
}

add_paysystem_to_list(array(
            'paysys_id' => 'manual',
            'title'     => 'Manual Payment',
            'description' => 'Payment Entered by Admin',
            'public'    => 0
        )
);
?>
