<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: beanstream payment plugin
*    FileName $RCSfile: beanstream.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.4 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*/

global $config;
require_once($config['root_dir']."/plugins/payment/cc_core/cc_core.inc.php");

class payment_beanstream extends payment {
    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){
        return cc_core_do_payment('beanstream', $payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, $vars);
    }
    function get_cancel_link($payment_id){
        global $db;                            
        return cc_core_get_cancel_link('beanstream', $payment_id);
    }
    function get_plugin_features(){
        return array(
            'title' => 'BeanStream',
            'description' => 'Credit card payment',
            'currency' => array('usd' => 'USD', 'eur' => 'EUR'),
            'phone' => 2,
            'code' => 1,
            'name_f' => 2
        );
    }

    /*************************************************************
      cc_bill - do real cc bill
    ***************************************************************/
    function cc_bill($cc_info, $member, $amount, 
        $currency, $product_description, 
        $charge_type, $invoice, $payment){
        global $config;
        $log = array();
        //////////////////////// cc_bill /////////////////////////
        if ($charge_type == CC_CHARGE_TYPE_TEST) 
            return array(CC_RESULT_SUCCESS, "", "", array('test transaction' => 'no validation'));
        $vars = array(
            'requestType'  => 'BACKEND',
            'errorPage'    => $config['root_surl'] . "/cancel.php?payment_id={$payment[payment_id]}",
            'merchant_id'  => $this->config['merchant_id'] ,
            
            'trnCardOwner' => $cc_info['cc_name_f'] . " " . $cc_info['cc_name_l'],
            'trnCardNumber' => $cc_info['cc_number'],
            'trnExpMonth' => substr($cc_info['cc-expire'], 0, 2),
            'trnExpYear' => substr($cc_info['cc-expire'], 2, 2),
            'trnOrderNumber' => $invoice,
            'trnAmount' => $amount,
            'ordEmailAddress' => $member['email'],
            'ordName' => $member['name_f'] . " " . $member['name_l'],
            'ordPhoneNumber' => $cc_info['cc_phone'],
            'ordAddress1' => $cc_info['cc_street'],
            'ordCity' => $cc_info['cc_city'],
            'ordProvince' => $cc_info['cc_state'],
            'ordPostalCode' => $cc_info['cc_zip'],
            'ordCountry' => $cc_info['cc_country'],
            'trnComments' => $product_description            
        );
        if ($cc_info['cc_code']) 
            $vars['trnCardCvd'] = $cc_info['cc_code'];
        // prepare log record
        $vars_l = $vars; 
        $vars_l['trnCardNumber'] = $cc_info['cc'];
        if ($vars['trnCardCvd'])
            $vars_l['trnCardCvd'] = preg_replace('/./', '*', $vars['trnCardCvd']);
        $log[] = $vars_l;
        /////
        foreach ($vars as $kk=>$vv){
            $v = urlencode($vv);
            $k = urlencode($kk);
            $vars1[] = "$k=$v";
        }
        $vars1 = join('&', $vars1);
        $ret = cc_core_get_url("https://www.beanstream.com/scripts/process_transaction.asp?$vars1");
        parse_str($ret, $res);
        $log[] = $res;

        if ($res['trnApproved']){
            return array(CC_RESULT_SUCCESS, "", $res['trnId'], $log);
        } else {
            if ($res['errorType'] == 'S') 
                return array(CC_RESULT_INTERNAL_ERROR, $res['messageText'], "", $log);
            else 
                return array(CC_RESULT_DECLINE_PERM, $res['messageText'], "", $log);
        }
    }
}

function beanstream_get_member_links($user){
    return cc_core_get_member_links('beanstream', $user);
}

function beanstream_rebill(){
    return cc_core_rebill('beanstream');
}

cc_core_init('beanstream');
?>