<?php

include "../../../config.inc.php";

$this_config = $plugin_config['payment']['beaverpay'];

function get_dump($var){
//dump of array
    $s = "";
    foreach ((array)$var as $k=>$v)
        $s .= "$k => $v<br>\n";
    return $s;
}

function beaverpay_error($msg){
    global $txn_id, $invoice;
    global $vars;
    fatal_error("BeaverPay ERROR: $msg (Details: txn_id:'$txn_id', invoice:'$invoice')<br>\n".get_dump($vars));
}

// read post from BeaverPay system and add 'cmd'
$vars = $HTTP_POST_VARS;
$req = 'cmd=_notify-validate';
foreach ($vars as $k => $v) {
    if (get_magic_quotes_gpc())
        $vars[$k] = $v = stripslashes($v);
    $req .= "&" . urlencode($k) . "=" . urlencode ($v);
}

// assign posted variables to local variables
// note: additional IPN variables also available -- see IPN documentation
// https://www.beaverpay.com/beaverpay/user/glc_integration_manual.html#ipn_variables
$receiver_email = $vars['payee_email'];
$invoice        = $vars['transaction_ref'];
$payment_status = $vars['status'];
$payment_gross  = $vars['amount'];
$txn_id         = $vars['transaction_id'];
$secret_code    = $vars['secret_code'];

$db->log_error("beaverpay DEBUG<br>\n".get_dump($vars));

if ($secret_code != $this_config['secret_id'])
    beaverpay_error("False secret code: '$secret_code'");

// check that receiver_email is an email address
// in your beaverpay account
if ($receiver_email != $this_config['business'])
    beaverpay_error(
    "Payment receiver is '$receiver_email' instead of my business: '".
            $this_config['business'] . "'");

if ($payment_status != 'SUCCESS')
    beaverpay_error("Payment is not processed, status: '$payment_status'");

// process payment
$err = $db->finish_waiting_payment($invoice, 'beaverpay',
        $txn_id, $payment_gross, $vars);
if ($err)
    beaverpay_error("finish_waiting_payment error: $err");

?>