<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: CC CORE payment plugin
*    FileName $RCSfile: cc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.10 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*/

require_once("../../../config.inc.php");

function ask_cc_info($member, $payment, $vars=array(), $renew_cc_info=0, $errors=array()){
    global $cc_core, $t, $db, $config;
    // get a plugin config
    $plugin = $cc_core[$payment['paysys_id']];
    if (!is_object($plugin)) fatal_error("This plugin ({$payment['paysys_id']}) is not handled by cc_core!");
    $features = $plugin->get_plugin_features();
    ///

    /// 
    $c = $config;
    foreach (array('name', 'name_f', 'code', 'company', 'phone') as $f)
        $c['cc_' . $f] = intval($features[$f]);        
    if ($features['type_options'])
        $c['cc_type_options'] = $features['type_options'];
    $t->assign('config', $c);

    $cc_fields = array(
        'name_f', 'name_l', 'name', 
        'phone', 'company',
        'street', 'city', 'state', 'zip','country', 'type');
    $cc_address = array(); // prefilled fields
    foreach ($cc_fields as $f){
        $v = $vars['cc_' . $f];
        if (!isset($vars['cc_'. $f])) {
            if ($renew_cc_info) 
                if (!$v) $v = $member['data']['cc_'.$f];
            if (!$v) $v = $member[$f];
            if (!$v && ($f == 'name'))
                $v = $member['name_f'] . ' ' . $member['name_l'];
            if (!$v && ($f == 'phone'))
                $v = $member['data']['phone'];
            if (!$v && ($f == 'company'))
                $v = $member['data']['company'];
        }
        $cc_address['cc_'.$f] = $v;
    }

    $add_fields = array('enc_info' => serialize(array(
        'member_id' => $member['member_id'], 
        'payment_id' => $payment['payment_id'],
        'v' => $vars['v'],
        'action' => $vars['action'],
        'paysys_id' => $vars['paysys_id']
    )));            

    $t->assign('cc_address', $cc_address);
    $t->assign('add_fields', $add_fields);
    $t->assign('error', $errors);
    $t->assign('member', $member);
    $t->assign('payment', $payment);
    $t->assign('renew_cc', $renew_cc_info);
    $t->display('cc/cc_info.html');
}

function validate_cc_info($member, $payment, &$vars){
    global $cc_core, $t, $db, $config;
    // get a plugin config
    $plugin = $cc_core[$payment['paysys_id']];
    if (!is_object($plugin)) fatal_error("This plugin ({$payment['paysys_id']}) is not handled by cc_core!");
    $features = $plugin->get_plugin_features();
    ///
    $errors = array();
    // check credit card
    $vars['cc_number'] = preg_replace('/\D+/', '', $vars['cc_number']);
    $cc = $vars['cc_number'];
    if (strlen($cc) == 0) {
        $errors[] = "Please enter Credit Card Number";
    } elseif (strlen($cc) < 12) {
        $errors[] = "Invalid Credit Card Number";
    }
    if (($vars['cc_expire_Month'] < 1) or ($vars['cc_expire_Month']>12)){
        $errors[] = "Invalid Expiration Date - Month";
    }

    if ($vars['cc_expire_Year'] < date('Y')){
        $errors[] = "Invalid Expiration Date - Year";
    }

    if (!strlen($vars['cc_type']) && $features['type_options'])
        $errors[] = "Please choose a Credit Card Type";
    if (!strlen($vars['cc_code']) && $features['code'])
        $errors[] = "Please enter Credit Card Code";
    if (!strlen($vars['cc_name']) && $features['name'])
        $errors[] = "Please enter credit card holder name";
    if (!strlen($vars['cc_name_f']) && $features['name_f'])
        $errors[] = "Please enter credit card holder first name";
    if (!strlen($vars['cc_name_f']) && $features['name_f'])
        $errors[] = "Please enter credit card holder last name";
    if (!strlen($vars['cc_company']) && ($features['company']>1))
        $errors[] = "Please enter credit card company";
    if (!strlen($vars['cc_phone']) && ($features['phone']))
        $errors[] = "Please enter phone number";


    if (!strlen($vars['cc_street']))
        $errors[] = "Please enter street address";
    if (!strlen($vars['cc_city']))
        $errors[] = "Please enter city";
    if (!strlen($vars['cc_state']))
        $errors[] = "Please choose state";
    if (!strlen($vars['cc_zip']))
        $errors[] = "Please enter ZIP code";
    if (!strlen($vars['cc_country']))
        $errors[] = "Please choose country";

    if (method_exists($plugin,'validate_cc_form'))
        $errors += $plugin->validate_cc_form($vars);

    return $errors;
}

function get_charge_type($payment){
    global $db;
    $product_ids = (array)$payment['data'][0]['BASKET_PRODUCTS'];
    $product_ids[] = $payment['product_id'];
    $product_ids = array_unique($product_ids);
    $recurring = $price_sum = 0;
    foreach ($product_ids as $product_id){
        $pr = $db->get_product($product_id);
        $recurring += (int)$pr['is_recurring'];
        $price_sum += $pr['price'];
    }
    if ($payment['amount'] <= 0.0)
        return CC_CHARGE_TYPE_TEST;
    elseif ($recurring) 
        return CC_CHARGE_TYPE_START_RECURRING;
    else
        return CC_CHARGE_TYPE_REGULAR;
        
}

function save_cc_info($cc_info, $member, $paysys_id){
    global $cc_core, $t, $db, $config;
    // get a plugin config
    $plugin = $cc_core[$paysys_id];
    if (!is_object($plugin)) fatal_error("This plugin ({$paysys_id}) is not handled by cc_core!");
    $features = $plugin->get_plugin_features();

    $member['data']['cc-hidden'] = amember_crypt(preg_replace('/\D+/', '', $cc_info['cc_number']));
    $member['data']['cc'] = get_visible_cc_number($cc_info['cc_number']);
    $member['data']['cc-expire'] = sprintf('%02d%02d',
        $cc_info['cc_expire_Month'],
        substr($cc_info['cc_expire_Year'], 2, 2));
    if ($features['type_options'])
        $member['data']['cc_type'] = $cc_info['cc_type'];
    if ($features['code'] > 1)
        $member['data']['cc_code'] = $cc_info['cc_code'];
    if ($features['name'])
        $member['data']['cc_name'] = $cc_info['cc_name'];
    if ($features['name_f']) {
        $member['data']['cc_name_f'] = $cc_info['cc_name_f'];
        $member['data']['cc_name_l'] = $cc_info['cc_name_l'];
    }
    if ($features['company'])    
        $member['data']['cc_company'] = $cc_info['cc_company'];
    if ($features['phone'])
        $member['data']['cc_phone'] = $cc_info['cc_phone'];

    $member['data']['cc_street'] = $cc_info['cc_street'];
    $member['data']['cc_city'] = $cc_info['cc_city'];
    $member['data']['cc_state'] = $cc_info['cc_state'];
    $member['data']['cc_zip'] = $cc_info['cc_zip'];
    $member['data']['cc_country'] = $cc_info['cc_country'];

    $db->update_user($member['member_id'], $member);
}

function get_visible_cc_number($cc){
    $cc = preg_replace('/\D+/', '', $cc);
    return '**** **** **** '.substr($cc, -4);
}

function user_has_recurring_subscriptions($member){
    global $cc_core, $config, $db;
    $core_cc_plugins = array_keys($cc_core);
    foreach ($db->get_user_payments($member['member_id'], 1) as $p){
        if ($p['expire_date'] < date('Y-m-d')) continue;
        if ($p['data']['CANCELLED']) continue;
        if (!in_array($p['paysys_id'], $core_cc_plugins)) continue;
        $pr = $db->get_product($p['product_id']);
        if (!$pr['is_recurring']) continue;
        return 1;
    }
    return 0;
}

///////////////// M A I N //////////////////////////////////////////////
$t = & new_smarty();
$vars = get_input_vars();
if ($vars['enc_info'])
    foreach (unserialize($vars['enc_info']) as $k=>$v)
        $vars[$k] = $v;


settype($vars['member_id'], 'integer');
if (!$vars['member_id']) 
    fatal_error("Member id is empty", 0);
$member = $db->get_user($vars['member_id']);

if (get_cc_info_hash($member, $vars['action']) != $vars['v'])
    fatal_error("'v' has invalid value");

/// member is verified, lets continue
switch ($vars['action']){
    case 'mfp': // make first payment
        settype($vars['payment_id'], 'integer');
        if (!$vars['payment_id'])
            fatal_error("Payment_id empty");        
        $payment = $db->get_payment($vars['payment_id']);
        if ($payment['member_id'] != $vars['member_id'])
            fatal_error("Incorrect payment owner");
        if ($payment['completed']) 
            fatal_error("Payment is already processed, please go to <a href='$config[root_url]/member.php'>Membership page</a>", 0);
        // 
        if ($vars['do_cc']) {
            $errors = validate_cc_info($member, $payment, $vars);
            if (!$errors) {
                // determine kind of processing
                // returns CC_CHARGE_TYPE_REGULAR OR CC_CHARGE_TYPE_START_RECURRING
                $charge_type = get_charge_type($payment);
                $pr = get_product($payment['product_id']);
                // product has a trial, check it
                // check if member can be qualified for trial
                if ($pr->config['trial_group']){ 
                    $product_ids_used = array();
                    foreach ($db->get_user_payments($payment['member_id'], 1) as $p)
                        $product_ids_used[$p['product_id']]++;
                    // same trial products
                    $product_ids_denied = array();
                    foreach ($db->get_products_list() as $p)
                        if ($p['trial_group'] == $pr->config['trial_group'])
                            $product_ids_denied[] = $p['product_id'];
                    // now check
                    if (array_intersect($product_ids_denied,
                            array_keys($product_ids_used))){
                        ask_cc_info($member, $payment, $vars, 0, 
                        array("You signed-up for this trial subscription already  - please return back to 
                        <a href='{$config[root_url]}/signup.php'>signup page</a> and choose another product"));
                        break;
                    }
                    // now check for the same credit card
                    $payer_id = cc_core_get_payer_id($vars, $member);
                    $s = join(',', $product_ids_denied);
                    $q = $db->query($s = "SELECT COUNT(*)
                    FROM {$db->config[prefix]}payments
                    WHERE payer_id='$payer_id' AND product_id IN ($s)
                      AND completed > 0
                    ");
                    list($count_denied) = mysql_fetch_row($q);
                    if ($count_denied){
                        ask_cc_info($member, $payment, $vars, 0, 
                        array("You signed-up for this trial subscription already - please go to 
                        <a href='{$config[root_url]}/signup.php'>signup page</a> and choose another product"));
                        break;
                    }
                }
                /// run payment
                $plugin = $cc_core[$payment['paysys_id']];
                if (!is_object($plugin)) fatal_error("This plugin ({$payment['paysys_id']}) is not handled by cc_core!");
                $title = (count((array)$payment['data'][0]['BASKET_PRODUCTS']) > 1) ? 
                    $config['multi_title'] : $product['title'];
                // check that payment is not yet completed
                $p = $db->get_payment($payment['payment_id']);
                if ($p['completed']) 
                    fatal_error("Payment is already processed, please go to <a href='$config[root_url]/member.php'>Membership page</a>", 0);
                $vars1 = $vars;
                $vars1['cc-expire'] = sprintf('%02d%02d',
                           $vars['cc_expire_Month'],
                    substr($vars['cc_expire_Year'], 2, 2));
                $vars1['cc'] = get_visible_cc_number($vars['cc_number']);
                $x = list($res, $err_msg, $receipt_id, $log) = $plugin->cc_bill($vars1, $member, $payment['amount'],
                    $product[$payment['paysys_id'] . '_currency'], 
                    $title, $charge_type, $payment['payment_id'], $payment);
                $payment = $db->get_payment($payment['payment_id']);
                foreach ($log as $v)
                    $payment['data'][] = $v;
                $db->update_payment($payment['payment_id'], $payment);
                if ($res == CC_RESULT_SUCCESS){
                    $err = $db->finish_waiting_payment(
                        $payment['payment_id'], $payment['paysys_id'], 
                            $receipt_id, $payment['amount'], '', cc_core_get_payer_id($vars, $member));
                    if ($err) {
                        fatal_error($err . ": payment_id = $payment[payment_id]");
                    }
                    /// save cc info to db
                    if ($charge_type != CC_CHARGE_TYPE_REGULAR){
                        save_cc_info($vars, $member, $payment['paysys_id']);
                    }
                    /// display thanks page
                    $product = $db->get_product($payment['product_id']);
                    $member  = $db->get_user($payment['member_id']);
                    $t->assign('payment', $payment);
                    $t->assign('product', $product);
                    $t->assign('user', $member);
                    $t->display("thanks.html");

                } else {
                    ask_cc_info($member, $payment, $vars, 0, array("Payment failed: ".$err_msg));
                }
            } else
                ask_cc_info($member, $payment, $vars, 0, $errors);
        } else
            ask_cc_info($member, $payment, $vars, 0); 
    break;


    case 'cancel_recurring': // cancel recurring payment
        settype($vars['payment_id'], 'integer');
        if (!$vars['payment_id'])
            fatal_error("Payment_id empty");        
        $payment = $db->get_payment($vars['payment_id']);
        if ($payment['member_id'] != $vars['member_id'])
            fatal_error("Incorrect payment owner");
        // 
        $p = $db->get_payment($vars['payment_id']);
        $p['data']['CANCELLED'] = 1;
        $p['data']['CANCELLED_AT'] = strftime($config['time_format'], time());
        $db->update_payment($vars['payment_id'], $p);

        if (!user_has_recurring_subscriptions($member))
            clean_cc_info($member);

        // email to member if configured
        if ($config['payment'][$p['paysys_id']]['mail_cancel_admin']){
            $t->assign('user', $member);            
            $t->assign('payment', $p);
            $t->assign('product', $db->get_product($p['product_id']));
            $mail = $t->fetch("cc/mail_cancel_admin.txt");
            mail_admin($mail, "*** User subscription cancelled");
        }
        if ($config['payment'][$p['paysys_id']]['mail_cancel_member']){
            $t->assign('user', $member);            
            $t->assign('payment', $p);
            $t->assign('product', $db->get_product($p['product_id']));
            $mail = $t->fetch("cc/mail_cancel_member.txt");
            mail_customer($member['email'], $mail, "Subscription cancelled");
        }

        $t->assign('title', 'Subscription cancelled');
        $t->assign('msg', 'The recurring subscription has been cancelled.');
        $t->display("msg_close.html");
    
    break;

    case 'renew_cc': // make first payment
        if ($vars['do_cc']) {
            $errors = validate_cc_info($member, array('paysys_id' => $vars['paysys_id']), $vars);
            if (!$errors) {
                save_cc_info($vars, $member, $vars['paysys_id']);
                html_redirect("$config[root_surl]/member.php?cc_renew_done=1", 
                0, "Credit card info changed", "You will be automatically redirected to membership info page in about 2 seconds");

            } else 
                ask_cc_info($member, array('paysys_id' => $vars['paysys_id']), $vars, 1, $errors);    
        } else 
            ask_cc_info($member, array('paysys_id' => $vars['paysys_id']), $vars, 1, $errors);    
    break;

    default:
        fatal_error("Action is empty");
}

?>