<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: compuworld payment plugin
*    FileName $RCSfile: compuworld.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.1 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*/

global $config;
require_once($config['root_dir']."/plugins/payment/cc_core/cc_core.inc.php");

class payment_compuworld extends payment {
    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){
        return cc_core_do_payment('compuworld', $payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, $vars);
    }
    function get_cancel_link($payment_id){
        global $db;                            
        return cc_core_get_cancel_link('compuworld', $payment_id);
    }
    function get_plugin_features(){
        return array(
            'title' => 'CompuWorld',
            'description' => 'Credit card payment',
            'phone' => 2,
            'code' => 1,
            'name_f' => 2,
            'type_options' => array('VISA' => 'Visa', 'MASTERCARD' => 'MasterCard')
        );
    }

    /*************************************************************
      cc_bill - do real cc bill
    ***************************************************************/
    function cc_bill($cc_info, $member, $amount, 
        $currency, $product_description, 
        $charge_type, $invoice, $payment){
        global $config;
        $log = array();
        //////////////////////// cc_bill /////////////////////////
        if ($charge_type == CC_CHARGE_TYPE_TEST) 
            return array(CC_RESULT_SUCCESS, "", "", array('test transaction' => 'no validation'));
        $cc_info['cc_phone'] = preg_replace('/\D+/', '', $cc_info['cc_phone']);    
        $vars = array(
            'accountNumber' => $this->config['merchant_id'],
            'businessname'  => $this->config['merchant_name'],

            'errorCode'=>'',
            'errorDescription'=>'',
            'transactionNumber'=>'',
            'authorizationNumber'=>'',
            'refNumber'=>'',
            'type'=>'SALES',
            'subTotal'=>$amount,
            'shipping'=>0,
            'total'=>$amount,

            'billingFirstName' => $cc_info['cc_name_f'],
            'billingLastName' => $cc_info['cc_name_l'],
            'billingAddress' => $cc_info['cc_street'],
            'billingCity' => $cc_info['cc_city'],
            'billingState' => $cc_info['cc_state'],
            'billingZipCode' => $cc_info['cc_zip'],
            'billingCountry' => $cc_info['cc_country'],
            'billingPhoneAreaCode' => substr($cc_info['cc_phone'], 0, 3),
            'billingPhoneFirstSet' => substr($cc_info['cc_phone'], 3, 3),
            'billingPhoneSecondSet' => substr($cc_info['cc_phone'], 6, 4),
            'billingEmail' => $member['email'],
            'billingCreditCardType' => $cc_info['cc_type'],
            'billingCreditCardNumber' => $cc_info['cc_number'],
            'billingCreditCardExpMonth' => substr($cc_info['cc-expire'], 0, 2),
            'billingCreditCardExpYear' => '20'.substr($cc_info['cc-expire'], 2, 2),
            'billingIP' => $member['remote_addr'],

            'billingComments' => '',
            'billingCoupon' => '',

            'shippingFirstName' => $cc_info['cc_name_f'],
            'shippingLastName' => $cc_info['cc_name_l'],
            'shippingAddress' => $cc_info['cc_street'],
            'shippingCity' => $cc_info['cc_city'],
            'shippingState' => $cc_info['cc_state'],
            'shippingZipCode' => $cc_info['cc_zip'],
            'shippingCountry' => $cc_info['cc_country'],
            'shippingPhoneNumber' => $cc_info['cc_phone'],

            'couponCode' => '',
            'couponName' => '',
            'couponDescription' => '',
            'couponQuantity' => '',
            'couponPrice' => '',
            'couponTotal' => ''
        
        );
        if ($cc_info['cc_code']) 
            $vars['billingSecurityNumber'] = $cc_info['cc_code'];
        ////// get XML post 
        $post = "<info>\n";
        foreach ($vars as $k=>$v)
            $post .= "<$k>$v</$k>\n";
        ////// fill-in products list
        if ($payment['data'][0]['BASKET_PRODUCTS'])
            $product_ids = (array)$payment['data'][0]['BASKET_PRODUCTS'];
        else 
            $product_ids = array($payment['product_id']);
        foreach ($product_ids as $pid){
            global $db;
            $pr = $db->get_product($pid);
            $post .= "<product>\n";
            $post .= "  <productCode>$pid</productCode>\n";
            $post .= "  <productName>$pr[title]</productName>\n";
            $post .= "  <productDescription>$pr[title]</productDescription>\n";
            $post .= "  <productQuantity>1</productQuantity>\n";
            $post .= "  <productPrice>$pr[price]</productPrice>\n";
            $post .= "  <productTotal>$pr[price]</productTotal>\n";
            $post .= "</product>\n";
        }
        $post .= "</info>\n";
        // prepare log record
        $post_l = $post; 
        $post_l = str_replace($vars['billingCreditCardNumber'], $cc_info['cc'], $post_l);
        $post_l = str_replace($vars['billingSecurityNumber'], preg_replace('/./', '*', $vars['billingSecurityNumber']), $post_l);
        $log[] = array('POST' => '<pre>'.$post_l.'</pre>');
        /////
        foreach ($vars as $kk=>$vv){
            $v = urlencode($vv);
            $k = urlencode($kk);
            $vars1[] = "$k=$v";
        }
        $vars1 = join('&', $vars1);
        $socket = fsockopen("www.compu-world.net", 80, $errno, $errstr);
        if ($errno) {
            return array(CC_RESULT_INTERNAL_ERROR, "Cannot connect to the host: $errstr", "", $log);
        }
        $post_to_send = 
        "POST /payment/payment.aspx HTTP/1.0\r\n".
        "Host:www.compu-world.net\r\n". 
        "Content-Type: text/xml\r\n".
        "Content-Length: ".strlen($post). "\r\n\r\n".
        $post. "\r\n";
        fwrite($socket, $post_to_send); 
        while(!feof($socket)) 
            $buf .= fgets($socket, 2048); 
        fclose($socket);                
        $ret = $buf;

        //// parse XML response
        preg_match('/<info>(.+?)<\/info>/', $ret, $regs);
        preg_match_all('/<(.+?)>(.+?)<\/(.+?)>/', $regs[1], $matches);
        $res = array();
        foreach ($matches[1] as $k=>$fname)
            $res[$fname] = $matches[2][$k];

        $log[] = $res;

        switch ($res['status']){
        case 'APPROVED':
        case 'COMPLETED':
            return array(CC_RESULT_SUCCESS, "", $res['transactionNumber'], $log);
            break;
        case 'DENIED':
            return array(CC_RESULT_DECLINE_PERM, $res['errorDescription'], "", $log);
            break;
        case 'FAILED':
        default:
            return array(CC_RESULT_INTERNAL_ERROR, $res['errorDescription'], "", $log);
            break;
        }
    }
    function validate_cc_form(&$vars){ // additional validation of credit card info
        $p = preg_replace('/\D/', '', $vars['cc_phone']);
        $errors = array();
        if (strlen($p) != 10){
            $errors[] = "Please enter phone number in format 999-999-9999 (10 digits)";
        }
        return $errors;
    }
}

function compuworld_get_member_links($user){
    return cc_core_get_member_links('compuworld', $user);
}

function compuworld_rebill(){
    return cc_core_rebill('compuworld');
}

cc_core_init('compuworld');
?>