<?php
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: PayFlow PRO payment plugin class
*    FileName $RCSfile: iongate.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.4 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember is free for both commercial and non-commercial use providing that the
* copyright headers remain intact and the links remain on the html pages.
* Re-distribution of this script without prior consent is strictly prohibited.
*
*/
require_once("$config[root_dir]/plugins/payment/iongate/pay.inc.php");
    
setup_plugin_hook('get_member_links', 'iongate_get_member_links');
setup_plugin_hook('daily', 'iongate_rebill');

add_product_field(
            'is_recurring', 'Recurring Billing',
            'select', 'should user be charged automatically<br>
             when subscription expires',
            '',
            array('options' => array(
                '' => 'No',
                1  => 'Yes'
            ))
);

add_member_field(
        'cc_street',
        'Billing Street Address',
        'text', 
        "",
        '',
        array('hidden_anywhere' => 1)
);
add_member_field(
        'cc_city',
        'Billing City',
        'text', 
        "",
        ''
);
add_member_field(
        'cc_state',
        'Billing State',
        'select', 
        "",
        '', 
        array('options' => $config['state_options'])
);
add_member_field(
        'cc_zip',
        'Billing ZIP',
        'text', 
        "",
        ''
);
add_member_field(
        'cc_country',
        'Billing Country',
        'select', 
        "",
        '', 
        array('options' => $config['country_options'])
);

add_member_field(
        'cc',
        'Credit Card # (visible)',
        'readonly', 
        "credit card number (read-only)",
        '',
        array('hidden_anywhere' => 1)
);

add_member_field(
        'cc-hidden',
        'Credit Card # (crypted)',
        'hidden', 
        '',
        '',
        array('hidden_anywhere' => 1)
);

add_member_field(
        'cc-expire',
        'Credit Card Expire',
        'readonly', 
        'Expiration date (mmyy)',
        '',
        array('hidden_anywhere' => 1)
);

add_paysystem_to_list(
array(
            'paysys_id' => 'iongate',
            'title'     => 'IonGate',
            'description' => 'Credit Card payment',
            'public'    => 1,
            'recurring' => 1
        )
);

class payment_iongate extends payment {
    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){
        global $config;
        header("Location: $config[root_surl]/plugins/payment/iongate/cc.php?payment_id=$payment_id&member_id=$member_id");
        return '';
    }
    function get_cancel_link($payment_id){
        global $db;
        $p = $db->get_payment($payment_id);
        if (!$p['data']['CANCELLED'])
        return 
        "member.php?action=cancel_recurring&payment_id=$payment_id";
    }
}

function iongate_get_member_links($user){
    global $config;
    if ($user['data']['cc'])
        return array("$config[root_surl]/plugins/payment/iongate/cc.php?renew_cc=1&member_id=$user[member_id]" => 'Update CC info');
}

function iongate_rebill(){
    global $config, $db, $t;
    if (!$config['use_cron'])
        fatal_error("IonGate rebill can be run only with external cron");
    $dat = date('Y-m-d');
    $tomorrow = date('Y-m-d', time() + 3600 * 24);
    $payments = $db->get_expired_payments($dat, $dat, 'iongate');
    $renewed = array();
    $log = "IonGate Rebill\n";
    foreach ($payments as $p){
        if ($p['data']['CANCELLED']) 
            continue;
        $member_id = $p['member_id'];
        $member = $db->get_user($member_id);
        $product_id = $p['product_id'];
        if ($renewed[$member_id][$product_id]++) continue;
        $product = & get_product($product_id);
        if (!$product->config['is_recurring']) continue;
        $vars = array(
            'RENEWAL_ORIG' => "RENEWAL_ORIG: $p[payment_id]"
        );
        $payment_id = $db->add_waiting_payment($member_id, $product_id, 
            'iongate', $product->config['price'], 
             $dat, $product->get_expire($dat), 
             $vars);
        list($err, $errno) = iongate_payment($payment_id, $member_id);
        if ($errno>1){
            mail_rebill_failed_member($member, $payment_id, $product, "$err ($errno)");
        } elseif (!$errno){
            $db->log_error("no return from IonGate, payment #$payment_id");
        } elseif ($errno == 1) {
            $err = "COMPLETED";
            mail_rebill_success_member($member, $payment_id, $product);
        }
        $log .= "login: $p[member_login] payment#: $payment_id: $err ($errno)\n";
    }
#    print $log;
}

?>
