<?php
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: PayFlow Pro payment interface via perl script
*    FileName $RCSfile: pay.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.3 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember is free for both commercial and non-commercial use providing that the
* copyright headers remain intact and the links remain on the html pages.
* Re-distribution of this script without prior consent is strictly prohibited.
*
*/

function iongate_get_card_type($cc_number){
        if (ereg ('^4(.{12}|.{15})$', $cc_number)) 
            return 'VISA';
        elseif (ereg ('^5[1-5].{14}$', $cc_number)) 
            return 'MASTERCARD';
        elseif (ereg ('^3[47].{13}$', $cc_number))
            return 'AMEX';
        elseif (ereg ('^6011.{12}$', $cc_number))
            return 'DISCOVER';
        elseif (ereg ('^3(0[0-5].{11}|[68].{12})$', $cc_number))
            return 'DINERS';
        elseif (ereg ('^(3.{15}|(2131|1800).{11})$', $cc_number)) 
            return 'JCB';
        else
         return "UNKNOWN";
}

function iongate_payment($payment_id, $member_id){
    set_time_limit(600);
    ignore_user_abort(true);
    // first prepare all variables
    global $db, $config, $plugin_config;
    $this_config   = $plugin_config['payment']['iongate'];
    if (!$this_config['login']) fatal_error("No username configured for IonGate");
    $payment = $db->get_payment($payment_id);
    if (!$payment)
        return array("Payment not found: #$payment_id", -900);
    if ($payment['completed'])
        return array("Payment already completed: #$payment_id", -901);
    if ($payment['paysys_id'] != 'iongate')
        return array("Payment created for another payment system: '$payment[paysys_id]' (#$payment_id)", -902);
    if ($payment['member_id'] != $member_id)
        return array("Payment created for another member: #$payment_id", -903);

    $member = $db->get_user($payment['member_id']);
    if (!$member) 
        return array("Member not found: #$member_id", -904); 
    $cc_number = amember_decrypt($member['data']['cc-hidden']);
    $cc_expire = $member['data']['cc-expire'];
    $cc_type   = iongate_get_card_type($cc_number);

    ///// !!! run transaction
    $url_proc = "https://secure.iongate.com/iongate.asp";
    session_start();
    if (!$_SESSION['_amember_payment_try'] || ($_SESSION['_amember_payment_try']>87))
        $_SESSION['_amember_payment_try'] = 65;
    $vars = array(
        "LOGIN"     => $this_config['login'],
        "AMOUNT" =>   $payment['amount'],
        "CARDTYPE" => $cc_type,
        "CARDNUM" => $cc_number,
        "EXPIRES" => $cc_expire,
        "CARDNAME" =>  $member['name_f'] . ' ' . $member['name_l'],
        "INVOICENO" => $payment_id . ' ' . strtolower(chr($_SESSION['_amember_payment_try']++)),
        "PHONE" =>    $member['data']['phone'],
        "EMAIL" =>    $member['email'],
        "CUSTNO" =>  $member_id,
        "RECEIPTURL" => "DISPLAY"

    );
    if ($this_config['testing'])
        $vars['x_Test_Request'] = 'TRUE';

    $vars = $vars + array(
    "ADDRESS" =>  $member['data']['cc_street'],
    "CITY" =>     $member['data']['cc_city'],
    "STATE" =>    strtoupper($member['data']['cc_state']),
    "ZIP" =>      $member['data']['cc_zip'],
    "COUNTRY" =>  $member['data']['cc_country']
    ); 
    foreach ($vars as $kk=>$vv){
        $v = urlencode($vv);
        $k = urlencode($kk);
        $vars1[] = "$kk=$vv";
    }

    $vars_cc = $vars; 
    $vars_cc['x_Card_Num'] = $member['data']['cc'];
    $payment['data'][] = $vars_cc;
    $db->update_payment($payment_id, $payment);

    $buffer = get_url($url_proc, join('&', $vars1));
    $buffer = str_replace('<h2>IONGATE Return Values</h2>', '', $buffer);
    $buffer = preg_split('/\<br\>/i', $buffer);
    $res = array();
    foreach ($buffer as $s){
        list($k,$v) = explode("=", $s);
        $return[$k] = $v;
    }

    $return['RESULT']      = $return['RESPONSECODE'];
    $return['RESPMSG']   = $return['AUTHRESPONSE'];

//    print_r($return);

    ////////////// check transaction result   ////////////////////////////
    if (!isset($return['RESULT'])){
        $db->log_error("Empty result, payment handling failed #$payment_id");
        return array("aMember: Empty result from processor, payment handling failed", 3);
    } elseif ($return['RESULT'] == 'AA') {
        $db->finish_waiting_payment($payment_id, 'iongate', 
            $return['PNREF'], '', $return);
        return array('', 1);
    } elseif ($return['RESULT'] == 2) {
        $payment['data'][] = $return;
        $db->update_payment($payment_id, $payment);
        return array($return['RESPMSG'], 2);
    } else  { //$return > 2 or unknown
        $payment['data'][] = $return;
        $db->log_error($return['RESPMSG']);
        $db->update_payment($payment_id, $payment);
        return array("Payment processor error: ".
        (($return['RESPMSG']) ? ($return['RESPMSG']) : $buffer), 
        2);
    }
    return array($return['RESPMSG'], 2); //dummy!
}

?>
