<?php
/*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: linkpoint payment plugin config
*    FileName $RCSfile: config.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.3 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*/

global $config;
require_once($config['root_dir']."/plugins/payment/cc_core/cc_core.inc.php");
include_once(dirname(__FILE__)."/lpphp.php");

$notebook_page = "LinkPoint";

config_set_notebook_comment($notebook_page, $notebook_page . ' configuration');
if (file_exists($rm = dirname(__FILE__) . "/readme.txt"))
    config_set_readme($notebook_page, $rm);

add_config_field('payment.linkpoint.host', 'LinkPoint Host', 'text', 
    "Your LinkPoint host (e.g. secure.linkpt.net).", $notebook_page, ''
);

add_config_field('payment.linkpoint.port', 'LinkPoint Port', 'text', 
    "Your LinkPoint host connection port (e.g. 1139).", $notebook_page, ''
);

add_config_field('payment.linkpoint.storename', 'LinkPoint Default Storename', 'text', 
    "Your default LinkPoint storename (usually a number, e.g. 123456).", $notebook_page, ''
);

add_config_field('payment.linkpoint.keypath', 'LinkPoint Default Key File Path', 'text', 
    "Supply the complete local path to the default key file<br>
    (e.g. /home/user/domain.com/cgi-bin/123456.pem).<br>
    It is highly recommended you store this file outside<br>
    your web directory for security reasons.<br>
    The key file is generated by LinkPoint and<br>
    emailed directly to you as a file (e.g. 123456.pem)<br>
    with your initial configuration information. <br>
    The file name usually matches your storename and<br>
    ends with '.pem'.  Contact LinkPoint support with<br>
    questions: www.linkpoint.com",
    $notebook_page, ''
);

add_config_field('payment.linkpoint.testing', 'Test Mode Enabled', 'select', 
    "Set to No after you complete testing.", $notebook_page, '','','',
    array('options' => array(0 => 'No', 1 => 'Yes'))
);

cc_core_add_config_items('linkpoint', $notebook_page);

?>