<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: The installation file
*    FileName $RCSfile: ipn.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.3 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember is free for both commercial and non-commercial use providing that the
* copyright headers remain intact and the links remain on the html pages.
* Re-distribution of this script without prior consent is strictly prohibited.
*
*/

include "../../../config.inc.php";

$this_config = $plugin_config['payment']['moneybookers'];

function get_dump($var){
//dump of array
    $s = "";
    foreach ((array)$var as $k=>$v)
        $s .= "$k => $v<br>\n";
    return $s;
}


function validate_md5($vars){
    global $this_config;
    $val = 
        $vars['merchant_id'] . 
        $vars['transaction_id'] . 
        $this_config['password'] . 
        $vars['mb_amount'] . 
        $vars['mb_currency'] . 
        $vars['status'];
    if ($m=strtoupper(md5($val)) != $vars['md5sig'])
        moneybookers_error("MD5 has incorrect: we got '$vars[md5sig]', but calculated is '$m' (from '$val')");
}

function moneybookers_error($msg){
    global $txn_id, $invoice;
    global $vars;
    fatal_error("moneybookers ERROR: $msg (Details: txn_id:'$txn_id', invoice:'$invoice')<br>\n".get_dump($vars));
}


if (!$vars['md5sig'])
    moneybookers_error("This page shouldn't be accessed from browser");

validate_md5($vars);

// assign posted variables to local variables
// note: additional IPN variables also available -- see IPN documentation
$receiver_email = $vars['pay_to_email'];
$invoice        = $vars['transaction_id'];
$payment_status = $vars['status'];
$payment_gross  = $vars['amount'];
$payment_currency  = $vars['currency'];
$txn_id         = $vars['mb_transaction_id'];

$db->log_error("moneybookers DEBUG<br>\n".get_dump($vars));

// check that receiver_email is an email address 
// in your moneybookers account
if ($receiver_email != $this_config['business']) 
    moneybookers_error(
    "Payment receiver is '$receiver_email' instead of my business: '".
            $this_config['business'] . "'");

if ($payment_status != 2)
    moneybookers_error("Payment is not processed, status: '$payment_status'");

// process payment
$err = $db->finish_waiting_payment($invoice, 'moneybookers', 
        $txn_id, $payment_gross, $vars);
if ($err) 
    moneybookers_error("finish_waiting_payment error: $err");

?>
