<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: The installation file
*    FileName $RCSfile: moneybookers.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.6 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember is free for both commercial and non-commercial use providing that the
* copyright headers remain intact and the links remain on the html pages.
* Re-distribution of this script without prior consent is strictly prohibited.
*
*/

add_paysystem_to_list(
array(
            'paysys_id' => 'moneybookers',
            'title'     => 'MoneyBookers',
            'description' => 'See <a href="http://www.moneybookers.com" target=_blank>www.moneybookers.com</a> for description',
            'public'    => 1
        )
);

add_product_field('moneybookers_currency', 
    'moneybookers Currency',
    'select',
    'valid only for moneybookers processing.<br> You should not change it<br> if you use 
    another payment processors',
    '',
    array('options' => array(
        ''    => 'USD',
        'GBP' => 'GBP',
        'EUR' => 'EUR',
        'CAD' => 'CAD',
        'JPY' => 'JPY'
    ))
    );

class payment_moneybookers extends payment {
    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){

        global $config, $db;
        $products = $product_id;
        $orig_product_id = $product_id;
        if (is_array($product_id))
             $product_id = $product_id[0];

        $product = & get_product($product_id);
        if (count($orig_product_id)>1)
            $product->config['title'] = $config['multi_title'];

        $member = $db->get_user($member_id);

        $vars = array(
            'pay_to_email'    => $this->config['business'],
            'pay_from_email'  => $member['email'],
            'transaction_id'  => $payment_id,
            'return_url'      => 
               sprintf("%s/thanks.php?member_id=%d&product_id=%d",
                $config['root_url'],
                $member_id, $product_id),
            'cancel_url' => $config['root_url']."/cancel.php",
            'status_url'  => $config['root_url'].
                             "/plugins/payment/moneybookers/ipn.php",
            'amount'      => sprintf('%.2f', $price),
            'detail1_text' => $product->config['title'],

            'firstname' => $member['name_f'],
            'lastname'  => $member['name_l'],
            'address'   => $member['street'],
            'postal_code' => $member['zip'],
            'city'      => $member['city'],
            'state'     => $member['state'],
            'country'   => $member['country']
        );

        // add currency code
        if (strlen($product->config['moneybookers_currency'])){
            $vars['currency'] = $product->config['moneybookers_currency'];
        } else {
            $vars['currency'] = 'USD';
        }

        $vars1 = array();
        foreach ($vars as $kk=>$vv){
            $v = urlencode($vv);
            $k = urlencode($kk);
            $vars1[] = "$k=$v";
        }
        $vars = join('&', $vars1);
        header("Location: https://www.moneybookers.com/app/payment.pl?$vars");
        exit();
    }
}

?>
