<?php 
$notebook_page = 'PayFlow Pro';
config_set_notebook_comment($notebook_page, 'PayFlow Pro configuration');
if (file_exists($rm = dirname(__FILE__)."/readme.txt"))
    config_set_readme($notebook_page, $rm);

add_config_field('payment.payflow_pro.login', 'PayflowPro login',
    'text', "your PayFlow Pro Username",
    $notebook_page, 
    '');
add_config_field('payment.payflow_pro.partner', 'PayflowPro partner',
    'text', "your PayFlow Pro Partner",
    $notebook_page, 
    '');
add_config_field('payment.payflow_pro.password', 'PayFlow Pro Password',
    'password_c', "your PayFlow Pro Password",
    $notebook_page, 
    'validate_password', '', '',
    array('store_type' => 3));
add_config_field('payment.payflow_pro.sdk_path', 'PayFlow Pro binary location',
    'text', "where bin folder from PayFlow SDK located",
    $notebook_page, 
    'validate_pfpro_sdk_path');
add_config_field('payment.payflow_pro.testing', 'Test Mode Enabled',
    'select', "set to No after you complete testing",
    $notebook_page, 
    '','','',
    array('options' => array(0 => 'No', 1 => 'Yes')));

cc_core_add_config_items('payflow_pro', $notebook_page);

function validate_pfpro_sdk_path($field, $vars){
    $fname = str_replace('.', '_', $field['name']);
    $win = preg_match('/^Windows/', php_uname());
    $f = $vars[$fname] . "/" . ($win ? "pfpro.exe" : "pfpro");
    if (!file_exists($f))
        return "Incorrect value for $field[title] - file $f is not exists";
    if (!$win && !is_executable($f))
        return "File $f exists, but not executable. Please chmod file 755, then back to this screen and press Save again";
}

?>
