<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: payflow_pro payment plugin
*    FileName $RCSfile: payflow_pro.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.7 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*/

global $config;
require_once($config['root_dir']."/plugins/payment/cc_core/cc_core.inc.php");

class payment_payflow_pro extends payment {
    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){
        return cc_core_do_payment('payflow_pro', $payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, $vars);
    }
    function get_cancel_link($payment_id){
        global $db;                            
        return cc_core_get_cancel_link('payflow_pro', $payment_id);
    }
    function get_plugin_features(){
        return array(
            'title' => 'PayFlow Pro',
            'description' => 'Credit card payment',
            'code' => 1,
            'name_f' => 2
        );
    }

    function run_transaction($vars){
        $win = preg_match('/^Windows/', php_uname());
        if ($win){
            $exec  = $this->config['sdk_path'] . "/pfpro.exe";
            if (!is_file($exec)){
                fatal_error("PayFlow plugin configuration error: file <i>$exec</i> is not exists");
            }
        } else {
            $exec  = dirname(__FILE__) . "/pfpro.sh";
            if (!is_executable($exec)){
                fatal_error("PayFlow plugin configuration error: file <i>$exec</i> is not executable. Please chmod this file 755");
            }
            $exec .= " " . escapeshellarg($this->config['sdk_path']);
        }
        $exec .= " ";
        $exec .= $this->config['testing'] ? 'test-payflow.verisign.com ' : 'payflow.verisign.com ';
        $exec .= '443 "';
        $execx = array();
        foreach ($vars as $k=>$v)
            $execx[]=urlencode($k).'='.urlencode($v);
        $exec .= join('&', $execx);
        $exec .= '" 2>&1';
        //print $exec;
        $f=popen($exec, 'r');
        if (!$f) fatal_error("Cannot run payment script");
        $l='';
        while (!feof($f)){
            $l.=fread($f, 1024);
        }
        if (!preg_match('/\w+=\w+/', $l))
            return array("RESPMSG" => "Error running pfpro script, result returned: $l");
        pclose($f);
        parse_str($l, $res);
        return $res;
    }

    function void_transaction($pnref, &$log){
        $vars = array(
            "PARTNER"   => $this->config['partner'],
            "USER"      => $this->config['login'],
            "VENDOR"    => $this->config['login'],
            "PWD"       => $this->config['password'],
            "TENDER"    => "C",
            "TRXTYPE"   => "V",
            "ORIGID"    => $pnref,
        );
        $vars_l = $vars;
        $vars_l['PWD'] = preg_replace('/./', '*', $vars['PWD']);
        $log[] = $vars_l;
        $res = $this->run_transaction($vars);
        $log[] = $res;
        return $res;
    }

    /*************************************************************
      cc_bill - do real cc bill
    ***************************************************************/
    function cc_bill($cc_info, $member, $amount, 
        $currency, $product_description, 
        $charge_type, $invoice, $payment){
        global $config;
        $log = array();
        //////////////////////// cc_bill /////////////////////////
        if ($charge_type == CC_CHARGE_TYPE_TEST) 
            $amount = "1.00";
        $vars = array(
            "PARTNER"   => $this->config['partner'],
            "USER"      => $this->config['login'],
            "VENDOR"    => $this->config['login'],
            "PWD"       => $this->config['password'],
            "AMT"       => $amount,
            "ACCT"      => $cc_info['cc_number'],
            "EXPDATE"   => $cc_info['cc-expire'],
            "TENDER"    => "C",
            "TRXTYPE"   => "S",
            "COMMENT2"  => $member['login'],
            "COMMENT1"  => $invoice,
            "NAME"      => $cc_info['cc_name_f'] . ' '. $member['cc_name_l'],
            "STREET"    => $cc_info['cc_street'],
            "ZIP"       => $cc_info['cc_zip']
        );
        if ($cc_info['cc_code']) 
            $vars['CVV2'] = $cc_info['cc_code'];
        // prepare log record
        $vars_l = $vars; 
        $vars_l['ACCT'] = $cc_info['cc'];
        if ($vars['CVV2'])
            $vars_l['CVV2'] = preg_replace('/./', '*', $vars['trnCardCvd']);
        $vars_l['PWD'] = preg_replace('/./', '*', $vars['PWD']);
        $log[] = $vars_l;
        /////
        $res = $this->run_transaction($vars);
        $log[] = $res;
        if ($res['RESULT']=='0'){
            if ($charge_type == CC_CHARGE_TYPE_TEST){
                /// void transaction if transaction type is test
                $this->void_transaction($res['PNREF'], $log);
            } elseif (($res['AVSADDR']=='N') && ($res['AVSZIP'] == 'N')
                 && ($charge_type != CC_CHARGE_TYPE_RECURRING)) {
                 /// void transaction if there is AVS mismatch
                 $this->void_transaction($res['PNREF'], $log);
                 $msg = "Card declined. Make sure address entered matches your credit card statement delivery address";
                 return array(CC_RESULT_DECLINE_PERM, $msg, "", $log);
            }
            return array(CC_RESULT_SUCCESS, "", $res['PNREF'], $log);
        } elseif ($res['RESULT'] > 0) {
            return array(CC_RESULT_DECLINE_PERM, $res['RESPMSG'], "", $log);
        } else {
            return array(CC_RESULT_INTERNAL_ERROR, $res['RESPMSG'], "", $log);
        }
    }
}

function payflow_pro_get_member_links($user){
    return cc_core_get_member_links('payflow_pro', $user);
}

function payflow_pro_rebill(){
    return cc_core_rebill('payflow_pro');
}

cc_core_init('payflow_pro');
?>