<?php
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: PayFlow Pro payment interface via perl script
*    FileName $RCSfile: pay.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.8 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember is free for both commercial and non-commercial use providing that the
* copyright headers remain intact and the links remain on the html pages.
* Re-distribution of this script without prior consent is strictly prohibited.
*
*/

function paymentsgatway_get_url($url, $post=''){
//    print $post;
    if (extension_loaded("curl")){
        $ch=curl_init($url);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt ($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post);  
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);    
        $buffer = curl_exec($ch);                       
        curl_close($ch);
        return $buffer;
    } else {
        global $config;
        if (substr(php_uname(), 0, 7) == "Windows") {
            $curl = $config['curl'];
            if (!strlen($curl)) fatal_error("cURL path is not set");
        } else {
            $curl = escapeshellcmd($config['curl']);
            if (!strlen($curl)) fatal_error("cURL path is not set");
//            $post = escapeshellcmd($post);
            $url = escapeshellcmd($url);
        }
        $ret=`$curl -d "$post" $url`;
        return $ret;
    }
}

function paymentsgateway_payment($payment_id, $member_id, $cc_details=false){
    set_time_limit(600);
    ignore_user_abort(true);
    // first prepare all variables
    global $db, $config, $plugin_config;
    $this_config   = $plugin_config['payment']['paymentsgateway'];
    if (!$this_config['merchant_id']) fatal_error("No username configured ");
    if (!$this_config['password']) fatal_error("No password configured");
    $payment = $db->get_payment($payment_id);
    if (!$payment)
        return array("Payment not found: #$payment_id", -900);
    if ($payment['completed'])
        return array("Payment already completed: #$payment_id", -901);
    if ($payment['paysys_id'] != 'paymentsgateway')
        return array("Payment created for another payment system: '$payment[paysys_id]' (#$payment_id)", -902);
    if ($payment['member_id'] != $member_id)
        return array("Payment created for another member: #$payment_id", -903);

    $member = $db->get_user($payment['member_id']);
    if (!$member) 
        return array("Member not found: #$member_id", -904); 
    if ($cc_details){
        $cc_number = $cc_details['cc_number'];
        $cc_expire = $cc_details['cc_expire'];
    } else {
        $cc_number = amember_decrypt($member['data']['cc-hidden']);
        $cc_expire = $member['data']['cc-expire'];
    }

    ///// !!! run transaction
    if ($this_config['live'])
        $url_proc = "https://www.paymentsgateway.net/cgi-bin/postauth.pl";
    else
        $url_proc = "https://www.paymentsgateway.net/cgi-bin/posttest.pl";
    $avs_method='';
    for ($i=0;$i<5;$i++)
        $avs_method .= intval($this_config["avs_method$i"]);

    $vars = array(
        "pg_merchant_id" => $this_config['merchant_id'],
        "pg_password" => $this_config['password'],
        "pg_transaction_type" => 10,
        "pg_total_amount" => $payment['amount'],

        "Ecom_BillTo_Postal_Name_First" => $member['name_f'],
        "Ecom_BillTo_Postal_Name_Last" => $member['name_l'],
        "Ecom_BillTo_Online_Email" => $member['email'],
        "Ecom_BillTo_Postal_Street_Line1" => $member['data']['cc_street'],
        "Ecom_BillTo_Postal_City" => $member['data']['cc_city'],
        "Ecom_BillTo_Postal_Stateprov" => $member['data']['cc_state'],
        "Ecom_BillTo_Postal_PostalCode" => $member['data']['cc_zip'],
        "Ecom_BillTo_Postal_CountryCode" => $member['data']['cc_country'],

        "Ecom_Payment_Card_Name" => $member['name_f'] . " " . $member['name_l'],
        "Ecom_Payment_Card_Type" => $member['data']['cc_type'],
        "Ecom_Payment_Card_Number" => $cc_number,
        "Ecom_Payment_Card_ExpDate_Month" => substr($cc_expire, 0, 2),
        "Ecom_Payment_Card_ExpDate_Year" => '20'.substr($cc_expire, 2, 2),

        "pg_avs_method" => $avs_method,
    );
    foreach ($vars as $kk=>$vv){
        $v = urlencode($vv);
        $k = urlencode($kk);
        $vars1[] = "$kk=$vv";
    }
    $vars_cc = $vars; 
    unset($vars_cc['pg_merchant_id']);
    unset($vars_cc['pg_password']);

    $vars_cc['Ecom_Payment_Card_Number'] = $member['data']['cc'];
    $payment['data'][] = $vars_cc;
    $db->update_payment($payment_id, $payment);

    $buffer = paymentsgatway_get_url($url_proc, join('&', $vars1).'&endofdata&');
    parse_str($b=preg_replace("/[\n\r]+/", "&", $buffer), $res);
//    print_r( $vars1);

    $return['RESULT']      = $res['pg_response_type'];
    $return['REASON_CODE'] = $res['pg_response_code'];
    $return['RESPMSG']     = $res['pg_response_description'];
    $return['AVS']         = $res['pg_avs_result'];
    $return['PNREF']       = $res['pg_trace_number'];

    ////////////// check transaction result   ////////////////////////////
    if (!isset($return['RESULT'])){
        $db->log_error("Empty result, payment handling failed #$payment_id");
        return array("aMember: Empty result from processor, payment handling failed", 3);
    } elseif ($return['RESULT'] == 'A') {
        $db->finish_waiting_payment($payment_id, 'paymentsgateway', 
            $return['PNREF'], '', $return);
        return array('', $return['RESULT']);
    } elseif ($return['RESULT'] == 'D') {
        $payment['data'][] = $return;
        $db->update_payment($payment_id, $payment);
        return array($return['RESPMSG'], $return['RESULT']);
    } else  { //$return > 2 or unknown
        $payment['data'][] = $return;
        $db->log_error($return['RESPMSG']);
        $db->update_payment($payment_id, $payment);
        return array("Payment processor error: ".$return['RESPMSG'], $return['RESULT']);
    }
    return array($return['RESPMSG'], $return['RESULT']); //dummy!
}

?>
