<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: The installation file
*    FileName $RCSfile: paypal.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.7.6.2.2.8 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember is free for both commercial and non-commercial use providing that the
* copyright headers remain intact and the links remain on the html pages.
* Re-distribution of this script without prior consent is strictly prohibited.
*
*/

add_paysystem_to_list(
array(
            'paysys_id' => 'paypal',
            'title'     => 'PayPal',
            'description' => 'See <a href="http://www.paypal.com" target=_blank>www.paypal.com</a> for description',
            'public'    => 1
        )
);

add_product_field('paypal_currency', 
    'PayPal Currency',
    'select',
    'valid only for PayPal processing.<br> You should not change it<br> if you use 
    another payment processors',
    '',
    array('options' => array(
        '' => 'USD',
        'GBP' => 'GBP',
        'EUR' => 'EUR',
        'CAD' => 'CAD',
        'JPY' => 'JPY'
    ))
    );

class payment_paypal extends payment {
    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){

        global $config;
        $products = $product_id;
        $orig_product_id = $product_id;
        if (is_array($product_id))
             $product_id = $product_id[0];

        $product = & get_product($product_id);
        if (count($orig_product_id)>1)
            $product->config['title'] = $config['multi_title'];

        $vars = array(
            'cmd'         => '_xclick',
            'business'    => $this->config['business'],
            'return'      => 
               sprintf("%s/thanks.php?payment_id=%d&member_id=%d&product_id=%d",
                $config['root_url'],
                $payment_id, $member_id, $product_id),
            'notify_url'  => $config['root_url'].
                             "/plugins/payment/paypal/ipn.php",
            'item_name'   => $product->config['title'],
            'item_number' => $product_id,
            'no_shipping' => 1,
            'cancel_return' => $config['root_url']."/cancel.php",
            'no_note'     => 1,
            'bn'          => 'CgiCentral.aMemberFree',
            'amount'      => sprintf('%.2f', $price),
            'custom'      => $member_id,
            'invoice'     => $payment_id.'-'.substr($payment_id, 0,1)
        );
        // add currency code
        if (strlen($product->config['paypal_currency'])){
            $vars['currency_code'] = $product->config['paypal_currency'];
        };

        $vars1 = array();
        foreach ($vars as $kk=>$vv){
            $v = urlencode($vv);
            $k = urlencode($kk);
            $vars1[] = "$k=$v";
        }
        $vars = join('&', $vars1);
        header("Location: https://www.paypal.com/cgi-bin/webscr?$vars");
        exit();
    }
}

?>
