<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: The installation file
*    FileName $RCSfile: ipn.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.6.9.4.14 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
*
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*
*/

include "../../../config.inc.php";

function paypal_r_get_url($url, $post=''){
    if (extension_loaded("curl")){
        $ch=curl_init($url);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post);  
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);    
        $buffer = curl_exec($ch);                       
        curl_close($ch);
        return $buffer;
    } else {
        global $config, $db;
        if (substr(php_uname(), 0, 7) == "Windows") {
            $curl = $config['curl'];
            if (!strlen($curl)) $db->log_error("cURL path is not set");
        } else {
            $curl = escapeshellcmd($config['curl']);
            if (!strlen($curl)) $db->log_error("cURL path is not set");
//            $post = escapeshellcmd($post);
            $url = escapeshellcmd($url);
        }
        $ret=`$curl -d "$post" $url`;
        return $ret;
    }
}

$this_config = $config['payment']['paypal_r'];

function get_dump($var){
//dump of array
    $s = "";
    foreach ((array)$var as $k=>$v)
        $s .= "$k => $v<br>\n";
    return $s;
}

function paypal_error($msg){
    global $txn_id, $invoice;
    global $vars;
#    header("Status: 500 Internal Server Error");
    fatal_error("PAYPAL ERROR: $msg (Details: txn_id:'$txn_id', invoice:'$invoice')<br>\n".get_dump($vars));
}

function r_send_unverified_warning($vars){
    global $config;

    $t = & new_smarty();
    $t->template_dir = dirname(__FILE__);
    $t->assign('vars', $vars);
    $t->assign('config', $config);
    // mail to customer
    mail_customer($vars['payer_email'], $t->fetch('c_pending_mail.txt'));
    // mail to admin
    mail_customer($config['admin_email'], $t->fetch('a_pending_mail.txt'));
}

function check_periods($vars, $payment){
    global $db;

    $terms = $payment['data']['paypal_vars'];
    if (!$terms) return;
    $terms = @unserialize($terms);
    if (!$terms) return;

    //check currency
    $curr = $terms['currency_code'] ? $terms['currency_code'] : "USD";
    if ($vars['mc_currency'] != $curr) 
        paypal_error("Incorrect currency: '$vars[mc_currency]', must be '$curr'");

    $prefix = ($curr != 'USD') ? 'mc_' : '';
    
    // check rates and periods
    for ($i=1;$i<=3;$i++){
        $a = $terms["a$i"]; 
        $p = $terms["p$i"]; 
        $t = strtolower($terms["t$i"]);
        $aa = $vars["{$prefix}amount{$i}"];
        list($pp, $tt) = preg_split('/\s+/', strtolower($vars["period$i"]));
        if ($a != $aa)
            paypal_error("a$i != aa$i: '$a' != '$aa'");
        if ($p != $pp)
            paypal_error("p$i != pp$i: '$p' != '$pp'");
        if ($t != $tt)
            paypal_error("t$i != tt$i: '$t' != '$tt'");
    }
}

// find payment by 'invoice' or by 'receipt_id'
function paypal_r_find_payment($vars){
    $x = intval($vars['invoice']);
    if ($x) return $x;
    global $db;  // try to find payment with this subscription id
    $s = $db->escape($vars['subscr_id']);
    if (!$s) return;
    $q = $db->query("SELECT payment_id
        FROM {$db->config[prefix]}payments
        WHERE receipt_id='$s' AND paysys_id='paypal_r'
    ");
    list($x) = mysql_fetch_row($q);
    if ($x) return $x;
}

function process_signup($vars){
    global $db;
    $payment_id = paypal_r_find_payment($vars);
    if (!$payment_id)
        paypal_error("Cannot find corresponding aMember payment record for this payment");
    check_periods($vars, $db->get_payment($payment_id)); //raises exception
    $err = $db->finish_waiting_payment($payment_id,
         'paypal_r', $vars['subscr_id'], '', $vars, $vars['payer_id']);
    if ($err) 
        paypal_error("process_signup: error in finish_waiting_payment: $err");
    $p = $db->get_payment($payment_id);
    $p['begin_date']  = date('Y-m-d');
    if ($vars['recurring']) 
        $p['expire_date'] = '2012-12-31';
    $p['amount'] = calculate_total($p['data']);
    $db->update_payment($payment_id, $p);
}

function process_eot($vars){
    global $db;
    $payment_id = paypal_r_find_payment($vars);
    if (!$payment_id)
        paypal_error("Cannot find corresponding aMember payment record for this payment");
    $p = $db->get_payment($payment_id);
    $new_expire = date('Y-m-d', time() - 3600 * 24 ); //yesterday date
    if ($p['expire_date'] && ($new_expire < $p['expire_date']))
        $p['expire_date'] = $new_expire;
    $p['data'][] = $vars;
    $p['amount'] = calculate_total($p['data']);
    $db->update_payment($payment_id, $p);
}

//calculate total of member payments based on saved info
function calculate_total($vars){
    $total = 0.0;
    foreach ((array)$vars as $v){
        if (($v['txn_type'] == 'subscr_payment')
         && (($v['payment_status'] == 'Completed') || 
             ($v['payment_status'] == 'Cancelled'))
        ){
            $total += $v['mc_gross'];
        }
    }
    return $total;
}

function process_other($vars){
    global $db;
    sleep(8);
    $payment_id = paypal_r_find_payment($vars);
    if (!$payment_id)
        paypal_error("Cannot find corresponding aMember payment record for this payment");
    $p = $db->get_payment($payment_id);
    $p['data'][] = $vars;
    $p['amount'] = calculate_total($p['data']);
    $data = $db->encode_data($p['data']);
    $data = $db->escape($data);
    $db->query(
    $s = "UPDATE {$db->config[prefix]}payments
    SET data = '$data',
        amount = '{$p[amount]}'
    WHERE payment_id=$payment_id");
}

function process_moneyback($vars){
    global $db;
    $payment_id = paypal_r_find_payment($vars);
    if (!$payment_id)
        paypal_error("Cannot find corresponding aMember payment record for this payment");
    $p = $db->get_payment($payment_id);
    $p['data'][] = $vars;
    $p['amount'] = calculate_total($p['data']);
    if ($vars['payment_status'] == 'Reversal'){
        $p['completed'] = 0;
    } elseif ($vars['payment_status'] == 'Cancelled_Reversal'){
        $p['completed'] = 1;
    }
    $db->update_payment($payment_id, $p);
}

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//            P A Y M E N T    P R O C E S S I N G                          //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

// relay post
if ($this_config['relay']){
    $vars = $HTTP_POST_VARS;
    $req = array();
    foreach ($vars as $k => $v) {
         if (get_magic_quotes_gpc()) 
             $vars[$k] = $v = stripslashes($v);
         $req[] = urlencode($k) . "=" . urlencode ($v);
    }
    paypal_r_get_url($this_config['relay'], join('&', $req));
}

// read post from PayPal system and add 'cmd'
$vars = $HTTP_POST_VARS;
$req = 'cmd=_notify-validate';
foreach ($vars as $k => $v) {
    if (get_magic_quotes_gpc()) 
        $vars[$k] = $v = stripslashes($v);
    $req .= "&" . urlencode($k) . "=" . urlencode ($v);
}


// assign posted variables to local variables
// note: additional IPN variables also available -- see IPN documentation
$item_name      = $vars['item_name'];
$receiver_email = $vars['receiver_email'];
$item_number    = $vars['item_number'];
$invoice        = $vars['invoice'];
$payment_status = $vars['payment_status'];
$payment_gross  = $vars['payment_gross'];
$txn_id         = $vars['txn_id'];
$txn_type       = $vars['txn_type'];
$payer_email    = $vars['payer_email'];

if (!$payer_email && !$receiver_email)
    paypal_error("IPN page must be accessed by PayPal only, not by customers");


$db->log_error("PAYPAL DEBUG<br>\n".get_dump($vars));
// post back to PayPal system to validate
if ($this_config['testing']) { 
    $paypal_addr = "www.eliteweaver.co.uk";
    $paypal_url  = "/testing/ipntest.php";
} else {
    $paypal_addr = "www.paypal.com";
    $paypal_url  = "/cgi-bin/webscr";
}
/////////////////////////////////////////////
$header  = '';
if ($this_config['testing']){
    $header .= "POST $paypal_url HTTP/1.1\r\n";
    $header .= "Host: $paypal_addr\r\n";
} else {
    $header .= "POST $paypal_url HTTP/1.0\r\n";
}
$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
$header .= "Content-Length: " . strlen ($req) . "\r\n\r\n";
$fp = fsockopen ($paypal_addr, 80, $errno, $errstr, 30);

if (!$fp) {
    // HTTP ERROR
    paypal_error("FOPEN www.paypal.com $errstr ($errno)");
} else {
    fputs ($fp, $header . $req);
    $res = '';
    while (!feof($fp)) {
        $res .= fgets ($fp, 1024);
    }
    fclose ($fp);

    if (preg_match('/^VERIFIED/m', $res)) {
        // check that receiver_email is an email address 
        // in your PayPal account
        if ($receiver_email != $this_config['business']) 
            paypal_error(
            "Payment receiver is '$receiver_email' instead of my business: '".
                    $this_config['business'] . "'");
        if ($txn_type == 'subscr_signup'){
            process_signup($vars);
        } elseif ($txn_type == 'subscr_eot') {
            process_eot($vars);
        } else {
            if ($vars['payment_status'] == 'Reversed') {
                process_moneyback($vars);
            } elseif ($vars['payment_status'] == 'Canceled_Reversal') {
                process_moneyback($vars);
            } else {
                process_other($vars);
            }
        }
    } else if (preg_match('/^INVALID/m', $res) != false) {
        // log for manual investigation
        paypal_error("INVALID answer from PayPal server. Possible hack attempt");
    } else {
        paypal_error("Not any VERIFIED or INVALID words found in response");
    }
}

?>


