<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: The installation file
*    FileName $RCSfile: paypal_r.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.4.12.4.15 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
*
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*
*/

add_payment_field('paypal_vars', 'PayPal subscription terms', 'hidden', '');
add_product_field(
            'is_recurring', 'Recurring Billing',
            'select', 'should user be charged automatically<br>
             when subscription expires',
            '',
            array('options' => array(
                '' => 'No',
                1  => 'Yes'
            ))
);

add_paysystem_to_list(
array(
            'paysys_id'   => 'paypal_r',
            'title'       => 'PayPal',
            'description' => 'See <a href="http://www.paypal.com" target=_blank>www.paypal.com</a> for description',
            'recurring'   => 1,
            'public'      => 1,
            'built_in_trials' => 1
        )
);

add_product_field('trial1_days', 
    'Trial 1 Duration',
    'period',
    'read PayPal docs for explanation, leave empty to not use trial',
    'validate_trial_period'
    );

add_product_field('trial1_price', 
    'Trial 1 Price',
    'money',
    'set 0 for free trial'
    );

add_product_field('trial2_days', 
    'Trial 2 Duration',
    'period',
    'read PayPal docs for explanation, leave empty to not use 2-st trial'
    );

add_product_field('trial2_price', 
    'Trial 2 Price',
    'money',
    'set price of 2-st trial period'
    );

add_product_field('rebill_times', 
    'Recurring Times',
    'text',
    'Recurring Times. This is the number of payments which<br>
     will occur at the regular rate. If omitted, payment will<br>
     continue to recur at the regular rate until the subscription<br>
     is cancelled.<br>
     NOTE: not for all payment processing this option is working'
    );

add_product_field('paypal_currency', 
    'PayPal Currency',
    'select',
    'valid only for PayPal processing.<br> You should not change it<br> if you use 
    another payment processors',
    '',
    array('options' => array(
        '' => 'USD',
        'GBP' => 'GBP',
        'EUR' => 'EUR',
        'CAD' => 'CAD',
        'JPY' => 'JPY'
    ))
    );

// get paypal period from aMember format
// input:  aMember period: 1, 1d, 2m, 3Y
// output: array(1,'D') ,  array(2,'M'), ...........
function paypal_get_period($orig_period){

    if (preg_match('/^\s*(\d+)\s*([y|Y|m|M|w|W|d|D]{0,1})\s*$/', 
            $orig_period, $regs)){
        $period = $regs[1];
        $period_unit = $regs[2];
        if (!strlen($period_unit)) $period_unit = 'd';
        $period_unit = strtoupper($period_unit);
        switch ($period_unit){
            case 'Y': 
                if (($period < 1) or ($period > 5)) 
                    return "Period must be in interval 1-5 years";
                break;
            case 'M': 
                if (($period < 1) or ($period > 24)) 
                    return "Period must be in interval 1-24 months";
                break;
            case 'W': 
                if (($period < 1) or ($period > 52)) 
                    return "Period must be in interval 1-52 weeks";
                break;
            case 'D': 
                if (($period < 1) or ($period > 90)) 
                    return "Period must be in interval 1-90 days";
                break;
            default:
                return "Unknown period unit: $period_unit";
        }
    } else {
        return "Incorrect value for expire days: ".$orig_period;
    }
    return array($period, $period_unit);
}

class payment_paypal_r extends payment {
    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){
        global $db;
        global $config;
        if (is_array($vars['product_id'])){
            $p = $db->get_payment($payment_id);
            $price_count = 0;
            foreach ($p['data'][0]['BASKET_PRICES'] as $pp)
                if ($pp) $price_count++;
            if ($price_count>1) {
                return "Only 1 paid product can be selected";
            }
            $product_id = $product_id[0];
        } 
            
        $product = & get_product($product_id);
        $member = $db->get_user($member_id);
        $res = paypal_get_period($product->config['expire_days']);
        if (!is_array($res))
            return $res; //error in expire_days
        else
            list($period, $period_unit) = $res;
        $vars = array(
            'cmd'         => '_xclick-subscriptions',
            'business'    => $this->config['business'],
            'return'      => 
               sprintf("%s/thanks.php?member_id=%d&product_id=%d&payment_id=%d",
                $config['root_url'],
                $member_id, 
                $product_id,
                $payment_id),
            'notify_url'  => 
            $this->config['testing'] ? 
            $this->config['testing_ipn']:
            ( $config['root_url'].
                             "/plugins/payment/paypal_r/ipn.php"), 
            'item_name'   => $product->config['title'],
            'item_number' => $product_id,
            'no_shipping' => 1,
            'cancel_return' => $config['root_url']."/cancel.php",
            'no_note'     => 1,
            'custom'      => $member_id,
            'invoice'     => $payment_id.'-'.substr($payment_id, 0,1),
            'bn'          => 'CgiCentral.aMemberPro',
            ////////////////////////////////////////////////////  Member info
            'first_name'  => $member[name_f],
            'last_name'  => $member[name_l],
            'address1'   => $member[street],
            'city'       => $member[city],
            'state'      => $member[state],
            'zip'        => $member[zip],
            'lc'         => $member[country],
        /////////////////////////////////////////////////////////////////
            'a3'      => sprintf('%.2f', $price),
            'p3'      => $period,
            't3'      => $period_unit,
            'sra'     => 1,
//            'usr_manage' => 0,
            'rm'      => 2
        );
        if ($product->config['rebill_times'])
            $vars['srt'] = $product->config['rebill_times'];

        if ($product->config['is_recurring'])
            $vars['src'] = 1;

        // add currency code
        if (strlen($product->config['paypal_currency'])){
            $vars['currency_code'] = $product->config['paypal_currency'];
        };

        /// check if trial enabled
        if (strlen($product->config['trial1_days'])){
            $res = paypal_get_period($product->config['trial1_days']);
            if (!is_array($res))
                return "trial1 period: ".$res; 
            else {
                list($period, $period_unit) = $res;
                $vars['p1'] = $period;
                $vars['t1'] = $period_unit;
                $vars['a1'] = $product->config['trial1_price'];
            }
        }

        /// check if trial2 enabled
        if (strlen($product->config['trial2_days'])){
            $res = paypal_get_period($product->config['trial2_days']);
            if (!is_array($res))
                return "trial2 period: ".$res; 
            else {
                list($period, $period_unit) = $res;
                $vars['p2'] = $period;
                $vars['t2'] = $period_unit;
                $vars['a2'] = $product->config['trial2_price'];
            }
        }

        // save $payment['data']['paypal_vars'] for future usage
        $pv = array();
        for ($i=1;$i<=3;$i++){
            if (isset($vars["p$i"])) {
                $pv["p$i"] = $vars["p$i"];
                $pv["t$i"] = $vars["t$i"];
                $pv["a$i"] = $vars["a$i"];
            }
        }
        $pv['currency_code'] = $vars['currency_code'];
        $payment = $db->get_payment($payment_id);
        $payment['data']['paypal_vars'] = serialize($pv);
        $db->update_payment($payment['payment_id'], $payment);

        //encode and send
        $vars1 = array();
        foreach ($vars as $kk=>$vv){
            $v = urlencode($vv);
            $k = urlencode($kk);
            $vars1[] = "$k=$v";
        }
        $vars = join('&', $vars1);
        if ($this->config['testing'])
            header("Location: ".$this->config[testing_url]."?$vars");
        else
            header("Location: https://www.paypal.com/cgi-bin/webscr?$vars");
        exit();
    }
    function get_cancel_link($payment_id){
        return 
        "https://www.paypal.com/cgi-bin/webscr?cmd=_subscr-find&alias=".urlencode($this->config['business']);
    }
}

function validate_trial_period(&$p, $field){
    if (!strlen($p[$field])) return;
    return validate_period($p, $field);
}
?>
