<?php 
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: PaySystems.COM Payment Plugin
*    FileName $RCSfile: paysystems.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.2 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
*
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*
*/

class payment_paysystems extends amember_payment {
    var $title = "PaySystems";
    var $description = "secure credit card payment";
    var $fixed_price=0;
    var $recurring=1;
    var $built_in_trials=1;
    ///
    function get_days($days, $field=''){
        $days = strtolower(trim($days));
        if (preg_match('/^(\d+)(d|w|m|y)$/', $days, $regs)) {
            $count = intval($regs[1]);
            $period = $regs[2];
            if ($period == 'm'){
                return 31 * $count;
            } elseif ($period == 'd'){
                return $count;
            } elseif ($period == 'w'){
                return 7 * $count;
            } elseif ($period == 'y'){
                return 365 * $count;
            } else {
                fatal_error("Unknown period unit in expire_days. Should be d|m|w|y");
            }
        } elseif (preg_match('/^\d+$/', $days)) 
            return intval($days);
        else 
            fatal_error("Incorrect value for $field: '$days'");
    }
    function do_bill($amount, $title, $products, $u, $invoice){
        global $config;
        $vars = array(  
            'companyid'  => $this->config['company_id'],
            'total'      => sprintf('%.2f', $amount),
            'product1'   => $title,
            'redirect'   => 
                $config['root_url'] . '/thanks.php',
            'redirectfail' => 
                $config['root_url'] . '/cancel.php',
            'option1'    => $invoice,
            'b_firstname' => $u['name_f'],
            'b_lastname'  => $u['name_l'],
            'b_address'   => $u['street'],
            'b_city'      => $u['city'],
            'b_zip'       => $u['zip'],
            'b_country'   => $u['country'],
            'b_state'     => $u['state'],
            'b_tel'       => $u['data']['phone'],
            'email'       => $u['email']
        );

        if ($products[0]['is_recurring']){
            if (count($products) != 1){
                fatal_error("Unfortunately, it is imposible to choose several products for recurirng billing at once. Please return back and choose one product");
            }
            $cycle = $this->get_days($products[0]['expire_days'], 'expire_days');
            if ($products[0]['trial1_price'] != '') {
                $vars['total'] = $products[0]['trial1_price'];
            }
            $vars += array(
                'reoccur'    => 'Y',
                'cycle'      => $cycle,
                'repeatamount' => sprintf('%.2f', $amount),
            );
        }
        return $this->encode_and_redirect("https://secure.paysystems1.com/cgi-v310/payment/onlinesale-tpppro.asp", $vars);
    }

    function get_begin_date($member_id, $product_id){
        global $db;
        $payments = & $db->get_user_payments(intval($member_id));
        $date = date('Y-m-d');
        foreach ($payments as $p){
            if (($p['product_id'] == $product_id) &&
                ($p['expire_date'] > $date) &&
                ($p['completed'] > 0)
                ) 
                $date = $p['expire_date'];
        }
        list($y,$m,$d) = split('-', $date);
        $date = date('Y-m-d', mktime(0,0,0,$m, $d, $y));
        return $date;
    }

    function resend_postback($url, $vars){
        $s = array();
        foreach ($vars as $k => $v)
            $s[] = urlencode($k) . '=' . urlencode($v);
        get_url($url, join('&', $s));
    }

    function process_postback($vars){
        global $db;

        $invoice      = $vars['orderno'];
        $amount       = $vars['total'];
        $payment_id   = intval($vars['option1']);
        $member_id    = intval($vars['option2']);
        $product_id   = intval($vars['option3']);
        $pin          = $vars['pin']; //not used yet
        $cid          = $vars['cid'];
        $chargestatus = $vars['chargestatus'];
        $status       = $vars['status'];
        $post_type    = $vars['post_type'];

        $valid_ip = 0;
        foreach (preg_split('/\s+/', $this->config['ip']) as $ip) {
            $valid_ip += compare_with_pattern($ip, $_SERVER['REMOTE_ADDR']) ? 1 : 0;
        }

        if (!$valid_ip){
            $this->postback_error("Postback came from unknown IP: [{$_SERVER[REMOTE_ADDR]}]");
            return false;
        }

        if ($this->config['resend_postback'])
            foreach (preg_split('/\s+/', $this->config['resend_postback']) as $url){
                $url = trim($url);
                if ($url == '') continue;                
                $this->resend_postback($url, $vars);
            }

        if (in_array($post_type, array(4,5,6,7))){
            $this->process_refund($payment_id);
            return true;
        }
        if (!in_array($post_type, array(1,3,8))){
            $this->postback_error("Unknown post type: [$post_type]");
            return false;
        }
        if (!in_array($chargestatus, array(1,3))){
            $this->postback_error("Unknown chargestatus: [$chargestatus]");
            return false;
        }
        if (!$amount){
            $this->postback_error("returned amount empty or = 0");
            return false;
        }

        /// all ok - process payment
        $pm = $db->get_payment($payment_id);

        //check if payment is already processed
        $payments = & $db->get_user_payments(intval($pm['member_id']));
        foreach ($payments as $p){
            if ($p['receipt_id'] == $invoice){
                return false; // already processed
            }
        }

        if ($pm){
            if ($pm['completed']){ // this is completed, we should add new one
                $product = get_product($pm['product_id']);
                $beg_date = $this->get_begin_date($pm['member_id'], $pm['product_id']);
                list($y,$m,$d) = split('-', $beg_date);
                $beg_date1 = date('Y-m-d', mktime(0,0,0,$m, $d, $y));
                $payment_id = $db->add_waiting_payment(
                    $pm['member_id'], 
                    $pm['product_id'], 
                    $pm['paysys_id'], 
                    $pm['amount'], 
                    $beg_date1, 
                    $product->get_expire($beg_date),
                    array()
                );
            } 
        }

        // process payment
        $err = $db->finish_waiting_payment(
            $payment_id, $this->get_plugin_name(), 
            $invoice, $amount, $vars);

        if ($err) 
            $this->postback_error("finish_waiting_payment error: $err");
    
    }
    function process_refund($payment_id){
        global $db;
        $pm = $db->get_payment($payment_id);
        $pm['completed']=0;
        $pm['data'][]=$this->postback_vars;
        $db->update_payment($payment_id,$pm);
    }
}

$pl = & instantiate_plugin('payment', 'paysystems');

?>
