<?php
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: PlugNPay payment interface 
*    FileName $RCSfile: pay.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.2 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember is free for both commercial and non-commercial use providing that the
* copyright headers remain intact and the links remain on the html pages.
* Re-distribution of this script without prior consent is strictly prohibited.
*
*/

function plugnpay_get_url($url, $post=''){
    if (extension_loaded("curl")){

        $ch=curl_init($url);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post);  
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);    
        $buffer = curl_exec($ch);                       
        curl_close($ch);
        return $buffer;
    } else {
        global $config;
        if (substr(php_uname(), 0, 7) == "Windows") {
            $curl = $config['curl'];
            if (!strlen($curl)) fatal_error("cURL path is not set");
        } else {
            $curl = escapeshellcmd($config['curl']);
            if (!strlen($curl)) fatal_error("cURL path is not set");
//            $post = escapeshellcmd($post);
            $url = escapeshellcmd($url);
        }
        $ret=`$curl -d "$post" $url`;
        return $ret;
    }
}

function plugnpay_payment($payment_id, $member_id){
    set_time_limit(600);
    ignore_user_abort(true);
    // first prepare all variables
    global $db, $config, $plugin_config;
    $this_config   = $plugin_config['payment']['plugnpay'];
    if (!$this_config['login']) fatal_error("No username configured for plugnpay");
    if (!$this_config['domain']) fatal_error("No domain configured for plugnpay");
    $payment = $db->get_payment($payment_id);
    if (!$payment)
        return array("Payment not found: #$payment_id", 3);
    if ($payment['completed'])
        return array("Payment already completed: #$payment_id", 3);
    if ($payment['paysys_id'] != 'plugnpay')
        return array("Payment created for another payment system: '$payment[paysys_id]' (#$payment_id)", 3);
//    if ($payment['member_id'] != $member_id)
//        return array("Payment created for another member: #$payment_id ({$payment[member_id]},$member_id)", -903);

    if ($payment['amount'] <= 0 ) { // seems it is a trial subscription
        $db->finish_waiting_payment($payment_id, 'plugnpay', 
            'free trial', '', $return);
        return array('', 1);
    }

    $member = $db->get_user($payment['member_id']);
    if (!$member) 
        return array("Member not found: #$member_id", -904); 
    $cc_number = amember_decrypt($member['data']['cc-hidden']);
    $cc_expire = $member['data']['cc-expire'];
    $product = $db->get_product($payment['product_id']);


    ///// !!! run transaction
    $url_proc = "https://{$this_config[domain]}/payment/pnpremote.cgi";
    session_start();           if (!$_SESSION['_amember_payment_try'] || ($_SESSION['_amember_payment_try']>87))
        $_SESSION['_amember_payment_try'] = 65;
    $vars = array(
        "publisher-name"    => $this_config['login'],
        "publisher-email"   => $config['admin_email'],
        "card-amount" => $payment['amount'],
        "card-name" => $member['name_f'] . " " . $member['name_l'],
        "card-address1" => $member['data']['cc_street'],
        "card-city" => $member['data']['cc_city'],
        "card-state" => $member['data']['cc_state'],
        "card-zip" => $member['data']['cc_zip'],
        "card-country" => $member['data']['cc_country'],
        "card-exp" => substr($cc_expire,0,2) . "/" . substr($cc_expire,2,2),
        "card-number" => $cc_number,
        "orderID" => $payment_id . '-' . intval($_SESSION['x_try']++),
        "app-level" => $this_config['app_level'],
        "acct_code" => $member['login'],

        'shipping' => 0,
        'tax' => 0,
        'order-id' => $payment_id,
        'item1' => (($product['price_group'] < 0) ? 
               ( - $product['price_group'] ) : $product['price_group']),
        'price1' => $payment['amount'],
        'quantity1' => 1,
        'description1' => $product['title']
    );
    if ($_SESSION['_amember_card_code'])
        $vars['card-cvv'] = $_SESSION['_amember_card_code'];
    $_SESSION['_amember_card_code'] = '';
    unset($_SESSION['_amember_card_code']);

    foreach ($vars as $kk=>$vv){
        $v = urlencode($vv);
        $k = urlencode($kk);
        $vars1[] = "$kk=$vv";
    }

    $vars_cc = $vars; 
    $vars_cc['card-number'] = $member['data']['cc'];
    unset($vars_cc['card-cvv']);
    $payment['data'][] = $vars_cc;
    $db->update_payment($payment_id, $payment);

    $buffer = plugnpay_get_url($url_proc, join('&', $vars1));
    parse_str($buffer, $res);
//    print_r($res);

    switch ($res['FinalStatus']){
        case 'success' : $return['RESULT'] = 1; break;
        case 'fraud':
        case 'badcard' : $return['RESULT'] = 2; break;
        case 'problem' : $return['RESULT'] = 3; break;
    } 
    $return['RESPMSG']   = $res['MErrMsg'] ? $res['MErrMsg'] : $res['auth-msg'];
    $return['RESPMSG'] = join("<br>\n", preg_split('/\|/', $return['RESPMSG']));
    $return['AVS']       = $res['avs-code'];
    $return['PNREF']     = $res['auth-code'];
    $return['CVV_VALID'] = $res['cvvresp'];

    ////////////// check transaction result   ////////////////////////////
    if (!isset($return['RESULT'])){
        $db->log_error("Empty result, payment handling failed #$payment_id");
        return array("aMember: Empty result from processor, payment handling failed", 3);
    } elseif ($return['RESULT'] == 1) { // success
        $db->finish_waiting_payment($payment_id, 'plugnpay', 
            $return['PNREF'], '', $return);
        return array('', $return['RESULT']);
    } elseif ($return['RESULT'] == 2) { // bad card

        $m = $db->get_user($member_id);
        $member['data']['cc-hidden'] = '';
        $member['data']['cc-expire'] = '';
        $member['data']['cc'] = '';
        $db->update_user($member_id, $m);

        $payment['data'][] = $return;
        $db->update_payment($payment_id, $payment);
        return array($return['RESPMSG'], $return['RESULT']);
    } else  { // another problem
        $db->log_error($return['RESPMSG']);
        $payment['data'][] = $return;
        $db->update_payment($payment_id, $payment);
        return array("Payment processor error: ".
        (($return['RESPMSG']) ? ($return['RESPMSG']) : $buffer), 
        $return['RESULT']);
    }
    return array($return['RESPMSG'], $return['RESULT']); //dummy!
}

?>
