<?php
// ############# 2CheckOut Plugin for aMember ##############
/************************************************************
*     Author: James Mitchell
*    Company: Auseasy Internet Services
*      Email: reductor@aismail.com
*
*    Re-distribution without prior consent is prohibited.
*
*    Re-distribution with permission of author. alex@cgi-central.net
*/
add_paysystem_to_list(
array(
            'paysys_id'   => 'twocheckout_r',
            'title'       => '2CheckOut',
            'description' => 'secure credit card/online check payment with 2Checkout.com',
            'recurring' => 1,
            'public'    => 1
        )
);

add_product_field(
            'is_recurring', 'Recurring Billing?',
            'select', 'should user be charged automatically<br>
             when subscription expires',
            '',
            array('options' => array(
                '' => 'No',
                1  => 'Yes'
            ))
);

add_product_field(
            'twocheckout_id', '2Checkout ID',
            'text', 'you must create the same product<br>
             in 2Checkout and enter its number here',
             'validate_twocheckout_id'
);



class payment_twocheckout_r extends payment {
    function do_not_recurring_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){
        global $config;
        global $db;
        $product = & get_product($product_id);

        $u = & $db->get_user(intval($member_id));

        $vars = array(
            'x_login'         => $this->config[seller_id],
            'x_amount'        => $price,
            'x_invoice_num' => $payment_id,
            'x_First_Name' => $u['name_f'],
            'x_Last_Name' => $u['name_l'],
            'x_Address' => $u['street'],
            'x_City' => $u['city'],
            'x_State' => $u['state'],
            'x_Zip' => $u['zip'],
            'x_Country' => $u['country'],
            'x_Email' => $u['email'],
            'x_Receipt_Link_URL' => $config['root_url']."/plugins/payment/twocheckout_r/thanks.php",
        );
//        if ($this->config['demo'] == 'Y')
//            $vars['demo'] = 'Y';

        $vars1 = array();
        foreach ($vars as $kk=>$vv){
            $v = urlencode($vv);
            $k = urlencode($kk);
            $vars1[] = "$k=$v";
        }
        $vars = join('&', $vars1);
        header("Location: https://www.2checkout.com/cgi-bin/Abuyers/purchase.2c?".$vars);
        exit();
    }

    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){

        global $config;
        global $db;
        $product = & get_product($product_id);

        if(!$product->config['is_recurring'])
            return $this->do_not_recurring_payment($payment_id, $member_id, $product_id,
                 $price, $begin_date, $expire_date, $vars);

        $varsx = array(
            'product_id' => $product->config['twocheckout_id'],
            'sid'        => $this->config['seller_id'],
            'amem_payment_id' => $payment_id,
            'verify'     => 
                md5(
                    $this->config['seller_id'].
                    $product->config['twocheckout_id'].
                    $price
                )
        );
        $varsx['recuring'] = 'Y';
//        if ($this->config['demo'] == 'Y')
//                    $varsx['demo'] = 'Y';
        $vars1 = array();
        foreach ($varsx as $kk=>$vv){
            $v = urlencode($vv);
            $k = urlencode($kk);
            $vars1[] = "$kk=$vv";
        }
        $varsx = join('&', $vars1);
        header($s="Location: https://www.2checkout.com/cgi-bin/crbuyers/recpurchase.2c?".$varsx);
        return '';
    }

    function validate_thanks(&$vars){
        if (!$vars['x_amount']){ // it is recurring sale
            if($vars['demo'] == "Y" && $this->config[demo]!="Y")
                return "Tried to use demo mode, but demo mode not enabled";
            if($vars['credit_card_processed'] != "Y")
                return "Credit card could not be processed";
            if(strtoupper(md5($this->config[secret].$this->config['seller_id'].$vars['order_number'].$vars['total']))!=$vars['key'])
                return "Unable to validate that you have paid, please contact the webmaster";
        } else { // not recurring sale
            if(intval($vars['x_trans_id'])==0&&$this->config[demo]!="Y")
                    return "Tried to use demo mode, but demo mode not enabled";
            if(intval($vars['x_response_code'])!=1)
                return "Invalid Responce code, please contact the webmaster";
            if(floor($vars['x_amount'])==$vars['x_amount'])
                $vars['x_amount']=floor($vars['x_amount']); 
            if(strtoupper(md5($this->config[secret].$this->config[seller_id].$vars['x_trans_id'].$vars['x_amount']))!=$vars['x_MD5_Hash'])
                return "Unable to validate that you have paid, please contact the webmaster";
        }
        return '';
    }

    function process_thanks(&$vars){
            global $db;
            $payment_id = intval($vars['amem_payment_id']?$vars['amem_payment_id']:$vars['x_invoice_num']);
            $err = $db->finish_waiting_payment($payment_id, 
                    'twocheckout_r', 
                    $vars['order_number']?$vars['order_number']:$vars['x_trans_id'],
                     '', $vars);
            if ($err) 
                return "finish_waiting_payment error: $err";
            $p = $db->get_payment($payment_id);
            $GLOBALS['vars']['payment_id'] = $payment_id;
            $product = & get_product($p['product_id']);
            if ($product->config['is_recurring'] && $vars['amem_payment_id']){
                ////// set expire date to infinite 
                ////// admin must cancel it manually!
                $p['expire_date'] = '2012-12-31'; 
                $db->update_payment($payment_id, $p);
            }
    }

}

function validate_twocheckout_id(&$p, $field){  
    if ((intval($p->config[$field]) <= 0) && $p->config['is_recurring']) {
        return "You MUST enter 2Checkout Product ID while you're using 2Checkout Recurring payment";
    }
    return '';
}
?>
