<?
/*
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: WorldPay payment plugin
*    FileName $RCSfile: worldpay.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.13 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
*
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*
*/

add_product_field(
            'is_recurring', 'Recurring Billing',
            'select', 'should user be charged automatically<br>
             when subscription expires',
            '',
            array('options' => array(
                '' => 'No',
                1  => 'Yes'
            ))
);
add_product_field(
            'worldpay_currency', 'WorldPay Currency',
            'select', 'currency for WorldPay gateway',
            '',
            array('options' => array(
                ''     => 'USD',
                'GBP'  => 'GBP',
                'EUR'  => 'EUR',
                'JPY'  => 'JPY'
            ))
);

add_paysystem_to_list(
array(
            'paysys_id'   => 'worldpay',
            'title'       => 'WorldPay',
            'description' => 'Pay by credit card/debit card - Visa/Mastercard/Eurocard/Delta/Solo/Switch/JCB',
            'recurring'   => 1,
            'public'      => 1,
            'built_in_trials' => 1
        )
);

function worldpay_get_interval_unit($days, $field=''){
    $days = strtolower(trim($days));
    if (preg_match('/^(\d+)(d|w|m|y)$/', $days, $regs)) {
        $count = $regs[1];
        $period = $regs[2];
        if ($period == 'm'){
            return 3;
        } elseif ($period == 'd'){
            return 1;
        } elseif ($period == 'w'){
            return 2;
        } elseif ($period == 'y'){
            return 4;
        } else {
            fatal_error("Unknown period unit in expire_days. Should be d|m|w|y");
        }
    } elseif (preg_match('/^\d+$/', $days)) 
        return 1;
    else 
        fatal_error("Incorrect value for $field: '$days'");
}



function worldpay_get_interval_mult($days){
    $days = strtolower(trim($days));
    if (preg_match('/^(\d+)(d|w|m|y)$/', $days, $regs)) {
        $count = $regs[1];
        return $count;
    } elseif (preg_match('/^\d+$/', $days)) 
        return $days;
    else 
        fatal_error("Incorrect value for $field in product #".
            $this->config['product_id'] . ": '$days'" );
}


class payment_worldpay extends payment {
    function do_payment($payment_id, $member_id, $product_id,
            $price, $begin_date, $expire_date, &$vars){

        global $config, $db;
        $orig_product_id = $product_id;
        if (is_array($product_id))
             $product_id = $product_id[0];
        $product = & get_product($product_id);
        if (count($orig_product_id)>1)
            $product->config['title'] = $config['multi_title'];
        $u  = $db->get_user($member_id);
        $vars = array(
            'instId'   => $this->config['installation_id'],
            'cartId'   => $payment_id,
            'currency' => 'USD',
            'desc'     => $product->config['title'],
            'email'            => $u['email'],
            'name'       => $u['name_f'] . ' ' . $u['name_l'],
            'address'          => $u['street'],
            'city'             => $u['city'],
            'state'            => $u['state'],
            'country'          => $u['country'],
            'postcode'         => $u['zip'],
            'MC_callback'      => str_replace('http://', '', $config['root_url']."/plugins/payment/worldpay/ipn.php")
        );
        if ($this->config['testing']){
            $vars['testMode'] = 100;
        }
        if ($product->config['worldpay_currency'])
            $vars['currency'] = $product->config['worldpay_currency'];

        if ($product->config['is_recurring']){
            $p = $db->get_payment($payment_id);
            $vars += array(
            'futurePayType' => 'regular',
//            'startDate'     => $p['expire_date'],
            'startDelayUnit'=> worldpay_get_interval_unit($product->config['expire_days'], 'expire_days'), 
            'startDelayMult'=> worldpay_get_interval_mult($product->config['expire_days'], 'expire_days'),
            'intervalUnit'  => worldpay_get_interval_unit($product->config['expire_days'], 'expire_days'),
            'intervalMult'  => worldpay_get_interval_mult($product->config['expire_days'], 'expire_days'),
            'normalAmount'  => $price,
            'option'        => 0
            );

            if ($product->config['trial1_price']){
                $vars['amount'] = $product->config['trial1_price'];
                $p['expire_date'] = $product->get_expire($begin_date, 'trial1_days');
                $p['amount'] = $product->config['trial1_price'];
                $db->update_payment($payment_id, $p);
            } else
                $vars['amount'] = $price;
        } else {
            $vars['amount'] = $price;
        }
        $vars1 = array();
        foreach ($vars as $kk=>$vv){
            $v = urlencode($vv);
            $k = urlencode($kk);
            $vars1[] = "$k=$v";
        }
        $vars = join('&', $vars1);
        header("Location: https://select.worldpay.com/wcc/purchase?$vars");
        exit();
    }
}

?>
