<?php
/*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: Product class and functions
*    FileName $RCSfile: product.inc.php,v $
*    Release: 2.1.8PRO ($Revision: 1.16.2.4.4.34 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*
*/
global $product_fields;
$product_fields = array(
    array(
        'name'         => 'product_id',
        'title'        => 'Product #',
        'type'         => 'text'
    ),
    array(
        'name'         => 'title',
        'title'        => 'Title',
        'type'         => 'text'
    ),
    array(
        'name'         => 'description',
        'title'        => 'Description',
        'type'         => 'text'
    ),
    array(
        'name'         => 'price',
        'title'        => 'Price',
        'type'         => 'money'
    )
);

global $product_additional_fields;
$product_additional_fields = array(
    array(
        'name'         => 'expire_days',
        'title'        => 'Duration',
        'type'         => 'period',
        'description'  => "can be:<br> - Count of days (10, 35)<br>- Count
            of calendar months (2m)<br>- Count of calendar years (1y)",
        'validate_func'=> 'validate_period'
    )
);

function add_product_field(
        $name, $title, $type,
        $description='',
        $validate_func='',
        $additional_fields=NULL){
    settype($additional_fields, 'array');
    global $product_additional_fields;
    foreach ($product_additional_fields as $k=>$v){
        if ($v['name'] == $name) {
            if ($v['validate_func'] &&
                ($v['validate_func'] != $validate_func)){
                $product_additional_fields[$k]['validate_func'] =
                        (array)$v['validate_func'];
                $product_additional_fields[$k]['validate_func'][] =
                    $validate_func;
            }
            return;
        }
    }
    $product_additional_fields[] = array_merge(
        $additional_fields,
        array(
            'name'          => $name,
            'title'         => $title,
            'type'          => $type,
            'description'   => $description,
            'validate_func' => $validate_func
        )
   );
}

add_product_field('url',
    'Product URL',
    'text',
    "Please enter URL of protected area.<br>
     For example: <i>/mydir/protected_dir1/</i><br>
     or <i>http://area.yoursite.com/xxx/</i><br>
     or <i>xxx/</i> or <i>../xxx/</i> -<br>
     last case case it is considered as relative<br>
     to configured aMember Pro root URL<br>
     PLEASE NOTE - folder will not become protected<br>
     if you just enter it here. Please read<br>
     aMember Pro manual about
      <a target=_blank href='http://www.cgi-central.net/scripts/amember/docs/'>Protection Plugins</a>.
     ",
    'validate_product_url');

add_product_field('add_urls',
    'Additional URLs',
    'textarea',
    'Enter additional URLs using this format:<br>
    /some_url/|URL title to display<br><br>
    These URLs will be displayed on the member.php page<br>
    in addition to the Product URL field',
    '');

if ($GLOBALS['config']['use_tax'])
    add_product_field('use_tax',
    'Add Tax',
    'select',
    'add tax value to price',
    '', array('options' => array('' => 'No', 1 => 'Yes')));


class product {
    // should contain keys:
    // product_id, title, description, price
    // expire_days, resources (list)
    var $config;
    function product($config){
        $this->config = $config;
    }
    function get_price(){
        return round($this->config['price'], 2);
    }
    function get_expire($begin_date, $field='expire_days'){


        list($y,$m,$d) = split('-', $begin_date);
        $days = $this->config[$field];
        if ($GLOBALS['_trial_days'])
            $days = $GLOBALS['_trial_days']; //trial handling
        $tm = mktime(0,0,0, $m, $d, $y);
        // handle fixed expiration date
        if (preg_match('/^(\d{4})-(\d{2})-(\d{2})$/', $days, $regs)){
            return $days;
        }
        //// coupon K - money left on coupon, lets make subscription
        //// little longer
        if ($GLOBALS['COUPON_NOT_USED']){
            $koef = 1.0 + $GLOBALS['COUPON_NOT_USED'];
        } else
            $koef = 1.0;
        //handle period (as 1m = 1 months, 2y = 2 years)
        if (preg_match('/^(\d+)(d|w|m|y)$/', $days, $regs)) {
            $count = $regs[1];
            $period = $regs[2];
            if ($period == 'd'){
                $tm = $this->expire_date_add($tm, mktime(0,0,0, $m, $d+$count, $y), $koef);
            } elseif ($period == 'w'){
                $tm = $this->expire_date_add($tm, mktime(0,0,0, $m, $d+($count*7), $y), $koef);
            } elseif ($period == 'm'){
                $tm = $this->expire_date_add($tm, mktime(0,0,0, $m + $count, $d, $y), $koef);
            } elseif ($period == 'y'){
                $tm = $this->expire_date_add($tm, mktime(0,0,0, $m, $d, $y + $count), $koef);
            } else {
                return "Unknown period unit in $field. Should be d|w|m|y";
            }
        } elseif (preg_match('/^\d+$/', $days))
            $tm = $this->expire_date_add($tm, mktime(0,0,0, $m, $d + $days, $y), $koef);
        else
            return "Incorrect value for $field in product #".
                $this->config['product_id'];
        return date('Y-m-d', $tm);
    }

    function expire_date_add($tm1, $tm2, $koef){
        $diff = $tm2 - $tm1;
        $new_diff = $diff * $koef;
        return $tm1 + $new_diff;
    }

    var $days_condition = " (to_days(%D) - to_days(begin_date)) %% %d = 0
    ";

    var $months_condition = "
            ( dayofmonth(begin_date) = dayofmonth(%D))
            AND  (( month(%D) - month(begin_date) +
            (year(%D) - year(begin_date)) * 12 ) %% %d) = 0
        ";
    var $years_condition  = "
            dayofmonth(begin_date) = dayofmonth(%D)
            AND  month(begin_date) = month(%D)
            AND  (year(%D) - year(begin_date)) %% %d  = 0";


    function get_recurring_where($beg_date){

        $this->days_condition   = str_replace('%D', "'$beg_date'", $this->days_condition);
        $this->months_condition = str_replace('%D', "'$beg_date'", $this->months_condition);
        $this->years_condition  = str_replace('%D', "'$beg_date'", $this->years_condition);

        $days = $this->config['expire_days'];
        //handle period (as 1m = 1 months, 2y = 2 years)
        if (preg_match('/^(\d+)(d|w|m|y)$/', $days, $regs)) {
            $count = $regs[1];
            $period = $regs[2];
            if ($period == 'm'){
                $res = sprintf($this->months_condition, $count);
            } elseif ($period == 'd'){
                $res = sprintf($this->days_condition, $count);
            } elseif ($period == 'w'){
                $res = sprintf($this->days_condition, $count*7);
            } elseif ($period == 'y'){
                $res = sprintf($this->years_condition, $count);
            } else {
                fatal_error("Unknown period unit in $field. Should be m|y");
            }
        } elseif (preg_match('/^(\d+)$/', $days, $regs)) {
            $count = $regs[1];
            $res = sprintf($this->days_condition, $count);
        } else
            fatal_error("Incorrect value for $field in product #".
                $this->config['product_id']);
        return $res;
    }

    function get_resources(){
        return $this->config[resources];
    }
}

function get_product($product_id){
    $db = &instantiate_db();
    $conf = $db->get_product($product_id); //return database record for product
    return new product($conf);
}

////////////////////// validate functions //////////////////////////////
function validate_period(&$p, $field){
    if (!preg_match('/^\d+\-\d+\-\d+$/', $res = $p->get_expire(date('Y-m-d'), $field))){
        return $res;
    }
    // unfortunately, get_expire raise fatal_error
    // so we can't return string from this function
    // but we SHOULD!
}

function validate_product_url(&$p, $field){
    $url = $p->config['url'];
    if (!strlen($url)) return;
//    if (preg_match('/^[^\/]/', $url) && !preg_match('/^http:\/\//', $url))
//        return "Url isn't relative to site root. Just point your
//        browser to protected directory and copy & paste URL from URL window";
//    $uri = parse_url($url);
//    $p->config['url'] =
//            $uri['path'] .
//            ($uri['query'] ? ('?'.$uri['query']) : '') .
//            ($uri['fragment'] ? ('#'.$uri['fragment']):'');
    return;
}

function product_sort_cmp($a, $b){
    $c = intval($a['order']) - intval($b['order']);
    if ($c) return $c;
    return strcmp($a['title'], $b['title']);
}

function calculate_price($product_id, $member_id, &$vars, &$prices){
    // input from vars:
    // $vars['paysys_id'], $vars['coupon']
    // get array or single product_id
    // get trial_prices or just prices if paysystem doesn't support built_in trials
    // sets $GLOBAL['_trial_days'], $GLOBAL['']
    // returns $prices[product_id] = calculated_price array
    global $db, $config, $error;
    $res = 0;
    $prices = array();
    if (!is_array($product_id))
        $product_id = array($product_id);
    elseif ((count($product_id)>1) && !$config['select_multiple_products'])
        fatal_error("Multiple Products select mode is not enabled. Internal error");

    // find out used product ids  (for future use with trials)
    $product_ids_used = array();
    if ($member_id) 
        foreach ($db->get_user_payments($member_id, 1) as $p){
            $product_ids_used[$p['product_id']]++;
        }
    //
    $paysys = get_paysystem($vars['paysys_id']);
    foreach ($product_id as $p){
        $product = & get_product($p);
        $products[$p] = $product;
        if (!$paysys['built_in_trials'] &&
            // !$product_ids_used[$p] && 
            $product->config['trial1_days']) {
            $prices[$p] = $product->config['trial1_price'];
            $GLOBALS['_trial_days'] = $product->config['trial1_days'];
        } else {
            $prices[$p] = $product->get_price();
        }
    }
    //
    if ($vars['coupon']){
        $coupon = $db->coupon_get($vars['coupon']);
        if (!is_array($coupon)){
            global $error;
            $error[] = $coupon;
            return 9999999999999;
        }
        //// check member usage
        $member_used_count = 0;
        if ($coupon['member_use_count'] && $member_id){
            foreach (split(';', $coupon['used_for']) as $s){
                list($p,$pr,$m) = split(',',$s);
                if ($m == $member_id) $member_used_count++;
            }
            if ($member_used_count >= $coupon['member_use_count']){
                global $error;
                $error[] = "Coupon is already used";
                return 9999999999999;
            }
        }
        //// ok, we got coupon object
        //// will find products which intersect with coupon allowed
        $coupon['product_id'] = preg_split('/,/', trim($coupon['product_id']));
        if (!$coupon['product_id'][0]) $coupon['product_id'] = array();
        if (count($coupon['product_id'])){
            $to_discount = array_intersect($product_id, $coupon['product_id']);
            $to_full     = array_diff($product_id, $to_discount);
        } else {
            $to_discount = $product_id;
            $to_full     = array();
        }
        //// ok, lets calculate now
        if (preg_match('/^(\d+)\s+\%$/', $coupon['discount'], $regs)) // % discount
            foreach ($to_discount as $pid){
                $prc = $prices[$pid];
                $prc *= (100 - $regs[1]) / 100;
                $prc = round($prc, 2);
                $prices[$pid] = $prc;
            }
        else { // numeric discount
            foreach ($to_discount as $pid)
                $orig_sum += $prices[$pid];
            if ($orig_sum)
                $k = ($orig_sum - $coupon['discount']) / $orig_sum;
            else
                $k = 0;
            if ($k < 0) 
                $k = 0;
            foreach ($to_discount as $pid)
                $prices[$pid] = round($prices[$pid] * $k, 2);
            if (count($to_discount)) {
                $discounted = $orig_sum - array_sum(array_values($prices));
                $left_on_coupon = $coupon['discount'] - $discounted;
                if ($left_on_coupon >= 0.01)  // set global (%)
                    $GLOBALS['COUPON_NOT_USED'] = $left_on_coupon / $coupon['discount'];
            }
      }
      if (count($to_discount)) 
          $GLOBALS['COUPON_CODE'] = $coupon['code'];
    }
    /// check tax
    if ($config['use_tax']){
        if ($config['tax_type'] == 1){ // global tax
            $tax = $config['tax_value'];
        } elseif ($config['tax_type'] == 2) { //regional tax
            if ($member_id && $member=$db->get_user($member_id)){
                foreach ($config['regional_taxes'] as $t){
                    if ($t['state'] && ($t['state'] == $member['state'])){
                        $tax = $t['tax_value'];
                        break;
                    }
                    if ($t['country'] && ($t['country'] == $member['country'])){
                        $tax = $t['tax_value'];
                        break;
                    }
                }
            }
        }
        if ($tax) { //apply tax 
            $tax_amount = 0;
            foreach ($prices as $k=>$v) {
                if (!$products[$k]->config['use_tax']) continue;
                $tax_amount += sprintf('%.2f', ($v * $tax/100));
                $prices[$k] = sprintf('%.2f', ($v * (100+$tax)/100));
            }
            $GLOBALS['TAX_AMOUNT'] = $tax_amount;
        }
    }
    // calculate totals
    return array_sum($prices);
}

function display_agreement($data){
    global $t, $error;
    $t->assign('data', $data);
    $t->assign('error', $error);
    $t->display('agreement.html');
}

function get_product_requirements_for_member($member_id){
    global $db;
    $dat = date('Y-m-d');
    $res = array();
    foreach ($db->get_user_payments($member_id, 1) as $p){
        if (($p['begin_date'] < $dat) && ($p['expire_date'] < $dat))
            $res['EXPIRED-'.$p['product_id']]++;
        elseif (($p['begin_date'] <= $dat) && ($p['expire_date'] >= $dat))
            $res['ACTIVE-'.$p['product_id']]++;
    }
    return array_keys($res);
}

function check_product_requirements($product_ids, $have=''){
    global $db;
    $error = array();

    $will_have = $have ? (array)$have : array();
    foreach ($product_ids as $product_id)
        $will_have[] = 'ACTIVE-'.$product_id;
    $will_have = array_unique($will_have);

    foreach ($product_ids as $product_id){
        $pr = $db->get_product($product_id);
        if ($pr['require_other']){
            $ro = array();
            foreach ($pr['require_other'] as $s)
                if ($s) $ro[] = $s; // skip empty requirement
            if ($ro && !array_intersect($ro, $will_have)) {
                $titles = array();
                foreach ($ro as $s){
                    if (preg_match('/^ACTIVE-(\d+)$/', $s, $args)){
                        $prt = $db->get_product($args[1]);
                        $titles[] = '"'. $prt['title'] . '"';
                    }
                }
                if ($titles){
                    $error[] = "\"{$pr[title]}\" can be ordered ".
                           "along with these products/subscriptons only: " . 
                           join(', ', $titles);
                    continue;
                } 
                $titles = array();
                foreach ($ro as $s){
                    if (preg_match('/^EXPIRED-(\d+)$/', $s, $args)){
                        $prt = $db->get_product($args[1]);
                        $titles[] = '"'. $prt['title'] . '"';
                    }
                }
                if ($titles){
                    $error[] = "\"{$pr[title]}\" can be ordered ".
                           "only if you have expired subscription ".
                           "for these products: " . 
                           join(', ', $titles);
                    continue;
                } 
            }
        }
    }
    return $error;
}



add_product_field('scope', 'Scope',
    'select', "Limits who can order this product<br>
    (Does not affect existing customers)",
    '',
    array('options'=>array(
        ''         => 'Visible for all',
        'disabled' => 'Disabled',
        'signup'   => 'Only Signup',
        'member'   => 'Only Members having paid subscriptions'
    )));

add_product_field('order', 'Sorting order',
    'text', "This is a numeric field. Products<br>
    will be sorted according to this number, then alphabetically
    ");
add_product_field('price_group', 'Price Group ID',
    'text', "This is a numeric field. Products with a negative price_group<br>
    will not be displayed on the default Signup page. You can link to<br>
    an alternate Signup page like this 'signup.php?price_group=-1'<br> to display 
    products ONLY from Price Group -1. You can enter<br>
    comma-separated ',' lists of pricegroups as well
    ");
add_product_field('renewal_group', 'Renewal Group',
    'text', "Value in this field defines how aMember will calculate<br>
    subscription start date when user renews his membership.<br>
    If user has subscription to a product WITH THE SAME renewal<br>
    group already, aMember will use expiration date of previous<br>
    subscription as start date for new subscription. If user hasn't<br>
    such subscriptions, aMember will use current date as start date.<br>
    Basically, products which grants the same level of access must<br>
    have the same Renewal Group value. Example of this value : \"BASIC\".<br>
    If this field has negative numeric value, it will always set subscription<br>
    start date to current date, allowing member to have several subscriptions<br>
    to the same product.
    ");
add_product_field('need_agreement', 'Display Agreement',
    'select', "Specify whether the user must agree to your Customer<br>
    Agreement before being allowed to proceed with payment.<br><br>

    Your Agreement must be located in the template:<br>
    <i>templates/agreement.html</i>"
    ,'',
    array('options' => array(
        '' => 'No',
        1  => 'Yes, display Agreement'
    )));
if (!is_lite()){
add_product_field('autoresponder', 'Send Automatic Emails',
    'textarea', "user can receive automatic emails after<br>
    signup. You can setup series of emails to be sent.<br>
    Format is :<br>
    <i>NUMBER_OF_DAYS - TEMPLATE_FILE_NAME</i>, like:<br>
    <i>1 - email1.txt<br>
       2 - email2.txt<br>
    </i>
    Email templates should be uploaded to amember/templates/ folder.<br>
    If number of days set to zero (0), email will be sent immediately<br>
    after purchase.
    ");
add_product_field('autoresponder_renew', 'Send Automatic Emails after Renewal',
    'select', "When user renews subscription, aMember can<br>
    resend days counter and start emails again from first one<br>
    or aMember can continue old mailing cycle.
    ", '', array('options' => array(
        ''  => 'Continue old mailing cycle',
        '1' => 'Reset days counter to zero, start new cycle'
    )));
}
unset($GLOBALS['COUPON_NOT_USED']);

?>
