<?php 
/*
*   Members page. Used to renew subscription.
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: Member display page
*    FileName $RCSfile: profile.php,v $
*    Release: 2.1.8PRO ($Revision: 1.1.2.4.4.9 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*                                                                                 
*/

include('./config.inc.php');
$t = & new_smarty();
$t->assign('config', $config);
$_product_id = array('ONLY_LOGIN');

include($config['plugins_dir']['protect'] . '/php_include/check.inc.php');

function check_new_username($login){
    global $config, $db;
    if (!preg_match($p="/^\\w\{{$config[login_min_length]}}\\w*\$/", $login)){
        return "Please enter correct login. It must contain at least $config[login_min_length] letters, digits or _";
    } else if (!$member_id=$db->check_uniq_login($login)){
        return "Username '$login' is already taken. Please choose another username.";
    }
}

function save_profile(&$vars, &$user){
    global $db, $config;
    global $_amember_id, $member_additional_fields;

    $fields_to_change = (array)$config['profile_fields'];

    $maf = array();
    foreach ($member_additional_fields as $f){
        $maf[$f['name']] = $f;
    }

    $error = array();
    foreach ($vars as $k=>$v){
        $field = $k;

        if (in_array($k, $fields_to_change))
            $field_type = 1;
        elseif ($maf[$k]['display_profile'])
            $field_type = 2;
        else {
            continue;
        }

        ///check username
        if (($k == 'login') && ($v != $_SESSION['_amember_login']) && $err=check_new_username($v)){
            $error[] = "Please enter correct username: $err";
            $user['login'] = $v;
            continue;
        }
        ////
        
        if (($k == 'email') && !check_email($v)){
            $error[] = "Please enter valid E-Mail address";
            $user['email'] = $v;
            continue;
        }
        if (($k == 'name_f') && !strlen($v)){
            $error[] = "Please enter First Name";
            $user['name_f'] = $v;
            continue;
        }
        if (($k == 'name_l') && !strlen($v)){
            $error[] = "Please enter Last Name";
            $user['name_l'] = $v;
            continue;
        }
        /// check password
        if ($k == 'pass0'){
            if (strlen($v) == 0) { //don't change at all
                continue;
            }
            if (strlen($v) < $config['pass_min_length']) {
                $error[] = "Password must have at least {$config[pass_min_length]} characters";
                continue;
            }
            if (strlen($v) > $config['pass_max_length']) {
                $error[] = "Password must have less than {$config[pass_max_length]} characters";
                continue;
            }
            if ($vars['pass0'] != $vars['pass1']){
                $error[] = "Password and confirmation is different. Please reenter";
                continue;
            }
            $field = 'pass';
        }
        /// set value
        if ($field_type == 1){
            $user[$field] = $v;
        } elseif ($field_type == 2) {
            $ff = $maf[$k];
            foreach ((array)$ff['validate_func'] as $func){
                if (!strlen($func)) continue;
                if ($err = $func($v, $ff['title'], $ff)){
                    $error[] = $err;
                }
            }
            if ($ff['sql'])
                $user[$k] = $v;
            else
                $user['data'][$k] = $v;
        } else {
            fatal_error("Unknown field type for '$k' : '$field_type'");
        }
    }
    if (!$error){
        $db->update_user($_amember_id, $user);
        global $HTTP_SESSION_VARS;
        if (in_array('login', $fields_to_change))
            $HTTP_SESSION_VARS['_amember_login'] = $user['login'];
        $HTTP_SESSION_VARS['_amember_pass'] = $user['pass'];
    }
    return $error;
}

function display_saved(){
    global $t, $db;
    global $_amember_id;
    $user = $db->get_user($_amember_id);
    $t->assign('user', $user);
    $t->display('profile_saved.html');
}

function display_form($user){
    global $t, $config;
    global $_amember_id, $error;
    $t->assign('user', $user);
    $t->assign('additional_fields_html', get_additional_fields_html($user, 'profile'));
    $fields_to_change = array();
    foreach ((array)$config['profile_fields'] as $f)
        $fields_to_change[$f]=1;
    $t->assign('fields_to_change', $fields_to_change);
    $t->assign('error', $error);
    $t->display('profile.html');
}

$vars = get_input_vars();
$_amember_id = $HTTP_SESSION_VARS['_amember_id'];
$user = $db->get_user($_amember_id);

if ($vars['do_save']){
    $error = save_profile($vars, $user);
    if ($error)
        display_form($user);
    else
        display_saved();
} else {
    display_form($user);
}


?>
