<?php 

/*
*  User's signup page
*
*
*     Author: Alex Scott
*      Email: alex@cgi-central.net
*        Web: http://www.cgi-central.net
*    Details: Signup Page
*    FileName $RCSfile: signup.php,v $
*    Release: 2.1.8PRO ($Revision: 1.14.2.3.4.38 $)
*
* Please direct bug reports,suggestions or feedback to the cgi-central forums.
* http://www.cgi-central.net/forum/
*                                                                          
* aMember PRO is a commercial software. Any distribution is strictly prohibited.
*                                                                                 
*/
include('./config.inc.php');


$signup_scope_allowed = array('', 'signup');

###############################################################################
# CHECK_PAYMENT_FORM
#
# set $GLOBAL[error] if needed
# return 1/0 (valid/not-valid)
#
function check_payment_form(){
    global $error;
    global $vars;
    global $db;
    global $config;

    //
    if (is_array($vars['product_id'])) {
        if (count($vars['product_id'])<=0) 
            $error[] = 'Please select a membership type';
    } else {
        if (!intval($vars['product_id'])) 
            $error[] = 'Please select a membership type';
    }

    if (!strlen($vars['paysys_id'])){   
        $error[] = 'Please select a payment system';
    }
    if (!strlen($vars['name_f'])){
        $error[] = 'Please enter your First Name';
    }
    if (!strlen($vars['name_l'])){
        $error[] = 'Please enter your Last Name';
    }
    if (preg_match('/[^0-9a-zA-Z_ ]+/', $vars['login'])){
        $error[] = "Username contains invalid characters - please use digits, letters or spaces";
    } elseif (strlen($vars['login']) < $config['login_min_length']){
        $error[] = "Please enter correct login. It must contain at least $config[login_min_length] characters";
    } elseif (!$member_id=$db->check_uniq_login($vars['login'], $vars['email'], 
        $vars['pass0'], 1)){
        $error[] = "Username '$vars[login]' is already taken. Please choose another username.";
    }
    if (!check_email($vars['email'])){
        $error[] = 'Please enter valid Email';
    } elseif (($config['unique_email'] && $member_id <= 0) && 
        $db->users_find_by_string($vars['email'], 'email', 1)){
        $error[] = 'An account with the same email already exists.<br>Please <a href="member.php">login</a> to your existing account.<br>If you have not completed payment, you will be able to complete it after login<br>';
    }
    if (!strlen($vars['pass0'])){
        $error[] = 'Please enter Password';
    } elseif (strlen($vars['pass0']) < $config['pass_min_length']){
        $ll = $config[pass_min_length];
        $error[] = "Password must contain at least $ll letters or digits";
    }
    if ($vars['pass0'] != $vars['pass1']){
        $error[] = 'Password and Password Confirmation are different. Please reenter both';
    }
    $error = array_merge($error, plugin_validate_signup_form($vars));
    return !count($error);
}

###############################################################################
# SHOW_PAYMENT_FORM
#
# get vars from database and plugins
# display $GLOBAL[error] if it set
# substitute previous entered parameters using Smarty
#
function show_payment_form(){
    global $t;
    global $error;
    global $db, $config, $vars;
    global $signup_scope_allowed;

    $t->assign('error', $error);

    $products = $db->get_products_list();
    if (!count($products)){
        fatal_error("Script configuration error - you have to add at least one Product (Membership type) from aMember Control Panel");
    }
    
    foreach ($products as $k=>$v){
        if (!in_array($v['scope'], $signup_scope_allowed))
            unset($products[$k]);
        if ($vars['price_group']){
            if (!in_array($vars['price_group'], split(',',$v['price_group'])) )
                unset($products[$k]);
        } elseif ($v['price_group'] < 0){
            unset($products[$k]);
        }
    }

    $paysystems = get_paysystems_list();
    //remove paysystems such as manual
    foreach ($paysystems as $k=>$p) 
        if (!$p['public']) unset($paysystems[$k]); 
    //remove free paysystem from select
    if (count($paysystems) > 1)
        foreach ($paysystems as $k=>$p)
            if ($p['paysys_id'] == 'free') unset($paysystems[$k]); 

    global $HTTP_POST_VARS;
    plugin_fill_in_signup_form($HTTP_POST_VARS);
            
    $t->assign('products', $products);
    $t->assign('paysystems', $paysystems);
    $t->assign('additional_fields_html', get_additional_fields_html($vars, 'signup'));
    if ($config['select_multiple_products'])     
        $t->display('signup_multi.html');
    else
        $t->display('signup.html');
}


function proceed_to_payment($payment_id, $member_id_exists){
    global $config, $db;
    $payment = $db->get_payment($payment_id);
    if (!$payment['payment_id']) 
        fatal_error("Payment #$payment_id not found", 1);
    if ($payment['completed'])
        fatal_error("Payment #$payment_id is already completed,
        please login to your account <a href='member.php'>here</a>", 1);
    extract($payment, EXTR_OVERWRITE);
    if ($pr = $payment['data'][0]['BASKET_PRODUCTS'])
        $product_id = $pr;
    global $error;
    $error = plugin_do_payment($paysys_id, $payment_id, $member_id, 
         is_array($product_id) ? $product_id[0] : $product_id,
         $amount, $begin_date, $expire_date, $vars);
    if ($error) {
        $db->delete_payment($payment_id);
        if (!$member_id_exists)
            $db->delete_user($member_id);
        show_payment_form();
    }
}

###############################################################################
##
##                             M  A  I  N 
##
###############################################################################
unset($GLOBALS['_trial_days']); // trial handling
$t = & new_smarty();
$error = '';


$vars = & get_input_vars();

$error = array();

if ($vars['continue_signup']){
    $u = $db->get_user($vars['member_id']);
    if (!$u['member_id'])
        fatal_error("Incorrect link - make sure you copy link from your email client correctly", 1);
    $md5 = md5($u['login'].$u['pass'].$vars['member_id'].$vars['payment_id']);
    if ($md5 != $vars['md5'])        
        fatal_error("Incorrect link - make sure you copy link from your email client correctly", 1);
    proceed_to_payment($vars['payment_id'], $vars['member_id_exists']);
    exit();    
}

if ($vars['do_agreement']){
    if (!$vars['i_agree']){
        $error[] = "You must agree with User Agreement to continue";
        display_agreement($vars['data']);
        exit();
    }
    $vars = unserialize($vars['data']);
    $vars['i_agree']++;
    foreach ($vars as $k=>$v)
        $t->_smarty_vars['request'][$k] = $v;
}

///// 
if ($vars['do_payment']){
    $vars['aff_id'] = $HTTP_COOKIE_VARS['amember_aff_id'];
    $vars['login'] = strtolower($vars['login']);
    if ($config['generate_login'])
        $vars['login'] = generate_login($vars);
    if ($config['generate_pass'])
        $vars['pass'] = $vars['pass0'] = $vars['pass1'] = generate_password($vars);
    if ($vars['product_id']){
        $price      = calculate_price($vars['product_id'], 0, $vars, $prices);
        if (($price == 0) && !$GLOBALS['_trial_days'] && 
                in_array('free', $plugins['payment'])) 
            $vars['paysys_id'] = 'free';
        if ($config['product_paysystem']){
            $pr = get_product(is_array($vars['product_id'])?$vars['product_id'][0]:$vars['product_id']);
            $vars['paysys_id'] = $pr->config['paysys_id'];
        }
    }
}

if (($vars['do_payment'] && check_payment_form())){

    //check for agreement
    $display_agreement = 0;
    foreach ((array)$vars['product_id'] as $pid){   
        $product = $db->get_product($pid);
        if ($product['need_agreement'])
            $display_agreement++;
    }
    if ($display_agreement && !$vars['i_agree']){
        display_agreement(serialize($vars)); // defined in the product.inc.php
        exit();
    }

    // do payment !
    $product_id = $vars['product_id'];
    $login      = $vars['login'];
    $paysys_id  = $vars['paysys_id'];

    do { // to easy exit using break()
        foreach ((array)$vars['product_id'] as $pid){
            $product = $db->get_product($pid);
            if (!in_array($product['scope'], $signup_scope_allowed)){
                $error = "Product ID incorrect for signup page";
                break;
            }
            ////////////// check products scope
        }
        if ($error = check_product_requirements((array)$vars['product_id']))
            break;
        $member_id = $db->check_uniq_login($vars['login'], $vars['email'], $vars['pass0'], 1);
        $member_id_exists = 0;
        if ($member_id < 0)
            $member_id = $db->add_pending_user($vars);
        elseif (!$member_id)
            die("Login exists. Internal error");
        else {
            $member_id_exists++; //we found existing user with the same params
            // then will clean CC parameters if any
            $member = $db->get_user($member_id);
            $member['data']['cc-hidden']='';
            $member['data']['cc-expire']='';
            $member['data']['cc']='';
            $member['data']['cc_street']='';
            $member['data']['cc_city']='';
            $member['data']['cc_state']='';
            $member['data']['cc_zip']='';
            $member['data']['cc_country']='';
            foreach ($vars as $k=>$v) $member[$k] = $v;
            $db->update_user($member_id, $member);
        }
        if ($error) {
            break;
        }

        $price      = calculate_price($product_id, $member_id, $vars, $prices);
        if ($GLOBALS['COUPON_CODE'])
            $vars['COUPON_CODE'] = $GLOBALS['COUPON_CODE'];
        $begin_date = date('Y-m-d');
        $additional_values = array();
        foreach ($payment_additional_fields as $f){
            $fname = $f['name'];
            if (isset($vars[$fname])) 
                $additional_values[$fname] = $vars[$fname];
        }
        if (is_array($product_id)) {
            $product = & get_product($product_id[0]);
            $expire_date   = $product->get_expire($begin_date); //yyyy-mm-dd
            $payment_id = $db->add_waiting_payments($member_id, $product_id, 
                $paysys_id, $price, $prices, $begin_date, $expire_date, $vars,
                $additional_values);
        } else {
            $product = & get_product($product_id);
            $expire_date   = $product->get_expire($begin_date); //yyyy-mm-dd
            $payment_id = $db->add_waiting_payment($member_id, $product_id, 
                $paysys_id, $price, $begin_date, $expire_date, $vars,
                $additional_values);
        }

        if ($error) {
            $db->delete_user($member_id);
            break;
        }

        if ($config['verify_email']){
            global $db;
            $u = $db->get_user($member_id);
            $md5 = md5($u['login'].$u['pass'].$member_id.$payment_id);
            mail_verification_email($u, $config['root_url']."/signup.php?continue_signup=1&member_id=$member_id&member_id_exists=$member_id_exists&payment_id=$payment_id&md5=$md5");
            $t->assign('user', $u);
            $t->display("email_verify.html");
            exit();
        }

        proceed_to_payment($payment_id, $member_id_exists);
                          
        exit();
    } while (0);
} 

show_payment_form();
?>
